<?php


class eng_ishop_page_all_product extends eng_gen_ishop_page
{
  /**
   * @var $obj_modul ishop_class
   */
  protected $obj_modul;
  
  protected $data_all_product = array();
  
  protected $add_param_url = array();
  protected $data_light_search = [];
  protected $kolvo_vsego_all_product = 0;
  protected $open_num_page_all_product = 0;
  
  protected $name_sort = "";
  protected $type_sort = "";
  
  protected $base_url_page = "";
  protected $data_block_navigation = [];
  
  function first_init()
    {
      $this->mas_name_copy=["name_sort","type_sort","base_url_page"];
      
      $this->data_block_navigation = &$this->obj_modul->data_block_navigation;
      $this->add_param_url = &$this->obj_modul->add_param_url;
      $this->data_light_search = &$this->obj_modul->data_light_search;
      
      return (true);
    }
  
  function control_data()
    {
      
      global $masConfig;
      
      $this->data_all_product = array();
      
      $this->add_param_url = array();
      
      $db_query_stext = "";
      //$db_query_type_product = "";
      $db_query_cost = "";
      $db_query_available = "";
      //$db_query_exists_images = "";
      
      $this->data_light_search["currency"] = $this->mas_inbox["currency"];
      /*
      if ( $this->mas_inbox['geo'] )
        {
         list($error,$mas_geo)=$this->check_geo_param_url($this->mas_inbox["geo"]);
         if ( $error )
           return (false);
        }
      */
      $this->obj_modul->check_is_add_param_url_open_page(array("m", "k", "num_page"));
      
      //$this->data_block_navigation["url_part_geo"]=$this->forming_geo_in_url_category(false);
      
      if ($this->mas_inbox["s_text"])
        {
          $this->add_param_url["s_text"] = $this->mas_inbox["s_text"];
          
          $this->data_light_search["s_text"] = $this->mas_inbox["s_text"];
          
          list($mas_words, $is_min_length) = process_text_search($this->mas_inbox["s_text"], 3, 30);
          //$s_text = codeText($this->mas_inbox["s_text"]);
          
          if (sizeof($mas_words))
            {
              $db_query_stext .= " and ( ";
              $sep = "";
              foreach ($mas_words as $one_word)
                {
                  $db_query_stext .= $sep." ( "
                    ." product.short_text LIKE '%".$one_word."%' "
                    ." or product.all_text LIKE '%".$one_word."%' "
                    ." or product.name_product LIKE '%".$one_word."%' "
                    ." or product.key_words LIKE '%".$one_word."%' "
                    ." ) ";
                  $sep = " and ";//" or "
                }
              $db_query_stext .= " ) ";
            }
          
        }
      
      
      $p_cost = " cost ";
      
      global $init_base_currency, $init_use_currency, $init_course_currency, $init_currency;
      /*
      if ( sizeof( $init_use_currency ) > 1 )
        {
         $p_cost = " ( ";
         $p_cost .= "(( currency = '".$this->mas_inbox["currency"]."' ) * cost )";
         
         foreach ( $init_use_currency as $one_currency )
           {
            if ( $one_currency == $this->mas_inbox["currency"] ) continue;
            $p_cost .= " + ((currency = '".$one_currency."') * cost * "
             .$init_course_currency[ $this->mas_inbox["currency"] ]." / ".$init_course_currency[$one_currency].") ";
           }
         
         $p_cost .= ")";
        }
      */
      if ($this->mas_inbox["min_cost"])
        {
          $this->data_light_search["min_cost"] = floatval($this->mas_inbox["min_cost"]);
          $db_query_cost .= " and ( ".$p_cost." >= ".$this->data_light_search["min_cost"]." ) ";
          
          $this->add_param_url["s_min_cost"] = $this->data_light_search["min_cost"];
          $this->add_param_url["s_currency"] = $this->data_light_search["currency"];
        }
      
      if ($this->mas_inbox["max_cost"])
        {
          $this->data_light_search["max_cost"] = floatval($this->mas_inbox["max_cost"]);
          $db_query_cost .= " and ( ".$p_cost." <= ".$this->data_light_search["max_cost"]." ) ";
          
          $this->add_param_url["s_max_cost"] = $this->data_light_search["max_cost"];
          $this->add_param_url["s_currency"] = $this->data_light_search["currency"];
        }
      /*
      $this->data_light_search["exists_images"] = "off";
      if ( $this->status_inbox["exists_images"] == "set" )
        {
         $this->data_light_search["exists_images"] = "on";
         $db_query_exists_images = " and product.image != '' ";
         $this->add_param_url["s_exists_images"] = "on";
        }
      */
      
      $this->data_light_search["available"] = "";
      $db_query_available = " and (product.quantity_stock > 0 || product.on_request = 'on' ) ";//по умолчанию ищем товары в наличии и под заказ
      if ($this->status_inbox["available"] == "set" && $this->mas_inbox["available"] != "")
        {
          //write_log_cms($this->mas_inbox["available"],"all product available");
          $this->data_light_search["available"] = $this->mas_inbox["available"];
          $this->add_param_url["available"] = $this->mas_inbox["available"];
          
          if ($this->mas_inbox["available"] == "stock")
            {
              //ищем товары только в наличии
              $db_query_available = " and product.quantity_stock > 0 and product.on_request = 'off' ";
            }
          elseif ($this->mas_inbox["available"] == "all")
            {
              //Все товары
              $db_query_available = "";
            }
          
        }
      
      $t_db_query_category = $this->obj_modul->get_text_db_query_part_category("product.n_category", 0);
      
      $db_query = "select count(*) "
        ." from ".DB_PREF."ishop_product product "
        ." where "
        //." product.n_category IN (".$this->list_id_inferiorcategory(false,true).") "
        .($t_db_query_category ? " ( ".$t_db_query_category." ) and " : "")
        ." product.hide='show' "
        //." and product.end_putdate > ".$GLOBALS["timeDayProduct"]."   "
        .$db_query_stext.$db_query_cost.$db_query_available
        
        .$this->obj_modul->add_db_query_country().$this->obj_modul->add_db_query_region().$this->obj_modul->add_db_query_city();
      
      $this->kolvo_vsego_all_product = db_work::query_count($db_query);
      
      if ($this->status_inbox["num_page"] == "set")
        {
          $this->open_num_page_all_product = $this->mas_inbox["num_page"];
          $this->openOnGetNumPage = true;
        }
      else
        {
          $this->open_num_page_all_product = 1;
        }
      
      $this->openNumPage = $this->open_num_page_all_product;
      
      if ($this->status_inbox["sort"] == "set")
        {
          $this->name_sort = $this->mas_inbox["sort"];
          $this->type_sort = $this->mas_inbox["tsort"];
          
        }
      
      if ($this->kolvo_vsego_all_product == 0)
        {
          if ($this->open_num_page_all_product != 1)
            {
              return (false);
            }
        }
      else
        {
          
          global $init_sort_ishop;
          
          $db_query = "select product.id_product, "
            ." product.name_product, product.short_text, product.image, product.start_date,
            product.cost,
            product.status_product , product.n_category, product.currency,
            product.name_url, product.quantity_stock, product.discount_cost, product.first_cost,
            product.on_request 
            from ".DB_PREF."ishop_product product  "
            ." where "
            //." product.n_category IN (".$this->list_id_inferiorcategory(false,true).") "
            .($t_db_query_category ? " ( ".$t_db_query_category." ) and " : "")
            ." product.hide='show' "
            //." and product.end_putdate > ".$GLOBALS["timeDayProduct"]."   "
            .$db_query_stext.$db_query_cost.$db_query_available
            
            //.$this->add_db_query_country().$this->add_db_query_region().$this->add_db_query_city()
            ." order by "
            .($this->name_sort ? " ".$init_sort_ishop[$this->name_sort]." ".$this->type_sort." " : " sort_time DESC ")
            ." limit ".($this->open_num_page_all_product - 1) * KOLVO_VIEW_SYNOPSIS_PRODUCT." , ".KOLVO_VIEW_SYNOPSIS_PRODUCT;
          list($kolvo, $this->data_all_product) = obr_db_query_select_assoc($db_query);
          
          if ($kolvo == 0) return (false);
          /*
          if ( $masConfig["ON_USE_GEO_DATA"] == 1 )
            {
             global $obj_geoData;
             $obj_geoData->add_data_mas_for_extract_geo($this->data_all_product,array("country_product","region_product","city_product"));
            }
          */
        }
      
      $this->base_url_page = $this->dir_http."/allproduct/";
      
      //$korekParam = true;
      
      $this->openNsrlKeyComponent = "3";
      //$this->openNsrlComponentIdent = ( sizeof( $mas_list_num ) ) ? $mas_list_num : 0;
      
      return (true);
    }
  
  function forming_data()
    {
      
      global $mas_value_template, $tpl, $masConfig;
      $mas_perem = $mas_value_template;
      $mas_perem["masConfig"] = $masConfig;
      
      $t_geo = "";
      $url_geo = "";
      /*
      if ( $masConfig["ON_USE_GEO_DATA"] == 1 )
        {
         global $obj_geoData;
         $t_geo = $obj_geoData->get_text_name_view_geo_data();
         $url_geo = $obj_geoData->forming_geo_in_url_main_setting();
        }
      */
      $t_num_page = ($this->open_num_page_all_product > 1 ? " - Страница ".$this->open_num_page_all_product : "");
      
      $this->title = "Все товары".($t_geo ? " - ".$t_geo." " : "").$t_num_page;
      $this->title_text = "Все товары".$t_num_page;
      
      $this->mas_navigation_pointer[] = array("Все товары");
      
      $mas_perem["url_geo"] = $url_geo;
      $mas_perem["kolvo_vsego_all_product"] = $this->kolvo_vsego_all_product;
      
      $mas_perem["data_row"] = $this->data_all_product;
      $mas_perem["kolvo_vsego_all_product"] = $this->kolvo_vsego_all_product;
      $mas_perem["open_num_page_all_product"] = $this->open_num_page_all_product;
      
      
      global $init_currency;
      $mas_perem["init_currency"] = $init_currency;
      $mas_perem["name_base_currency"] = $this->obj_modul->name_base_currency;
      
      $mas_perem["dir_http_template_modul"] = $this->obj_modul->dir_http_template_modul;
      
      $mas_perem["search_add_link_page_dynamic"] = $this->obj_modul->search_add_link_page_dynamic;//***
      $mas_perem["data_open_category"] = $this->data_block_navigation["data_open_lvl_category"];//***
      
      $mas_perem["obj_ishop"] = &$this->obj_modul;
      
      $this->text = "";
      
      $tpl->template_dir = $this->obj_modul->dir_template_mfile."/";
      
      $tpl->assign($mas_perem);
      $t_bk_oper = $tpl->fetch("forming_block_oper.html");
      
      $mas_perem["t_bk_oper"] = $t_bk_oper;
      
      //$t_bk_search = $this->forming_block_search();
      //$mas_perem["t_bk_search"]=$t_bk_search;
      
      $tpl->template_dir = $this->obj_modul->dir_template_mfile."/page/";
      
      $tpl->assign($mas_perem);
      $this->text = $tpl->fetch("all_product.html");
      
      
      return (true);
    }
  
}

