<?php


class eng_ishop_page_category extends eng_gen_ishop_page
{
  /**
   * @var $obj_modul ishop_class
   */
  protected $obj_modul;
  
  protected $type_element = "";
  
  protected $data_synopsis_product = array();
  //protected $data_select_cat_podcat = array();
  
  protected $add_param_url = array();
  protected $data_block_navigation = array();
  protected $data_light_search = array();
  
  protected $data_category_url = array();
  
  protected $set_num_page_category = false;
  
  protected $open_num_category = 0;
  protected $open_num_podcategory = 0;
  protected $num_open_lvl_category = 0;
  protected $data_open_category = [];
  protected $data_open_podcategory = [];
  
  protected $mas_series_num_category = array();
  
  protected $search_mas_num_lvl_category = array();
  
  protected $search_navigation_exists_images_product = false;
  
  protected $type_product = "";
  protected $open_num_page = 0;
  protected $kolvo_product_vsego_to_category = 0;
  protected $name_sort = "";
  protected $type_sort = "";
  protected $base_url_page = "";
  
  protected $advanced_search = false;
  protected $num_element_init_dynamic_data = 0;
  
  
  function first_init()
    {
      $this->mas_name_copy=["open_num_category","open_num_podcategory","num_open_lvl_category",
       "data_open_category","data_open_podcategory","search_mas_num_lvl_category",
       "advanced_search",
       "set_num_page_category","mas_series_num_category",
       "name_sort","type_sort","base_url_page"];
      
      $this->data_block_navigation = &$this->obj_modul->data_block_navigation;
      $this->add_param_url = &$this->obj_modul->add_param_url;
      $this->data_light_search = &$this->obj_modul->data_light_search;
      
      $this->num_element_init_dynamic_data = &$this->obj_modul->num_element_init_dynamic_data;
      $this->search_mas_num_lvl_category = &$this->obj_modul->search_mas_num_lvl_category;
      
      return (true);
    }
  
  function control_data()
    {
    
      global $masConfig;
    
      $num_element = $this->mas_inbox["category"];
      
      
      $this->type_element = "";
      
      $this->data_synopsis_product = array();
      //$this->data_select_cat_podcat = array();
      
      $this->add_param_url = array();
      
      $this->data_category_url = array();
      
      $this->set_num_page_category = false;
      
      $this->open_num_category = 0;
      $this->open_num_podcategory = 0;
      
      $this->mas_series_num_category = array();
      
      $this->search_mas_num_lvl_category = array();
      
      $this->search_navigation_exists_images_product = false;
      
      $this->type_product = "";
      
      $mas_serias_lvl_num_category = array();
      $mas_list_num = array();
      
      $this->obj_modul->check_is_add_param_url_open_page(array("m", "k", "smgeo", "num_page", "category_url"));
      
      if ($this->status_inbox["category"] == "set")
        {
          
          if ($this->obj_modul->obj_cache_category->check_num_data_1lvl($num_element))
            {
              $this->type_element = "high";
              $this->open_num_category = $num_element;
              $this->data_open_category = $this->obj_modul->obj_cache_category->get_one_num_data($num_element);
              
              header("Location: ".$this->dir_http."/allproduct/".$this->obj_modul->forming_name_url_category($num_element, "high")."/", true, 301);
              exit ();
              
            }
          elseif ($this->obj_cache_category->check_num_data_many_lvl($num_element))
            {
              //if ( empty( $this->mas_category[$this->mas_podcategory[$num_element]["n_category"]] ) ) return (false);
              $mas_serias_lvl_num_category = $this->obj_modul->serias_lvl_num_category($num_element);
              if (!$mas_serias_lvl_num_category) return (false);
              $this->type_element = "inferior";
              $this->open_num_category = $mas_serias_lvl_num_category[0];//$this->mas_podcategory[$num_element]["n_category"];
              $this->open_num_podcategory = $num_element;
              $this->data_open_podcategory = $this->obj_modul->obj_cache_category->get_one_num_data($num_element);
              
              header("Location: ".$this->dir_http."/allproduct/".$this->obj_modul->forming_name_url_category($num_element, "inferior")."/", true, 301);
              exit ();
              
            }
          else
            {
              
              return (false);
            }
        }
      elseif ($this->status_inbox["category_url"] == "set")
        {
          $category_url = $this->mas_inbox["category_url"];
          if (!trim($category_url)) return (false);
          
          if (mb_substr($category_url, mb_strlen($category_url) - 1, 1) == "/")
            {
              $category_url = mb_substr($category_url, 0, mb_strlen($category_url) - 1);
            }
          
          if (!trim($category_url)) return (false);
          $this->data_category_url = explode("/", $category_url);
          
          
          //list($on_category,$key_category) = search_mas_2level($this->mas_category,"united_name_url",$this->data_category_url[0],false);
          $mas_serias_lvl_num_category = $this->obj_modul->obj_cache_category->check_mas_name_url_data($this->data_category_url);
          
          //if ( !$on_category ) return (false);
          if (!$mas_serias_lvl_num_category) return (false);
          
          //if ( sizeof($this->data_category_url) == 2 )
          $kolvo_lvl = sizeof($mas_serias_lvl_num_category);
          if ($kolvo_lvl > 1)
            {
              
              //if ( !trim($this->data_category_url[1]) ) return (false);
              
              //list($on_podcategory,$key_podcategory) = search_mas_2level($this->mas_podcategory,"united_name_url",$this->data_category_url[1],false);
              //list($on_podcategory,$key_podcategory) = search_mas_2level($this->mas_num_podcategory[$key_category],"united_name_url",$this->data_category_url[1],false);
              
              //if ( !$on_podcategory ) return (false);
              
              $this->type_element = "inferior";
              $this->open_num_category = $mas_serias_lvl_num_category[0];//$this->mas_podcategory[$key_podcategory]["n_category"];
              $this->open_num_podcategory = $mas_serias_lvl_num_category[$kolvo_lvl - 1];//$key_podcategory;
              $this->data_open_podcategory = $this->obj_modul->obj_cache_category->get_one_num_data($this->open_num_podcategory);//$this->mas_podcategory[$key_podcategory];
              $mas_list_num = $mas_serias_lvl_num_category;
            }
          elseif ($kolvo_lvl == 1)
            {
              $this->type_element = "high";
              $this->open_num_category = $mas_serias_lvl_num_category[0];
              $this->data_open_category = $this->obj_modul->obj_cache_category->get_one_num_data($this->open_num_category);
              $mas_list_num[] = $this->open_num_category;
            }
          else
            {
              return (false);
            }
          
        }
      else
        {
          return (false);
        }
      
      /*
      if ( $this->mas_inbox['geo'] )
        {
         list($error,$mas_geo)=$this->check_geo_param_url($this->mas_inbox["geo"]);
         if ( $error )
           return (false);
        }
      */
      $this->mas_series_num_category = $mas_serias_lvl_num_category;
      
      $this->search_mas_num_lvl_category = $mas_serias_lvl_num_category;
      
      $this->num_open_lvl_category = $this->open_num_podcategory > 0 ? $this->open_num_podcategory : $this->open_num_category;
      $this->openComponentIdent = $this->num_open_lvl_category;
      
      $this->data_block_navigation["num_lvl_category"] = $this->num_open_lvl_category;
      if ($this->open_num_podcategory > 0)
        {
          $this->data_block_navigation["data_open_lvl_category"] = $this->data_open_podcategory;
        }
      else
        {
          $this->data_block_navigation["data_open_lvl_category"] = $this->data_open_category;
        }
      
      
      $this->data_block_navigation["data_lvl_podcategory"] = $this->obj_modul->get_mas_nested_category($this->num_open_lvl_category);
      $this->data_block_navigation["series_num_lvl_category"] = $mas_serias_lvl_num_category;
      
      
      //$this->data_block_navigation["url_part_geo"]=$this->forming_geo_in_url_category(false);
      
      $url_part_category = "";
      if ($this->open_num_category > 0)
        {
          if ($this->open_num_podcategory > 0)
            {
              $url_part_category = "/".$this->obj_modul->forming_name_url_category($this->open_num_podcategory, 'inferior');
            }
          else
            {
              $url_part_category = "/".$this->obj_modul->forming_name_url_category($this->open_num_category, 'high');
            }
        }
      $this->data_block_navigation["url_part_category"] = $url_part_category;
      /* ( $obj_ishop->open_num_podcategory > 0 ) ? $obj_ishop->forming_all_name_url_category($obj_ishop->open_num_podcategory,'inferior') : 
      ( $obj_ishop->open_num_category > 0 ? $obj_ishop->forming_all_name_url_category($obj_ishop->open_num_category, 'high' ): "" ) */
      
      
      if ($masConfig["ON_VIEW_QUANTITY_PRODUCT_CATEGORY"])
        {
          $mas_series_num_category = $this->obj_modul->serias_lvl_num_category($this->num_open_lvl_category);
          $mas_num_nested_category = $this->obj_modul->obj_cache_category->get_mas_num_nested_data($this->num_open_lvl_category, false);
          $mas_num_category_quantity = array_merge($mas_series_num_category, $mas_num_nested_category);
          $mas_num_category_quantity = array_unique($mas_num_category_quantity);
          
          $this->data_block_navigation["quantity_product_category"] = $this->obj_modul->obj_cache_db->get_quantity_product_mas_num_category($mas_num_category_quantity, $this->obj_modul->user_view_country, $this->obj_modul->user_view_region, $this->obj_modul->user_view_city);
        }
      
      if ($this->mas_inbox["all_dparam"] == "on")
        {
          $this->obj_modul->add_param_to_link_page_search_dynam("all_dparam", "on");
          $this->advanced_search = true;
        }
      
      $this->num_element_init_dynamic_data = $this->num_open_lvl_category;// ($this->open_num_podcategory > 0 ? $this->open_num_podcategory : $this->open_num_category);
      $this->obj_modul->opred_param_dynamic_part_search();
      
      if ($this->status_inbox["num_page"] == "set")
        {
          $this->open_num_page = $this->mas_inbox["num_page"];
          $this->set_num_page_category = true;
          $this->openOnGetNumPage = true;
        }
      else
        {
          $this->open_num_page = 1;
        }
      
      $this->openNumPage = $this->open_num_page;
      
      $list_num_category_query = "";
      $one_num_category_query = "";
      
      $t_db_query_category = $this->obj_modul->get_text_db_query_part_category("product.n_category", $this->num_open_lvl_category);
      
      /*
      if ( $this->open_num_podcategory  )
        {
         //$one_num_category_query = $this->list_id_inferiorcategory( $this->open_num_podcategory );
         $list_num_category_query = $this->list_id_inferiorcategory($this->open_num_podcategory,true);
        }
       else
         {
          $list_num_category_query = $this->list_id_inferiorcategory($this->open_num_category,true);
          
         }
      */
      
      $db_query_stext = "";
      //$db_query_type_product = "";
      $db_query_cost = "";
      $db_query_available = "";
      //$db_query_exists_images = "";
      
      $this->data_light_search["currency"] = $this->mas_inbox["currency"];
      
      if ($this->mas_inbox["s_text"])
        {
          $this->add_param_url["s_text"] = $this->mas_inbox["s_text"];
          
          $this->data_light_search["s_text"] = $this->mas_inbox["s_text"];
          
          list($mas_words, $is_min_length) = process_text_search($this->mas_inbox["s_text"], 3, 30);
          //$s_text = codeText($this->mas_inbox["s_text"]);
          //var_dump($mas_words,$is_min_length);
          if (sizeof($mas_words))
            {
              $db_query_stext .= " and ( ";
              $sep = "";
              foreach ($mas_words as $one_word)
                {
                  $db_query_stext .= $sep." ( "
                    ." product.short_text LIKE '%".$one_word."%' "
                    ." or product.all_text LIKE '%".$one_word."%' "
                    ." or product.name_product LIKE '%".$one_word."%' "
                    ." or product.key_words LIKE '%".$one_word."%' "
                    ." ) ";
                  $sep = " and ";//" or "
                }
              $db_query_stext .= " ) ";
            }
          
        }
      
      $p_cost = " cost ";
      
      global $init_base_currency, $init_use_currency, $init_course_currency, $init_currency;
      /*
      if ( sizeof( $init_use_currency ) > 1 )
          {
           $p_cost = " ( ";
           $p_cost .= "(( currency = '".$this->mas_inbox["currency"]."' ) * cost )";
           
           foreach ( $init_use_currency as $one_currency )
             {
              if ( $one_currency == $this->mas_inbox["currency"] ) continue;
              $p_cost .= " + ((currency = '".$one_currency."') * cost * "
               .$init_course_currency[ $this->mas_inbox["currency"] ]." / ".$init_course_currency[$one_currency].") ";
             }
           
           $p_cost .= ")";
          }
      */
      if ($this->mas_inbox["min_cost"])
        {
          $this->data_light_search["min_cost"] = floatval($this->mas_inbox["min_cost"]);
          $db_query_cost .= " and ( ".$p_cost." >= ".$this->data_light_search["min_cost"]." ) ";
          
          $this->add_param_url["s_min_cost"] = $this->data_light_search["min_cost"];
          $this->add_param_url["s_currency"] = $this->data_light_search["currency"];
        }
      
      if ($this->mas_inbox["max_cost"])
        {
          $this->data_light_search["max_cost"] = floatval($this->mas_inbox["max_cost"]);
          $db_query_cost .= " and ( ".$p_cost." <= ".$this->data_light_search["max_cost"]." ) ";
          
          $this->add_param_url["s_max_cost"] = $this->data_light_search["max_cost"];
          $this->add_param_url["s_currency"] = $this->data_light_search["currency"];
        }
      /*
      $this->data_light_search["exists_images"] = "off";
      if ( $this->status_inbox["exists_images"] == "set" )
        {
         $this->data_light_search["exists_images"] = "on";
         $db_query_exists_images = " and product.image != '' ";
         $this->add_param_url["s_exists_images"] = "on";
        }
      */
      
      $this->data_light_search["available"] = "";
      $db_query_available = " and (product.quantity_stock > 0 || product.on_request = 'on' ) ";//по умолчанию ищем товары в наличии и под заказ
      if ($this->status_inbox["available"] == "set" && $this->mas_inbox["available"] != "")
        {
          //write_log_cms($this->mas_inbox["available"],"all product available");
          $this->data_light_search["available"] = $this->mas_inbox["available"];
          $this->add_param_url["available"] = $this->mas_inbox["available"];
          
          if ($this->mas_inbox["available"] == "stock")
            {
              //ищем товары только в наличии
              $db_query_available = " and product.quantity_stock > 0 and product.on_request = 'off' ";
            }
          elseif ($this->mas_inbox["available"] == "all")
            {
              //Все товары
              $db_query_available = "";
            }
          
        }
      
      $q_where_dynamic = " ";
      
      /*
        if ( $this->podcategory_search > 0 && $this->search_part_query_db_dynamic_data )
          {
           $q_where_dynamic.=" and product.id_product = ALL ( select n_product from "
              .DB_PREF."ishop_data 
              where n_category = ".$this->podcategory_search." ".$this->search_part_query_db_dynamic_data." ) ";
           
          }
      */
      
      if (sizeof($this->obj_modul->mas_query_data_dynamic_search) > 0)
        {
          $sep = "";
          $q_where_dynamic .= " and product.id_product IN (select n_product from (select n_product, count(*) as n_count from ".DB_PREF."ishop_data where ";
          
          foreach ($this->obj_modul->mas_query_data_dynamic_search as $one_query)
            {
              $q_where_dynamic .= $sep.$one_query;
              $sep = " or ";
              
            }
          $q_where_dynamic .= " group by n_product) search_dynamic where n_count=".sizeof($this->obj_modul->mas_query_data_dynamic_search).") ";
          
        }
      
      
      $db_query = "select count(*) "
        ." from ".DB_PREF."ishop_product product "
        ." where "
        //." n_category " . ( $list_num_category_query !== "" ? ( " IN (".$list_num_category_query.") " ) : " = " . $one_num_category_query )
        .($t_db_query_category ? " ( ".$t_db_query_category." ) and " : "")
        ." hide='show' "//." and end_putdate>".$GLOBALS["timeDayProduct"]." "
        .$db_query_stext.$db_query_cost.$db_query_available
        
        //.$this->add_db_query_country().$this->add_db_query_region().$this->add_db_query_city()
        .$q_where_dynamic;
      
      $vsego_kolvo = obr_db_query_count($db_query);
      
      
      $this->kolvo_product_vsego_to_category = $vsego_kolvo;
      
      if ($this->status_inbox["sort"] == "set")
        {
          $this->name_sort = $this->mas_inbox["sort"];
          $this->type_sort = $this->mas_inbox["tsort"];
          
        }
      
      if ($vsego_kolvo == 0)
        {
          if ($this->open_num_page != 1)
            {
              return (false);
            }
        }
      else
        {
          
          global $init_sort_ishop;
          
          $db_query = "select * "
            ." from ".DB_PREF."ishop_product product "
            ." where "
            //." n_category " . ( $list_num_category_query !== "" ? ( " IN (".$list_num_category_query.") " ) : " = ".$one_num_category_query )
            .($t_db_query_category ? " ( ".$t_db_query_category." ) and " : "")
            ." hide='show' "//." and end_putdate>".$GLOBALS["timeDayProduct"]." "
            .$db_query_stext.$db_query_cost.$db_query_available
            
            //.$this->add_db_query_country().$this->add_db_query_region().$this->add_db_query_city()
            .$q_where_dynamic
            ." order by "
            .($this->name_sort ? " ".$init_sort_ishop[$this->name_sort]." ".$this->type_sort." " : " sort_time DESC ")
            ." limit ".($this->open_num_page - 1) * KOLVO_VIEW_SYNOPSIS_PRODUCT." , ".KOLVO_VIEW_SYNOPSIS_PRODUCT;
          
          list($kolvo_product, $this->data_synopsis_product) = obr_db_query_select_assoc($db_query);
          
          
          if ($kolvo_product == 0) return (false);
          /*
          if ( $masConfig["ON_USE_GEO_DATA"] == 1 )
            {
             global $obj_geoData;
             $obj_geoData->add_data_mas_for_extract_geo($this->data_synopsis_product,array("country_product","region_product","city_product"));
            }
          */
        }
      
      //$this->base_url_page = $this->dir_http."/category".($this->open_num_podcategory ? $this->open_num_podcategory : $this->open_num_category)."/";
      $this->base_url_page = ($this->open_num_podcategory ? $this->obj_modul->forming_all_name_url_category($this->open_num_podcategory, "inferior") : $this->obj_modul->forming_all_name_url_category($this->open_num_category, "high"));
      
      //$korekParam = true;
      
      $this->openNsrlKeyComponent = "4";
      $this->openNsrlComponentIdent = (sizeof($mas_list_num)) ? $mas_list_num : 0;
      
      
      return (true);
    }
  
  function forming_data()
    {
      
      global $mas_value_template, $tpl, $masConfig, $dir_http;
      $mas_perem = $mas_value_template;
      $mas_perem["masConfig"] = $masConfig;
      
      $t_geo = "";
      if ($masConfig["ON_USE_GEO_DATA"] == 1)
        {
          global $obj_geoData;
          $t_geo = $obj_geoData->get_text_name_view_geo_data();
        }
      
      $data_select_category = ($this->open_num_podcategory) ? $this->data_open_podcategory : $this->data_open_category;
      $t_num_page = ($this->open_num_page > 1 ? " - Страница ".$this->open_num_page : "");
      $this->title_text = (trim($data_select_category["title_category"]) ? $data_select_category["title_category"] : $data_select_category["name"]).$t_num_page;
      $this->title = (trim($data_select_category["teg_title"]) ? $data_select_category["teg_title"] : $data_select_category["name"]).($t_geo ? " - ".$t_geo." " : "").$t_num_page;
      
      $this->keywords = $data_select_category["meta_keywords"];
      $this->description = $data_select_category["meta_description"];
      $this->description .= ($this->description ? $t_num_page : "");
      
      if ($this->num_open_lvl_category > 0)
        {
          
          $this->mas_navigation_pointer[] = array("Все товары",
            $dir_http.$this->data_block_navigation['url_part_geo'].'/allproduct/'
          );
          $mas_links = $this->obj_modul->forming_mas_links_series_category_from_num($this->num_open_lvl_category);
          $kolvo_links = sizeof($mas_links);
          for ($i = 0; $i < ($kolvo_links - 1); $i++)
            {
              $one_link = $mas_links[$i];
              $this->mas_navigation_pointer[] = array($one_link["name"], $one_link["link"]);
            }
          $this->mas_navigation_pointer[] = array($mas_links[$kolvo_links - 1]["name"], false);
        }
      
      
      //$this->num_open_lvl_category = $this->open_num_podcategory ? $this->open_num_podcategory : $this->open_num_category;
      
      $mas_perem["kolvo_product_vsego_to_category"] = $this->kolvo_product_vsego_to_category;
      $mas_perem["data_synopsis_product"] = $this->data_synopsis_product;
      $mas_perem["open_num_page"] = $this->open_num_page;
      $mas_perem["open_num_element"] = $this->num_open_lvl_category;
      $mas_perem["data_select_category"] = $data_select_category;
      $mas_perem["data_row"] = $this->data_synopsis_product;
      
      
      // для поиска по динамическим полям
      global $obj_dynamic;
      $t_data_js = "  dynamic_data:'no'   ";
      
      if ($this->num_open_lvl_category > 0 && sizeof($this->obj_modul->search_mas_global_num_properties) > 0)
        {
          
          $data_value = $obj_dynamic->selectValuesPropertiesTextJoin($this->obj_modul->search_mas_global_num_properties);
          
          $text_data_properties = "";
          
          $data_properties = $obj_dynamic->union_mas_link_properties($this->obj_modul->search_mas_link_pc, $this->obj_modul->search_data_properties);
          
          $text_data_properties = encode_mas_to_jointext($data_properties);
          
          $t_data_js = "  dynamic_data:'yes' , t_properties:[ $text_data_properties ] , $data_value ";
          
          if (sizeof($this->obj_modul->search_find_get_dynamic_data) > 0)
            {
              $jointext_dynam_data = $obj_dynamic->forming_mas_to_jointext_dynam_data_product($this->obj_modul->search_find_get_dynamic_data);
              $t_data_js .= " , dynamic_value_product:{ $jointext_dynam_data } ";
              
            }
          
        }
      
      
      //$mas_perem["t_data_js"] = $t_data_js;
      $this->obj_modul->text_dynamic_data_join_js = $t_data_js;
      
      $mas_perem["search_add_link_page_dynamic"] = $this->obj_modul->search_add_link_page_dynamic;
      $mas_perem["data_open_category"] = $this->data_block_navigation["data_open_lvl_category"];//***
      
      global $init_currency;
      $mas_perem["init_currency"] = $init_currency;
      $mas_perem["name_base_currency"] = $this->obj_modul->name_base_currency;
      
      $mas_perem["dir_http_template_modul"] = $this->obj_modul->dir_http_template_modul;
      
      
      $mas_perem["obj_ishop"] = &$this->obj_modul;
      
      $tpl->template_dir = $this->obj_modul->dir_template_mfile."/";
      
      $tpl->assign($mas_perem);
      $t_bk_oper = $tpl->fetch("forming_block_oper.html");
      
      $mas_perem["t_bk_oper"] = $t_bk_oper;
      
      //$t_bk_search = $this->forming_block_search();
      //$mas_perem["t_bk_search"]=$t_bk_search;
      
      $tpl->template_dir = $this->obj_modul->dir_template_mfile."/page/";
      
      $tpl->assign($mas_perem);
      $this->text = $tpl->fetch("category.html");
      
      
      return (true);
    }
  
}

