<?php


class eng_ishop_page_wishlist extends eng_gen_ishop_page
{
  /**
   * @var $obj_modul ishop_class
   */
  protected $obj_modul;
  
  protected $kolvo_vsego_product = 0;
  protected $open_num_page_product = 1;
  protected $data_product = array();
  
  protected $alert_user = false;
  protected $text_alert_user = "";
  
  function first_init()
    {
      
    }
  
  function control_data()
    {
      
      $this->kolvo_vsego_product = 0;
      $this->open_num_page_product = 1;
      $this->data_product = array();
      
      $this->alert_user = false;
      $this->text_alert_user = "";
      
      global $masConfig;
      
      if ($this->status_inbox["delete_num"] == "set")
        {
          $save = false;
          
          list($save, $mas_num_product) = eng_wishlist_ishop::delete_one_num($this->mas_inbox["delete_num"]);
          
          if ($save)
            {
              $this->obj_modul->add_data_user_behavior("wishlist_del", ["vnum1" => $this->mas_inbox["delete_num"]]);
            }
          
          header("Location: ".$this->dir_http."/wishlist/");
          exit();
        }
      /*
      if ( $this->status_inbox["alert"] == "set" )
        {
         
         if ( $this->mas_inbox["alert"] == "on" )
           {
            $this->alert_user = true;
            $this->text_alert_user = "Объявление удалено из закладок!";
           }
          else
            {
             $this->alert_user = true;
             $this->text_alert_user = "Объявление не найдено в закладках!";
            }
         
        }
      */
      
      if ($this->obj_modul->quantity_wishlist)
        {
          
          $t_db_query_category = $this->obj_modul->get_text_db_query_part_category("product.n_category", 0);
          
          
          $db_query = "select count(*) from ".DB_PREF."ishop_product product "
            ." where "
            .($t_db_query_category ? " ( ".$t_db_query_category." ) and " : "")
            ." product.hide='show' "
            //." and product.end_putdate > ".$GLOBALS["timeDayProduct"]
            ."  and  id_product IN (".implode(",", $this->obj_modul->data_wishlist["mas_num"]).") ";
          $this->kolvo_vsego_product = obr_db_query_count($db_query);
          
          
          if ($this->status_inbox["num_page"] == "set")
            {
              $this->open_num_page_product = $this->mas_inbox["num_page"];
              $this->openOnGetNumPage = true;
            }
          else
            {
              $this->open_num_page_product = 1;
            }
          
          $this->openNumPage = $this->open_num_page_product;
          
          if ($this->kolvo_vsego_product == 0)
            {
              if ($this->open_num_page_product != 1)
                {
                  return (false);
                }
            }
          else
            {
              $db_query = "select product.id_product,
          
          product.name_product, product.short_text, product.image, product.start_date,
          product.cost,
          product.status_product, product.n_category, product.currency,
          product.name_url, product.quantity_stock, product.discount_cost, product.first_cost,
          product.on_request 
          from ".DB_PREF."ishop_product product "
                ." where "
                .($t_db_query_category ? " ( ".$t_db_query_category." ) and " : "")
                ." product.hide='show' "
                ."  and  id_product IN (".implode(",", $this->obj_modul->data_wishlist["mas_num"]).") "
                ." order by product.sort_time DESC limit ".($this->open_num_page_product - 1) * KOLVO_VIEW_SYNOPSIS_PRODUCT." , ".KOLVO_VIEW_SYNOPSIS_PRODUCT;
              
              list($kolvo, $this->data_product) = obr_db_query_select_assoc($db_query);
              
              if ($kolvo == 0) return (false);
              
            }
          
          
        }
      
      $korekParam = true;
      
      
      return (true);
    }
  
  function forming_data()
    {
      
      $t_num_page = ($this->open_num_page_product > 1 ? " - Страница ".$this->open_num_page_product : "");
      $this->title = "Товары в избранном".$t_num_page;
      $this->title_text = "Товары в избранном".$t_num_page;
      
      
      global $mas_value_template, $tpl, $masConfig;
      $mas_perem = $mas_value_template;
      $mas_perem["masConfig"] = $masConfig;
      
      
      $mas_perem["user_to_site"] = $GLOBALS["user_to_site"];
      $mas_perem["kolvo_vsego_product"] = $this->kolvo_vsego_product;
      $mas_perem["open_num_page_product"] = $this->open_num_page_product;
      $mas_perem["data_product"] = $this->data_product;
      $mas_perem["page_product"] = true;
      
      $mas_perem["alert_user"] = $this->alert_user;
      $mas_perem["text_alert_user"] = $this->text_alert_user;
      
      
      global $init_currency;
      $mas_perem["init_currency"] = $init_currency;
      $mas_perem["name_base_currency"] = $this->obj_modul->name_base_currency;
      
      $mas_perem["dir_http_template_modul"] = $this->obj_modul->dir_http_template_modul;
      
      
      $mas_perem["obj_ishop"] = &$this->obj_modul;
      
      $tpl->template_dir = $this->obj_modul->dir_template_mfile."/page/";
      
      $tpl->assign($mas_perem);
      $this->text = $tpl->fetch("wishlist.html");
      
      
      return (true);
    }
  
}

