<?php


class  class_work_dynamic_properties_ishop
  {
   private $dbcnx = false;
   private $error_baz=false;
   private $obj_cache_category = false;
   
   function __construct( $obj_ishop_cache_category )
     {
      
      $this->obj_cache_category = $obj_ishop_cache_category;
      
     }
   
   function selectLinkPC($num_podcategory,$on_light = false)
     {
      
      $db_query="select * from ".DB_PREF."ishop_link_pc where num_category = ".$num_podcategory
        . ($on_light ? " and on_light = 'on' " : "" );
      list($kolvo,$data_link)=obr_db_query_select_assoc($db_query);
      
      $rez_mas=array();
      $mas_global_num_properties=array();
      
      $rez=false;
      
      if ( $kolvo )
        {
         
         foreach ( $data_link as $row )
           {
            
            $rez_mas[$row["num_properties"]]=$row;
            $mas_global_num_properties[]=$row["num_properties"];
            $rez=true;
           }
         
        }
      
      return ( $rez ? array( $rez_mas, $mas_global_num_properties ) : $rez );
     }
   
   function selectProperties($mas_num_properties)
     {
      
      $db_query="select * from ".DB_PREF."ishop_properties 
        where id_properties IN ( ".implode(",",$mas_num_properties).")
          or global_num_properties IN ( ".implode(",",$mas_num_properties)." ) ";
      list($kolvo,$data_properties)=obr_db_query_select_assoc($db_query);
      
      
      $rez_mas=array();
      $rez=false;
      
      if ( $kolvo )
        {
         
         foreach ( $data_properties as $row )
           {
            
            $rez_mas[]=$row;
            $rez=true;
           }
         
        }
      
      return ( $rez ? $rez_mas : $rez );
     }
   
   function union_mas_link_properties($mas_link_pc,$data_properties)
     {
      $rez=array();
      if (is_array($mas_link_pc) && is_array($data_properties))
        {
         foreach ($data_properties as $key => $one_properties)
           {
            $num_pos=0;
            $on_light="on";
            
            if (!empty($mas_link_pc[$one_properties["id_properties"]]))
              {
               $num_pos=$mas_link_pc[$one_properties["id_properties"]]["num_pos"];
               $on_light=$mas_link_pc[$one_properties["id_properties"]]["on_light"];
              }
            
            $data_properties[$key]["num_pos"]=$num_pos;
            $data_properties[$key]["on_light"]=$on_light;
            
           }
         $rez=$data_properties;
         usort ($rez,"sort_properties");
        }
      
      return ($rez);
     }
   
   function sort_properties($a,$b)
     {
      if ($a["num_pos"]==$b["num_pos"]) return 0;
      return (($a["num_pos"]>$b["num_pos"])?1:-1);
     }
   
   
   function selectValuesPropertiesTextJoin($mas_num_properties)
     {
      
      $db_query="select * from ".DB_PREF."ishop_listv 
        where n_properties IN ( ".implode(",",$mas_num_properties).")
          or global_link_properties IN ( ".implode(",",$mas_num_properties)." ) order by pos_value ASC, name_value ASC ";
      list($kolvo,$data)=obr_db_query_select_assoc($db_query);
      
      $rez_text=" listv:[ ";
      $rez=false;
      
      if ( $kolvo )
        {
         $raz=" ";
         foreach ( $data as $row )
           {
            $raz1=" ";
            $rez_text.=$raz."{";
            foreach ($row as $key => $value)
              {
               $rez_text.=$raz1." '$key':'".RawUrlEncode(decodeText($value))."'";
               $raz1=",";
              }
            //$rez_mas[]=$row;
            $rez_text.="}";
            $raz=",";
           }
         
         
        }
      $rez_text.="]";
      return ($rez_text);
     }
   
   function selectValuesPropertiesMassiv($mas_num_properties)
     {
      
      $db_query="select * from ".DB_PREF."ishop_listv 
        where n_properties IN ( ".implode(",",$mas_num_properties).")
          or global_link_properties IN ( ".implode(",",$mas_num_properties)." ) order by pos_value ASC, name_value ASC ";
      list($kolvo,$data)=obr_db_query_select_assoc($db_query);
      
      $rez_mas=array();
      $rez=false;
      
      if ( $kolvo )
        {
         
         foreach ($data as $row )
           {
            
            $rez_mas[$row["id_value"]]=$row;
            
            $rez=true;
           }
         
         
        }
      
      return ($rez?$rez_mas:$rez);
     }
   
   function save_dynamic_values($mas_dynamic_data,$podcategory,$num_product)
     {
      
      $db_query="insert into ".DB_PREF."ishop_data values ";
      $text_data_save="";
      $raz=" ";
      foreach ($mas_dynamic_data as $one_data)
        {
         $text_data_save.=$raz." (0,$num_product,$podcategory,".$one_data[0].",'".codeText($one_data[1])
          ."','".$one_data[2]."')";
         $raz=" , ";
        }
      $db_query.=$text_data_save;
      //write_log_cms($db_query,"db query save dynamic values");
      obr_db_query($db_query);
      
      return (true);
     }
   
   function delete_dynamic_values_num_product($num_product)
     {
      
      $db_query="delete from ".DB_PREF."ishop_data where n_product = $num_product ";
      obr_db_query($db_query);
      
      return (true);
     }
   
   function delete_dynamic_values_list_num_product($list_num_product)
     {
      
      $db_query="delete from ".DB_PREF."ishop_data where n_product IN ( $list_num_product ) ";
      obr_db_query($db_query);
      
      return (true);
     }
   
   function selectValuesProduct($num_product)
     {
      //Функция вернет динамические данные продукта сгрупированные по id свойств
      // (групировка нужна из-за свойств "выборочные значения")
      
      $db_query="select * from ".DB_PREF."ishop_data 
        where n_product = $num_product ";
      list($kolvo,$data)=obr_db_query_select_assoc($db_query);
      
      $rez_mas=array();
      
      if ( $kolvo )
        {
         foreach ( $data as $row )
           {
            
            $num_properties=$row["n_properties"];
            
            if (!isset($rez_mas[$num_properties]))
              {
               $rez_mas[$num_properties]=array();
              }
            
            $rez_mas[$num_properties][]=$row;
            
           }
        }
      
      return ($rez_mas);
     }
   
   function selectValuesListProduct($mas_num_product)
     {
      
      $db_query="select * from ".DB_PREF."ishop_data 
        where n_product IN ( ".implode(",",$mas_num_product). " ) ";
      list($kolvo,$data)=obr_db_query_select_assoc($db_query);
      
      $rez_mas=array();
      
      if ( $kolvo )
        {
         $rez_mas = $data;
        }
      
      return ($rez_mas);
     }
   
   
   function edit_dynamic_values_one_product($num_product,$n_category,$current_dynamic,$new_dynamic)
     {
       /*
       write_log_cms($num_product,"num product edit dynamic data");
       write_log_cms($n_category,"n_category");
       write_log_cms($current_dynamic,"current dynamic product");
       write_log_cms($new_dynamic,"new dynamic product");
       */
       
       $size_current=sizeof($current_dynamic);
       $size_new=sizeof($new_dynamic);
       
       if ($size_current == 0 && $size_new == 0) return (true);
       
       if ($size_current == 0 && $size_new > 0)
         {
           // Добавляем новые свойства, текущих свойств нет
           $this->save_dynamic_values($new_dynamic,$n_category,$num_product);
         }
       elseif ($size_current > 0 && $size_new == 0)
         {
           // Новых свойств нет, поэтому удаляем текущие свойства
           $this->delete_dynamic_values_num_product($num_product);
         }
       else
         {
           
           $_current_d=$current_dynamic;
           
           $mas_new_values=[];
           $mas_edit_values=[];
           $mas_del_values=[];
           
           //$_current_d2=$_current_d;
           
           foreach ($new_dynamic as $new_item)
             {
               // $new_item -> [num_properties, value, type_properties (text)]
               //write_log_cms($new_item,"new item dynamic data");
               
               $num_properties=$new_item[0];
               $_data_one_current=$_current_d[$num_properties] ?? false;
               
               if ($_data_one_current)
                 {
                   //write_log_cms($_data_one_current,"values current one properties");
                   $_size_m=sizeof($_data_one_current);
                   
                   if ($_size_m == 1)
                     {
                       $_one_current=$_data_one_current[0];// содержит одну строчку динамических данных (текущие данные) из базы данных
                       $on_equal=$this->_check_equal_item_dynamic($new_item,$_one_current,$n_category);
                       //write_log_cms($on_equal,"on equal item dynamic");
                       
                       if (!$on_equal)
                         {
                           $_elm=$_one_current;
                           $_elm["n_category"]=$n_category;
                           $_elm["value_properties"]=$new_item[1];
                           //write_log_cms($_elm,"edit item dynamic data");
                           $mas_edit_values[]=$_elm;
                         }
                       
                       $_current_d[$num_properties][0]["_status"]=$on_equal ? "equal":"edit";
                     }
                   else
                     {
                       list($_on_search,$_num_key)=search_mas_2level($_data_one_current,"value_properties",$new_item[1],false);
                       //write_log_cms($_on_search ? "on search key -> ". $_num_key:"no search","on search mas values dynamic");
                       
                       if (!$_on_search)
                         {
                           $mas_new_values[]=$new_item;
                         }
                       else
                         {
                           $on_equal=$this->_check_equal_item_dynamic($new_item,$_data_one_current[$_num_key],$n_category);
                           if (!$on_equal)
                             {
                               $_elm = $_data_one_current[$_num_key];
                               $_elm["n_category"] = $n_category;
                               $_elm["value_properties"] = $new_item[1];
                               //write_log_cms($_elm, "edit item dynamic data (list_checkbox)");
                               $mas_edit_values[] = $_elm;
                             }
                           $_current_d[$num_properties][$_num_key]["_status"] = $on_equal ? "equal" : "edit";
                         }
                     }
                   
                 }
               else
                 {
                   $mas_new_values[]=$new_item;
                 }
             }
           
           //write_log_cms($_current_d,"current data status");
           
           foreach ($_current_d as $_key_d => $_one_current_d)
             {
               foreach ($_one_current_d as $_item_current)
                 {
                   if (!isset($_item_current["_status"]))
                     {
                       $mas_del_values[]=$_item_current;
                     }
                 }
             }
           /*
           write_log_cms($mas_new_values,"mas new values dynamic");
           write_log_cms($mas_edit_values,"mas edit values dynamic");
           write_log_cms($mas_del_values,"mas del values dynamic");
           */
           if (sizeof($mas_new_values) > 0 && sizeof($mas_del_values) > 0)
             {
               list($_mas_new2,$_mas_edit2,$_mas_del2)=$this->_replace_mas_new_del($mas_new_values,$mas_del_values,$n_category);
               
               $mas_new_values=$_mas_new2;
               $mas_edit_values=array_merge($mas_edit_values,$_mas_edit2);
               $mas_del_values=$_mas_del2;
             }
           /*
           write_log_cms($mas_new_values,"mas2 new values dynamic");
           write_log_cms($mas_edit_values,"mas2 edit values dynamic");
           write_log_cms($mas_del_values,"mas2 del values dynamic");
           */
           if (sizeof($mas_new_values))
             {
               $this->save_dynamic_values($mas_new_values,$n_category,$num_product);
             }
           
           if (sizeof($mas_edit_values))
             {
               foreach ($mas_edit_values as $one_row)
                 {
                   $db_query=forming_db_query_indexmas(DB_PREF."ishop_data",$one_row,"edit","id_data");
                   //write_log_cms($db_query,"db query edit item dynamic data");
                   db_work::query($db_query);
                 }
             }
           
           if (sizeof($mas_del_values))
             {
               $mas_num=select_mas1lev_2level($mas_del_values,"id_data",false);
               $db_query="delete from ".DB_PREF."ishop_data where id_data IN (".implode(",",$mas_num).") ";
               db_work::query($db_query);
             }
           
         }
       
       
       return (true);
     }
   
   protected function _check_equal_item_dynamic($new_item,$current_item,$n_category)
     {
       /*
       write_log_cms($n_category,"num category for dynamic data");
       write_log_cms($new_item,"new item dynamic");
       write_log_cms($current_item,"current item dynamic");
       */
       $on_equal=true;
       
       if ($current_item["n_category"] != $n_category) $on_equal = false;
       
       if ($current_item["value_properties"] != $new_item[1]) $on_equal = false;
       
       return ($on_equal);
     }
   
   protected function _replace_mas_new_del($mas_new_values,$mas_del_values,$n_category)
     {
       $mas_new2=$mas_new_values;
       $mas_edit=[];
       
       foreach ($mas_new_values as $_key_m => $new_item)
         {
           if (sizeof($mas_del_values) == 0) break;
           $_elm=array_pop($mas_del_values);
           //write_log_cms($_elm,"elm pop");
           //write_log_cms($mas_del_values,"mas del values после pop");
           $_elm["n_category"]=$n_category;
           $_elm["n_properties"]=$new_item[0];
           $_elm["value_properties"]=$new_item[1];
           $_elm["type_propData"]=$new_item[2];
           $mas_edit[]=$_elm;
           unset($mas_new2[$_key_m]);
         }
       
       $mas_new2=array_values($mas_new2);
       
       return ([$mas_new2,$mas_edit,$mas_del_values]);
     }
   
   function forming_one_properties($one_properties,$data_product,$mas_listv)
     {
      $t="";
      
      $t_value="";
      if (isset($data_product[$one_properties["id_properties"]]))
        {
         $mas_data=$data_product[$one_properties["id_properties"]];
         
         foreach ($mas_data as $one_data)
           {
            switch ($one_properties["type_properties"])
              {
               case ("text"):
               case ("numeric"):
                  $t_value.=htmlspecialchars($one_data["value_properties"],ENT_QUOTES);
                 break;
               case ("list"):
               case ("nested_list"):
                 //$t_value=" ++ ";
               case ("list_checkbox"):
                 if (isset($mas_listv[$one_data["value_properties"]]))
                   $t_value.="<div>".$mas_listv[$one_data["value_properties"]]["name_value"]."</div>";
              }
           }
         
        }
      
      if ( $t_value )
        {
         $t.="<tr><td class='td_name_param'>";
         $t.=$one_properties["name_properties"];
         $t.="</td><td>";
         $t.= $t_value ? $t_value : "нет данных";
         $t.="</td></tr>";
        }
      
      return ($t);
     }
   
   function search_nested_list($num_properties,$mas_properties,$data_value_product,$data_value)
     {
      $t="";
      foreach ($mas_properties as $one_properties)
        {
         if ($one_properties["type_properties"] != "nested_list") continue;
         
         if ($one_properties["num_properties"] == $num_properties)
           {
            //$t.=$num_properties;
            $t.=$this->forming_one_properties($one_properties,$data_value_product,$data_value);
            
            $t.=$this->search_nested_list($one_properties["id_properties"],$mas_properties,$data_value_product,$data_value);
            
           }
         
        }
      return ($t);
     }
   
   function forming_mas_to_jointext_dynam_data_product($dynam_data_value_product)
     {
      
      $t="";
      $raz=" ";
      foreach ($dynam_data_value_product as $num_properties => $mas_data)
        {
         $t.=$raz.$num_properties.":[";
         $raz=" , ";
         $raz1="";
         foreach ($mas_data as $one_row)
           {
            
            $t.=$raz1."{".encode_row_mas_to_jointext($one_row)."}";
            $raz1=" , ";
           }
         
         $t.="]";
        }
      
      return ($t);
     }
   
   
   function get_dynamic_data_product($num_category,$num_product)
     {
      
      //$data_dynamic = "";
      $mas_properties = array();
      
      $rez_data=$this->selectLinkPC( $num_category );
      
      
      if ($rez_data && is_array($rez_data[0]) && sizeof($rez_data[0]) > 0)
        {
         $mas_global_num_properties=$rez_data[1];
         $mas_link_pc=$rez_data[0];
         
         
         $data_properties=$this->selectProperties($mas_global_num_properties);
         
         
         if ($data_properties && is_array($data_properties) && sizeof($data_properties) > 0)
           {
            
            $data_value=$this->selectValuesPropertiesMassiv($mas_global_num_properties);
            
            
            
            $data_value_product=$this->selectValuesProduct( $num_product );
            
            
            
            $data_properties=$this->union_mas_link_properties($mas_link_pc,$data_properties);
            
            foreach ($data_properties as $one_properties)
              {
               
               if ( $one_properties["num_properties"] ) continue;
               
               //$data_dynamic .= $this->forming_one_properties($one_properties,$data_value_product,$data_value);
               $mas_properties[] = $this->get_name_value_one_properties($one_properties,$data_value_product,$data_value);
               
               //$data_dynamic .= $this->search_nested_list($one_properties["id_properties"],$data_properties,$data_value_product,$data_value);
               $mas = $this->get_name_value_nested_list_properties($one_properties["id_properties"],$data_properties,$data_value_product,$data_value);
               
               $mas_properties = array_merge($mas_properties,$mas);
               
               
              }
            
            
           }
          else
            {
             
            }
         
         
        }
       else
         {
          
         }
      
      
      return ( $mas_properties );
     }
   
   
   function get_name_value_one_properties($one_properties,$data_product,$mas_listv)
     {
      $get_data = array( "name" => "" , "value" => array(), "type_properties" => "" );
      
      //$t.="<tr><td class='td_name_param'>";
      $get_data["name"] = $one_properties["name_properties"];
      $get_data["type_properties"] = $one_properties["type_properties"];
      //$t.="</td><td>";
      
      $t_value="";
      if ( isset($data_product[$one_properties["id_properties"]]) )
        {
         $mas_data=$data_product[$one_properties["id_properties"]];
         
         foreach ($mas_data as $one_data)
           {
            switch ($one_properties["type_properties"])
              {
               case ("text"):
               case ("numeric"):
                  //$t_value.=htmlspecialchars($one_data["value_properties"],ENT_QUOTES);
                  $get_data["value"][] = $one_data["value_properties"];
                 break;
               case ("list"):
               case ("nested_list"):
                 //$t_value=" ++ ";
               case ("list_checkbox"):
                 if ( isset($mas_listv[$one_data["value_properties"]]) )
                   $get_data["value"][] = $mas_listv[$one_data["value_properties"]]["name_value"];
                   //$t_value.="<div>".$mas_listv[$one_data["value_properties"]]["name_value"]."</div>";
              }
           }
         
        }
      
      //$t.=$t_value?$t_value:"нет данных";
      //$t.="</td></tr>";
      
      return ($get_data);
     }
   
   
   function get_name_value_nested_list_properties($num_properties,$mas_properties,$data_value_product,$data_value)
     {
      //$t="";
      $list_data = array();
      $mas = array();
      
      foreach ($mas_properties as $one_properties)
        {
         if ($one_properties["type_properties"] != "nested_list") continue;
         
         if ($one_properties["num_properties"] == $num_properties)
           {
            //$t.=$num_properties;
            $list_data[] = $this->get_name_value_one_properties($one_properties,$data_value_product,$data_value);
            
            $mas = $this->get_name_value_nested_list_properties($one_properties["id_properties"],$mas_properties,$data_value_product,$data_value);
            $list_data = array_merge($list_data,$mas);
           }
         
        }
      
      return ($list_data);
     }
   
   function get_dynamic_data_many_product( $mas_data_product )
     {
      $mas_num_category = array_values(array_unique(select_mas1lev_2level($mas_data_product,"n_category",false)));
      $mas_num_product = select_mas1lev_2level($mas_data_product,"id_product",false);
      
      $mas_properties_values = array();
      
      $data_link = $this->selectLinkPropertiesManyCategory( $mas_num_category );
      
      
      if ( $data_link && is_array($data_link[0]) && sizeof($data_link[0]) > 0 )
        {
         
         $mas_global_num_properties = array_values( array_unique($data_link[1]) );
         $mas_link_pc = $data_link[0];
         
         
         $data_properties = $this->selectProperties($mas_global_num_properties);
         
         if ( $data_properties && is_array($data_properties) && sizeof($data_properties) > 0 )
           {
            
            $data_value_properties = $this->selectValuesPropertiesMassiv($mas_global_num_properties);
            
            $data_value_many_product = $this->selectValuesGroupListProduct( $mas_num_product );
            
            
            $data_properties = $this->union_mas_link_properties_many_category($mas_link_pc,$data_properties);
            $data_properties = select_mas_2level($data_properties,"on_preview","yes",false);
            
            foreach ( $mas_data_product as $one_product )
              {
               
               $data_properties_one_product = select_mas_2level($data_properties,"num_category",$one_product["n_category"],false);
               
               //$data_properties_one_product = $this->ext_properties_to_num_category( $data_properties,$mas_link_pc, $one_product["n_category"] );
               
               $dynamic_data_one_product = array();
               
               foreach ( $data_properties_one_product as $one_properties )
                 {
                  if ( $one_properties["num_properties"] ) continue;
                  if ( empty( $data_value_many_product[$one_product["id_product"]] ) ) continue;
                  
                  $data_one_product = $data_value_many_product[$one_product["id_product"]];
                  //var_dump($data_one_product);exit;
                  $dynamic_data_one_product[] = $this->get_name_value_one_properties($one_properties,$data_one_product,$data_value_properties);
                  
                  $mas = $this->get_name_value_nested_list_properties($one_properties["id_properties"],$data_properties,$data_one_product,$data_value_properties);
                  
                  $dynamic_data_one_product = array_merge($dynamic_data_one_product,$mas);
                  
                 }
               
               $mas_properties_values[$one_product["id_product"]] = $dynamic_data_one_product;
              }
            
            /*
            foreach ($data_properties as $one_properties)
              {
               if ( $one_properties["num_properties"] ) continue;
               
               $mas_properties[] = $this->get_name_value_one_properties($one_properties,$data_value_product,$data_value);
               
               $mas = $this->get_name_value_nested_list_properties($one_properties["id_properties"],$data_properties,$data_value_product,$data_value);
               
               $mas_properties = array_merge($mas_properties,$mas);
               
              }
            */
            
           }
         
        }
      
      return ( $mas_properties_values );
     }
   
   function selectLinkPropertiesManyCategory($mas_num_category)
     {
      
      $db_query="select * from ".DB_PREF."ishop_link_pc where num_category IN ( ".implode(",",$mas_num_category) . " ) ";
      list($kolvo,$data_link)=obr_db_query_select_assoc($db_query);
      
      $rez_mas=array();
      $mas_global_num_properties=array();
      
      $rez=false;
      
      if ( $kolvo )
        {
         
         foreach ( $data_link as $row )
           {
            
            $rez_mas[]=$row;
            $mas_global_num_properties[]=$row["num_properties"];
            $rez=true;
           }
         
        }
      
      return ( $rez ? array( $rez_mas, $mas_global_num_properties ) : $rez );
     }
   
   /*
   function union_mas_link_properties_many_category($mas_link_pc,$data_properties)
     {
      //$rez=array();
      //$is_res = false;
      
      $data_union_properties = array();
      
      if (is_array($mas_link_pc) && is_array($data_properties))
        {
         //foreach ($data_properties as $key => $one_properties)
         foreach ($mas_link_pc as $key => $one_link_pc)
           {
            $one_union_properties = array();
            $num_pos=0;
            $num_category=0;
            
            list($on_search,$key_properties) = search_mas_2level($data_properties,"id_properties",$one_link_pc["num_properties"], false);
            
            if ( $on_search )
              {
               //$one_link = $mas_link_pc[$key_link_pc];
               //$is_res = true;
               
               //$num_pos=$one_link["num_pos"];
               //$num_category=$one_link["num_category"];
               
               $one_union_properties = $data_properties[$key_properties];
               $one_union_properties["num_pos"] = $one_link_pc["num_pos"];
               $one_union_properties["num_category"] = $one_link_pc["num_category"];
               
               $data_union_properties[] = $one_union_properties;
              }
            / *
            if (!empty($mas_link_pc[$one_properties["id_properties"]]))
              {
               $num_pos=$mas_link_pc[$one_properties["id_properties"]]["num_pos"];
              }
            * /
            
            //$data_properties[$key]["num_pos"]=$num_pos;
            //$data_properties[$key]["num_category"]=$num_category;
            
           }
         
         if ( sizeof($data_union_properties) )
           {
            //$rez=$data_properties;
            usort ($data_union_properties,"sort_properties");
           }
        }
      
      return ($data_union_properties);
     }
   */
   
   function union_mas_link_properties_many_category($mas_link_pc,$data_properties)
     {
      $rez=array();
      $is_res = false;
      
      if (is_array($mas_link_pc) && is_array($data_properties))
        {
         foreach ($data_properties as $key => $one_properties)
           {
            $num_pos=0;
            $num_category=0;
            
            list($on_search,$key_link_pc) = search_mas_2level($mas_link_pc,"num_properties",$one_properties["id_properties"], false);
            
            if ( $on_search )
              {
               $one_link = $mas_link_pc[$key_link_pc];
               $is_res = true;
               
               $num_pos=$one_link["num_pos"];
               $num_category=$one_link["num_category"];
               
              }
            /*
            if (!empty($mas_link_pc[$one_properties["id_properties"]]))
              {
               $num_pos=$mas_link_pc[$one_properties["id_properties"]]["num_pos"];
              }
            */
            
            $data_properties[$key]["num_pos"]=$num_pos;
            $data_properties[$key]["num_category"]=$num_category;
            
           }
         
         if ( $is_res )
           {
            $rez=$data_properties;
            usort ($rez,"sort_properties");
           }
        }
      
      return ($rez);
     }
   
   function selectValuesGroupListProduct($mas_num_product)
     {
      
      $db_query="select * from ".DB_PREF."ishop_data 
        where n_product IN ( ".implode(",",$mas_num_product). " ) ";
      //list($kolvo,$data)=obr_db_query_select_assoc($db_query);
      list($kolvo,$data)=obr_db_query_select_assoc_index_group($db_query,"n_product");
      
      $rez_mas=array();
      
      if ( $kolvo )
        {
         //$rez_mas = $data;
         
         foreach ( $data as $num_product => $mas_values )
           {
            $one_grup = array();
            foreach ( $mas_values as $one_value )
              {
               
               $num_properties=$one_value["n_properties"];
               
               if (!isset($one_grup[$num_properties]))
                 {
                  $one_grup[$num_properties]=array();
                 }
               
               $one_grup[$num_properties][]=$one_value;
               
              }
            
            $rez_mas[$num_product] = $one_grup;
            
           }
         
        }
      
      return ($rez_mas);
     }
   
   /*
   function ext_properties_to_num_category( $data_properties, $mas_link_pc, $num_category )
     {
      $mas_properties = array();
      
      $link_pc_to_category = select_mas_2level($mas_link_pc,"num_category",$num_category,false);
      
      return ( $mas_properties );
     }
   */
   
   /*
   function get_name_value_one_properties_one_product($one_properties,$data_product,$mas_listv)
     {
      $get_data = array( "name" => "" , "value" => array() );
      
      $get_data["name"] = $one_properties["name_properties"];
      
      $t_value="";
      
      if ( isset($data_product[$one_properties["id_properties"]]) )
        {
         $mas_data=$data_product[$one_properties["id_properties"]];
         
         foreach ($mas_data as $one_data)
           {
            switch ($one_properties["type_properties"])
              {
               case ("text"):
               case ("numeric"):
                  
                  $get_data["value"][] = $one_data["value_properties"];
                 break;
               case ("list"):
               case ("nested_list"):
                 
               case ("list_checkbox"):
                 if ( isset($mas_listv[$one_data["value_properties"]]) )
                   $get_data["value"][] = $mas_listv[$one_data["value_properties"]]["name_value"];
                   
              }
           }
         
        }
      
      //$t.=$t_value?$t_value:"нет данных";
      //$t.="</td></tr>";
      
      return ($get_data);
     }
   */
   
   function get_dynamic_data_product_many_lvl_category($mas_num_lvl_category,$num_product)
     {
      $mas_properties = array();
      
      $mas_num_lvl_category_back = array_reverse($mas_num_lvl_category);
      
      //var_dump($mas_num_lvl_category_back);
      $on_data_link_pc = false;
      $mas_global_num_properties = array();
      $mas_link_pc = array();
      
      foreach ( $mas_num_lvl_category_back as $one_category )
        {
         $data_link=$this->selectLinkPc($one_category);
         if ($data_link && is_array($data_link[0]) && sizeof($data_link[0]) > 0)
           {
            $mas_link_pc = $data_link[0] + $mas_link_pc;
            $mas_global_num_properties = array_merge($mas_global_num_properties,$data_link[1]);
            $on_data_link_pc = true;
           }
         
        }
      
      $mas_global_num_properties = array_unique( $mas_global_num_properties );
      
      //if ($rez_data && is_array($rez_data[0]) && sizeof($rez_data[0]) > 0)
      if ($on_data_link_pc && is_array($mas_link_pc) && sizeof($mas_link_pc) > 0)
        {
         //$mas_global_num_properties=$rez_data[1];
         //$mas_link_pc=$rez_data[0];
         
         
         $data_properties=$this->selectProperties($mas_global_num_properties);
         
         
         if ($data_properties && is_array($data_properties) && sizeof($data_properties) > 0)
           {
            
            $data_value=$this->selectValuesPropertiesMassiv($mas_global_num_properties);
            
            
            
            $data_value_product=$this->selectValuesProduct( $num_product );
            
            
            
            $data_properties=$this->union_mas_link_properties($mas_link_pc,$data_properties);
            
            foreach ($data_properties as $one_properties)
              {
               
               if ( $one_properties["num_properties"] ) continue;
               
               //$data_dynamic .= $this->forming_one_properties($one_properties,$data_value_product,$data_value);
               $mas_properties[] = $this->get_name_value_one_properties($one_properties,$data_value_product,$data_value);
               
               //$data_dynamic .= $this->search_nested_list($one_properties["id_properties"],$data_properties,$data_value_product,$data_value);
               $mas = $this->get_name_value_nested_list_properties($one_properties["id_properties"],$data_properties,$data_value_product,$data_value);
               
               $mas_properties = array_merge($mas_properties,$mas);
               
               
              }
            
            
           }
          else
            {
             
            }
         
         
        }
       else
         {
          
         }
      
      return ( $mas_properties );
     }
   
   function get_link_pc_properties_series_category($mas_num_lvl_category,$on_light = false)
     {
      
      $on_data_link_pc = false;
      $mas_global_num_properties = array();
      $mas_link_pc = array();
      $data_properties = false;
      
      $mas_data_list_category = $this->obj_cache_category->get_data_mas_num($mas_num_lvl_category);
      
      foreach ( $mas_num_lvl_category as $one_category )
        {
         if ( !empty( $mas_data_list_category[$one_category] ) )
           {
            /*
            $data_one_category = $mas_data_list_category[$one_category];
            if ( $data_one_category["on_inherit_properties"] == "off" )
              {
               $on_data_link_pc = false;
               $mas_global_num_properties = array();
               $mas_link_pc = array();
              }
            */
            
            $data_link=$this->selectLinkPc($one_category,$on_light);
            if ($data_link && is_array($data_link[0]) && sizeof($data_link[0]) > 0)
              {
               $mas_link_pc = $data_link[0] + $mas_link_pc;
               $mas_global_num_properties = array_merge($mas_global_num_properties,$data_link[1]);
               $on_data_link_pc = true;
              }
           }
          else
            {
             //ошибка
            }
        }
      
      $mas_global_num_properties = array_unique( $mas_global_num_properties );
      
      if ($on_data_link_pc && is_array($mas_link_pc) && sizeof($mas_link_pc) > 0)
        {
         $data_properties=$this->selectProperties($mas_global_num_properties);
        }
      
      return (array($on_data_link_pc,$mas_global_num_properties,$mas_link_pc,$data_properties));
     }
   
   function search_dynamic_data_post($mas_global_num_properties,$data_properties)
     {
      
      global $masConfig;
      $is_fill_add_pole = $masConfig["IS_FILL_ADD_POLES_PRODUCT"];
      
      $name_post_pole_dynamic = NAME_POST_DYNAMIC_POLE;
      $error = 0;$error_text = "no";
      $mas_dynamic_data = array();
      $mas_value_real=array();
      
      if ($data_properties && is_array($data_properties) && sizeof($data_properties) > 0)
        {
         
         $data_value=$this->selectValuesPropertiesMassiv($mas_global_num_properties);
         
         
         foreach ($data_properties as $one_properties)
           {
            $num_one_properties=$one_properties["id_properties"];
            $name_dynamic_pole=$name_post_pole_dynamic.$num_one_properties;
            if (isset($_POST[$name_dynamic_pole]) || $one_properties["type_properties"] == "list_checkbox")
              {
               
               switch ($one_properties["type_properties"])
                 {
                  case ("text"):
                     $mas_dynamic_data[]=array($num_one_properties,$_POST[$name_dynamic_pole],"text");
                     $mas_value_real[]=$_POST[$name_dynamic_pole];
                    break;
                  case ("numeric"):
                    if (!is_numeric($_POST[$name_dynamic_pole]))
                      {
                       if ( $is_fill_add_pole == 1 || ( $is_fill_add_pole == 2 && $one_properties["surely_fill"] == "yes" ) )
                         {
                          $error=1;$error_text="Ошибка с данными (динамическими, не тот тип)!";
                         }
                      }
                     else
                       {
                        if ($one_properties["control_meaning"] == 'y')
                          {
                           if ( $_POST[$name_dynamic_pole] <= $one_properties["max_numeric"] &&
                                $_POST[$name_dynamic_pole] >= $one_properties["min_numeric"] )
                            {
                             $mas_dynamic_data[]=array($num_one_properties,$_POST[$name_dynamic_pole],"numeric");
                             $mas_value_real[]=$_POST[$name_dynamic_pole];
                            }
                           else
                             {
                              $error=1;$error_text="Ошибка с данными (динамическими, число выходит за заданные пределы)!";
                             }
                          }
                         else
                           {
                            $mas_dynamic_data[]=array($num_one_properties,$_POST[$name_dynamic_pole],"numeric");
                            $mas_value_real[]=$_POST[$name_dynamic_pole];
                           }
                       }
                    break;
                  case ("list"):
                     if (isset($data_value[$_POST[$name_dynamic_pole]]) 
                       && $data_value[$_POST[$name_dynamic_pole]]["n_properties"] == $num_one_properties)
                       {
                        $mas_dynamic_data[]=array($num_one_properties,$_POST[$name_dynamic_pole],"list");
                        $mas_value_real[]=$data_value[$_POST[$name_dynamic_pole]]["name_value"];
                       }
                      else
                        {
                         if ( $is_fill_add_pole == 1 || ( $is_fill_add_pole == 2 && $one_properties["surely_fill"] == "yes" ) )
                           {
                            $error=1;$error_text="Ошибка с данными (динамическими, не найдено значение)!";
                           }
                        }
                     
                    break;
                  case ("nested_list"):
                     if (isset($data_value[$_POST[$name_dynamic_pole]]) 
                       && $data_value[$_POST[$name_dynamic_pole]]["n_properties"] == $num_one_properties)
                       {
                        $mas_dynamic_data[]=array($num_one_properties,$_POST[$name_dynamic_pole],"nested_list");
                        $mas_value_real[]=$data_value[$_POST[$name_dynamic_pole]]["name_value"];
                       }
                      else
                        {
                         if ( $is_fill_add_pole == 1 || ( $is_fill_add_pole == 2 && $one_properties["surely_fill"] == "yes" ) )
                           {
                            $error=1;$error_text="Ошибка с данными (динамическими, не найдено значение)!";
                           }
                        }
                     
                    break;
                  case ("list_checkbox"):
                     if (isset($_POST[$name_dynamic_pole]))
                       {
                         if (is_array($_POST[$name_dynamic_pole]))
                           {
                            foreach ($_POST[$name_dynamic_pole] as $one_value_checkbox)
                              {
                               if (isset($data_value[$one_value_checkbox]) 
                                   && $data_value[$one_value_checkbox]["n_properties"] == $num_one_properties)
                                   {
                                    $mas_dynamic_data[]=array($num_one_properties,$one_value_checkbox,"list_checkbox");
                                    $mas_value_real[]=$data_value[$one_value_checkbox]["name_value"];
                                   }
                                  else
                                    {
                                     $error=1;$error_text="Ошибка с данными (динамическими, не найдено значение)!";
                                    }
                               
                               
                              }
                           }
                          else
                            {
                             $error=1;$error_text="Ошибка с данными (динамическими, не найдено значение)!";
                            }
                       }
                     
                    break;
                 }
              }
             else
               {
                if ( $is_fill_add_pole == 1 || ( $is_fill_add_pole == 2 && $one_properties["surely_fill"] == "yes" ) )
                  {
                   $error=1;$error_text="Не все поля заполнены (динамические)!";
                  }
               }
            
            if ( $error == 1 )
              {
               break;
              }
            
           }
         
         
         
        }
      
      return (array($error,$error_text,$mas_dynamic_data,$mas_value_real));
     }
   
   function search_dynamic_data_get($num_category,$search_mas_num_lvl_category,$on_light)
     {
      
      $data_get=array();
      
      $vars_dynamic=array();
      $mas_dynamic_value_get=array();
      
      $on_data_link_pc = false;
      $mas_global_num_properties = array();
      $mas_link_pc = array();
      $data_properties = array();
      
      //$query_properties="";
      $found_param = array();
      
      //$num_category = $this->num_element_init_dynamic_data;
      //$search_mas_num_lvl_category = $this->search_mas_num_lvl_category
      
      $name_post_pole_dynamic = NAME_POST_DYNAMIC_POLE;
      $is_url_param = false;
      
      if ( $num_category && is_numeric($num_category) && $num_category > 0 )
        {
         
         //добавляем данные для поиска по динамическим полям
         
         list($on_data_link_pc,$mas_global_num_properties,$mas_link_pc,$data_properties) = $this->get_link_pc_properties_series_category($search_mas_num_lvl_category,$on_light);
         
         /*
         if ($on_data_link_pc && is_array($mas_link_pc) && sizeof($mas_link_pc) > 0)
           {
            
            $this->search_mas_global_num_properties = $mas_global_num_properties;
            $this->search_mas_link_pc = $mas_link_pc;
           }
         */
         
         if ($data_properties && is_array($data_properties) && sizeof($data_properties) > 0)
           {
            //$this->search_data_properties=$data_properties;
            
            foreach ($data_properties as $one_properties)
              {
               $num_one_properties=$one_properties["id_properties"];
               
               $name_dynamic_pole=$name_post_pole_dynamic.$num_one_properties;
               
               $is_get=false;
               $value_get="";
               if (isset($_GET[$name_dynamic_pole]) )
                 {
                  $is_get=true;
                  $is_url_param = true;
                  if ( $one_properties["type_properties"] != "list_checkbox" )
                    $value_get=trim($_GET[$name_dynamic_pole]);
                   else
                     $value_get=$_GET[$name_dynamic_pole];
                 }
               
               $data_get[$num_one_properties]=array();
               
               switch ($one_properties["type_properties"])
                 {
                  case ("text"):
                    
                    $vars_dynamic[]=$name_dynamic_pole;
                    if ( $value_get )
                      {
                       //$query_properties.=" and ( n_properties = ".$num_one_properties." and  value_properties LIKE '%".codeText($value_get)."%' ) ";
                       //$mas_dynamic_value_get[]=" and tab_dynamic.n_properties = ".$num_one_properties." and  tab_dynamic.value_properties LIKE '%".codeText($value_get)."%' ";
                       $mas_dynamic_value_get[]=" n_properties = ".$num_one_properties." and  value_properties LIKE '%".codeText($value_get)."%' ";
                       
                       $mas=array("v_get" => $value_get);
                       $data_get[$num_one_properties][0]=$mas;
                       //$this->add_param_to_link_page_search_dynam($name_dynamic_pole,$value_get);
                       $found_param[]=array($name_dynamic_pole,$value_get);
                      }
                    
                    break;
                  case ("numeric"):
                    $vars_dynamic[]=$name_dynamic_pole."_min";
                    $vars_dynamic[]=$name_dynamic_pole."_max";
                    $min_value="";
                    $max_value="";
                    $all_query="";
                    
                    if ( isset($_GET[$name_dynamic_pole."_min"] ) )
                      {
                       $is_url_param = true;
                       $min_value = $_GET[$name_dynamic_pole."_min"];
                       if ( $min_value !== "" && is_numeric($min_value) )
                         {
                          //$query_properties.=" and ( n_properties = ".$num_one_properties." and  value_properties >= ".codeText($min_value)." ) ";
                          $all_query.=" and  value_properties >= ".codeText($min_value)."  ";
                         }
                       //$this->add_param_to_link_page_search_dynam($name_dynamic_pole."_min",$min_value);
                       $found_param[]=array($name_dynamic_pole."_min", $min_value);
                      }
                    
                    if ( isset($_GET[$name_dynamic_pole."_max"] ) )
                      {
                       $is_url_param = true;
                       $max_value = $_GET[$name_dynamic_pole."_max"];
                       if ( $max_value !== "" && is_numeric($max_value) )
                         {
                          //$query_properties.=" and ( n_properties = ".$num_one_properties." and  value_properties <= ".codeText($max_value)." ) ";
                          $all_query.=" and  value_properties <= ".codeText($max_value)."  ";
                         }
                       //$this->add_param_to_link_page_search_dynam($name_dynamic_pole."_max",$max_value);
                       $found_param[]=array($name_dynamic_pole."_max", $max_value);
                      }
                    $mas=array("v_get" => $min_value);
                    $data_get[$num_one_properties][0]=$mas;
                    $mas=array("v_get" => $max_value);
                    $data_get[$num_one_properties][1]=$mas;
                    if ( $all_query )
                      {
                       //$mas_dynamic_value_get[]=" and  tab_dynamic.n_properties = ".$num_one_properties." ".$all_query;
                       $mas_dynamic_value_get[]=" n_properties = ".$num_one_properties." ".$all_query;
                      }
                    
                    break;
                  case ("list"):
                     $vars_dynamic[]=$name_dynamic_pole;
                     
                     if ($is_get && is_numeric($value_get)  &&  $value_get > 0 ) 
                       {
                        //$query_properties.=" and ( n_properties = ".$num_one_properties." and  value_properties = ".codeText($value_get)." ) ";
                        //$mas_dynamic_value_get[]=" and  tab_dynamic.n_properties = ".$num_one_properties." and  tab_dynamic.value_properties = ".codeText($value_get)."  ";
                        $mas_dynamic_value_get[]=" n_properties = ".$num_one_properties." and  value_properties = ".codeText($value_get)." ";
                        
                        $mas=array("v_get" => $value_get);
                        $data_get[$num_one_properties][0]=$mas;
                        //$this->add_param_to_link_page_search_dynam($name_dynamic_pole,$value_get);
                        $found_param[]=array($name_dynamic_pole, $value_get);
                       }
                     
                    break;
                  case ("nested_list"):
                     $vars_dynamic[]=$name_dynamic_pole;
                     
                     if ($is_get && is_numeric($value_get)  &&  $value_get > 0 ) 
                       {
                        //$query_properties.=" and ( n_properties = ".$num_one_properties." and  value_properties = ".codeText($value_get)." ) ";
                        //$mas_dynamic_value_get[]=" and tab_dynamic.n_properties = ".$num_one_properties." and  tab_dynamic.value_properties = ".codeText($value_get)."  ";
                        $mas_dynamic_value_get[]=" n_properties = ".$num_one_properties." and  value_properties = ".codeText($value_get)." ";
                        $mas=array("v_get" => $value_get);
                        $data_get[$num_one_properties][0]=$mas;
                        //$this->add_param_to_link_page_search_dynam($name_dynamic_pole,$value_get);
                        $found_param[]=array($name_dynamic_pole, $value_get);
                       }
                     
                    break;
                  case ("list_checkbox"):
                     $vars_dynamic[]=$name_dynamic_pole;
                     
                     if (isset($is_get))
                       {
                        if (is_array($value_get))
                          {
                           foreach ($value_get as $one_value_checkbox)
                             {
                              if (is_numeric($one_value_checkbox) && $one_value_checkbox > 0) 
                                {
                                 //$query_properties.=" and ( n_properties = ".$num_one_properties." and  value_properties = ".codeText($one_value_checkbox)." ) ";
                                 //$mas_dynamic_value_get[]=" and tab_dynamic.n_properties = ".$num_one_properties." and  tab_dynamic.value_properties = ".codeText($one_value_checkbox)."  ";
                                 $mas_dynamic_value_get[]=" n_properties = ".$num_one_properties." and  value_properties = ".codeText($one_value_checkbox)."  ";
                                 $mas=array("v_get" => $one_value_checkbox);
                                 $data_get[$num_one_properties][]=$mas;
                                 //$this->add_param_to_link_page_search_dynam($name_dynamic_pole."[]",$one_value_checkbox);
                                 $found_param[]=array($name_dynamic_pole."[]", $one_value_checkbox);
                                }
                              
                             }
                          }
                        
                       }
                     
                    break;
                 }
               
              }
            
           }
         
        }
      
      //$this->search_data_properties=$data_properties;
      //$this->search_mas_global_num_properties = $mas_global_num_properties;
      //$this->search_mas_link_pc = $mas_link_pc;
      /*
        if ( $query_properties )
          {
           $this->search_part_query_db_dynamic_data=$query_properties;
          }
      */
      /*
      $this->search_get_vars_dynamic = $vars_dynamic;
      $this->search_find_get_dynamic_data = $data_get;
      $this->mas_query_data_dynamic_search=$mas_dynamic_value_get;
      */
      
      return (array($on_data_link_pc,$mas_link_pc,$mas_global_num_properties,$data_properties,$vars_dynamic,$data_get,$mas_dynamic_value_get,$found_param,$is_url_param));
     }
   
   
  }


function sort_properties($a,$b)
  {
   if ($a["num_pos"]==$b["num_pos"]) return 0;
   return (($a["num_pos"] > $b["num_pos"])?1:-1);
  }












