<?php


class eng_wishlist_ishop
{
  
  static protected $name_cookie = "ishop_wishlist";
  
  static protected $d_time_check = 10;// в минутах
  
  static protected $on_init = false;
  
  static protected $on_cache_data = false;
  static protected $data_wishlist = [];
  
  static protected $max_number = 70;//максимальное количество записей в избранном
  
  function __construct()
    {
      
    }
  
  public static function init_data()
    {
      
      $mas_num_product=[];
      $data_wishlist=[];
      
      $on_check_actual = false;
      
      list($mas_num_product,$data_wishlist)=self::_proc_store_get();
      //write_log_cms($mas_num_product,"ishop wishlist mas num first");
      //write_log_cms($data_wishlist,"ishop wishlist data first");
      
      if (!self::$on_init)
        {
          self::$on_init=true;
          
          $on_save=false;
          $mas_num_new=[];
          $clear_cookie=false;
          
          $last_time = $data_wishlist["last_time"] ?? 0;
          
          if (!$last_time || (($last_time + self::$d_time_check * 60) < $GLOBALS["timeGlobal"]))
            {
              $on_check_actual = true;
              //write_log_cms("on_check","wishlist ishop check actual");
            }
          
          
          if ($GLOBALS["user_to_site"])
            {
              // проверяем данные в куках, если есть то добавляем в БД
              
              list($mas_num_more, $_last_time) = self::_get_data_not_auth();
              //write_log_cms($mas_num_more,"mas num more (not auth) wishlist ishop");
              if ($mas_num_more && sizeof($mas_num_more) > 0)
                {
                  $mas_new = array_merge($mas_num_more,$mas_num_product);
                  //write_log_cms($mas_new,"mas new merge");
                  $mas_new = array_values(array_unique($mas_new));
                  //write_log_cms($mas_new,"mas new unique merge");
                  
                  if (sizeof($mas_new) > self::$max_number)
                    {
                      $mas_new = array_slice($mas_new, 0, self::$max_number);
                      //write_log_cms($mas_new, "mas num product обрезанный до заданной длины");
                    }
                  
                  $mas_num_product = $mas_new;
                  
                  $on_check_actual = true;
                  $on_save = true;
                  
                  //$data_wishlist["mas_num"] = $mas_num_product;
                  
                  //self::proc_store("set", $mas_num_product, $data_wishlist);
                  //list($mas_num_product, $data_wishlist) = self::proc_store("get", false, false);
                  
                  // удаляем данные из куки (очищаем и удаляем куку)
                  $clear_cookie=true;
                  //self::_save_data_not_auth([]);
                  
                }
            }
    
          if ($on_check_actual)
            {
              if (sizeof($mas_num_product) > 0)
                {
                  $mas_num_new = self::_get_data_product_mas_num($mas_num_product);
                  //write_log_cms($mas_num_new, "ishop wishlist mas num update");
                  
                  $mas_num_product = $mas_num_new;
                  $mas_num_product = array_intersect($mas_num_product, $mas_num_new);//Сохраняем порядок id товаров, как были добавлены
                  //write_log_cms($mas_num_product, "ishop wishlist mas num new2 update");
                  
                  $on_save=true;
                  
                  //$data_wishlist["mas_num"] = $mas_num_product;
                  //self::proc_store("set", $mas_num_product, $data_wishlist);
                  
                }
              
            }
          
          if ($on_save)
            {
              self::_proc_store_set($mas_num_product,$data_wishlist);
            }
          
          if ($clear_cookie)
            {
              self::_save_data_not_auth([]);
            }
          
        }
      
      return ([sizeof($mas_num_product),$data_wishlist]);
    }
  
  public static function change_one_num($one_num,$oper)
    {
      // Функция добавит или удалит товар в избранном и возвратит $on_change (были изменения или нет), количество товаров в избранном и массив с id товаров
      // $one_num - id продукта
      // $oper - add или delete
      
      $on_change=false;
      $mas_num_product=[];
      
      if ($oper == "add")
        {
          list($on_change,$mas_num_product)=self::add_one_num($one_num);
        }
      elseif ($oper == "delete")
        {
          list($on_change,$mas_num_product)=self::delete_one_num($one_num);
        }
      
      return ([$on_change,sizeof($mas_num_product),$mas_num_product]);
    }
  
  public static function add_one_num($one_num)
    {
      // добавляем в избранное id продукта указанное в $one_num
      $on_add=false;
      $mas_num=[];
      
      self::init_data();
      
      list($mas_num_product,$data_wishlist)=self::_proc_store_get();
      
      if (!in_array($one_num, $mas_num_product))
        {
          //$mas_num_product[]=$one_num;
          array_unshift($mas_num_product,$one_num);//Добавляем id в начало массива
          
          if (sizeof($mas_num_product) > self::$max_number)
            {
              $mas_num_product=array_slice($mas_num_product,0,self::$max_number);
              //write_log_cms($mas_num_product,"mas num product wishlist обрезанный до заданной длины");
            }
          
          self::_proc_store_set($mas_num_product,$data_wishlist);
          $on_add=true;
        }
      
      $mas_num=$mas_num_product;
      
      return ([$on_add,$mas_num]);
    }
  
  public static function delete_one_num($one_num)
    {
      // удаляем из избранного id продукта указанное в $one_num
      
      self::init_data();
      
      list($mas_num_product,$data_wishlist)=self::_proc_store_get();
      
      $save = false;
      
      if ( ($num_pos = array_search($one_num,$mas_num_product)) !== false )
        {
          unset($mas_num_product[$num_pos]);
          $mas_num_product=array_values($mas_num_product);
          
          //write_log_cms($mas_num_product,"new mas wishlist id products");
          
          $save=true;
          
          self::_proc_store_set($mas_num_product,$data_wishlist);
          
        }
      
      return ([$save,$mas_num_product]);
    }
  
  protected static function ___proc_store($type,$set_mas_num,$set_data_wishlist)
    {
      // $type -> get, set (должно быть указано $set_mas_num и $set_data_wishlist)
      
      $mas_num_product=[];
      $data_wishlist=[];
      
      if ($type == "get")
        {
          $data_wishlist=array("id_wishlist"=>0, "list_num"=>"", "num_user"=>0, "last_time"=>0, "mas_num"=>array());
          
          if (self::$on_cache_data)
            {
              //write_log_cms("get cache wishlist");
              $data_wishlist=self::$data_wishlist;
              $mas_num_product=$data_wishlist["mas_num"];
            }
          else
            {
              if ($GLOBALS["user_to_site"])
                {
                  list($mas_num_product, $_data) = self::_get_data_auth();
                  if (sizeof($mas_num_product) > 0)
                    {
                      $data_wishlist = $_data;
                    }
                }
              else
                {
                  list($mas_num_product, $last_time) = self::_get_data_not_auth();
                  $data_wishlist["last_time"] = $last_time;
                  $data_wishlist["mas_num"] = $mas_num_product;
        
                }
              //write_log_cms("get no cache wishlist");
              self::$on_cache_data=true;
              self::$data_wishlist=$data_wishlist;
            }
        }
      elseif ($type == "set")
        {
          if ($GLOBALS["user_to_site"])
            {
              self::_save_data_auth($set_mas_num,$set_data_wishlist);
            }
          else
            {
              self::_save_data_not_auth($set_mas_num);
            }
          
          self::$on_cache_data=false;
        }
      
      return ([$mas_num_product,$data_wishlist]);
    }
  
  protected static function _proc_store_get()
    {
      $mas_num_product=[];
      //$data_wishlist=[];
      
      $data_wishlist=array("id_wishlist"=>0, "list_num"=>"", "num_user"=>0, "last_time"=>0, "mas_num"=>array());
      
      if (self::$on_cache_data)
        {
          //write_log_cms("get cache wishlist");
          $data_wishlist=self::$data_wishlist;
          $mas_num_product=$data_wishlist["mas_num"];
        }
      else
        {
          if ($GLOBALS["user_to_site"])
            {
              //list($mas_num_product, $_data) = self::_get_data_auth();
              $_data = self::_get_data_auth();
              if ($_data)
                {
                  $data_wishlist["id_wishlist"] = $_data["id_wishlist"];
                  $mas_num_product = explode(",", $_data["list_num"]);
                  $data_wishlist["mas_num"]=$mas_num_product;
                  $data_wishlist["last_time"] = $_data["last_time"];
                }
            }
          else
            {
              list($mas_num_product, $last_time) = self::_get_data_not_auth();
              $data_wishlist["last_time"] = $last_time;
              $data_wishlist["mas_num"] = $mas_num_product;
              
            }
          //write_log_cms("get no cache wishlist");
          self::$on_cache_data=true;
          self::$data_wishlist=$data_wishlist;
        }
      //write_log_cms($data_wishlist,"get data wishlist");
      return ([$mas_num_product,$data_wishlist]);
    }
  
  protected static function _proc_store_set($set_mas_num,$set_data_wishlist)
    {
      $mas_num_product=[];
      $data_wishlist=[];
      
      if ($GLOBALS["user_to_site"])
        {
          $id_wishlist=self::_save_data_auth($set_mas_num,$set_data_wishlist);
          self::$data_wishlist["id_wishlist"]=$id_wishlist;
          self::$data_wishlist["mas_num"]=$set_mas_num;
          self::$data_wishlist["last_time"]=$GLOBALS["timeGlobal"];
        }
      else
        {
          self::_save_data_not_auth($set_mas_num);
          self::$data_wishlist["mas_num"]=$set_mas_num;
          self::$data_wishlist["last_time"]=$GLOBALS["timeGlobal"];
        }
      
      //write_log_cms(self::$data_wishlist,"set data wishlist");
      
      return (true);
    }
  
  protected static function _get_data_auth()
    {
      // Получаем данные о товарах в избранном авторизованного пользователя (находятся в БД)
      $mas_num_product=[];
      $data_wishlist=[];
      
      $db_query = "select * from ".DB_PREF."ishop_wishlist where num_user = ".$GLOBALS["id_user_to_site"];
      list($kolvo, $data_wishlist) = db_work::query_select_one_assoc($db_query);
      /*
      $data_wishlist["mas_num"]=[];
      
      if ($kolvo > 0 && $data_wishlist["list_num"])
        {
          //write_log_cms($data_wishlist["list_num"],"ishop wishlist list num");
          $mas_num_product = explode(",", $data_wishlist["list_num"]);
          $data_wishlist["mas_num"]=$mas_num_product;
        }
      */
      return ($kolvo ? $data_wishlist : false);
    }
  
  protected static function _get_data_not_auth()
    {
      // Получаем данные о товарах в избранном неавторизованного пользователя (находятся в куках)
      $mas_num=[];
      $last_time=0;
      //$data_wishlist=[];
      
      $data_ck=$_COOKIE[self::$name_cookie] ?? "";
      
      if ($data_ck && preg_match("#^[0-9]+(\,[0-9]+)*\:[0-9]+$#", $data_ck))
        {
          $mas_v=explode(":",$data_ck);
          //write_log_cms($mas_v,"data cookie wishlist explode (:)");
          $mas_num = explode(",", $mas_v[0]);
          $last_time=$mas_v[1];
        }
      
      return ([$mas_num,$last_time]);
    }
  
  protected static function _save_data_auth($mas_num,$data_wishlist)
    {
      // Сохраняем данные о товарах в избранном авторизованного пользователя (в БД)
      
      $id_wishlist=0;
      
      if (sizeof($mas_num) > 0)
        {
          $type_create="new";
          
          if ($data_wishlist && is_array($data_wishlist) && $data_wishlist["id_wishlist"] > 0)
            {
              $type_create="edit";
            }
          
          $save_data = array(
            "id_wishlist" => ($type_create == "edit" ? $data_wishlist["id_wishlist"] : 0),
            "list_num" => implode(",", $mas_num),
            "num_user" => $GLOBALS["id_user_to_site"],
            "last_time" => $GLOBALS["timeGlobal"]
          );
          $db_query = forming_db_query_indexmas(DB_PREF."ishop_wishlist", $save_data, $type_create, "id_wishlist");
          db_work::query($db_query);
          
          if ($type_create == "new")
            {
              $id_wishlist=db_work::get_insert_id();
            }
          else
            {
              $id_wishlist=$data_wishlist["id_wishlist"];
            }
          
        }
      else
        {
          $db_query = "delete from ".DB_PREF."ishop_wishlist where num_user = ".$GLOBALS["id_user_to_site"];
          db_work::query($db_query);
        }
      
      return ($id_wishlist);
    }
  
  protected static function _save_data_not_auth($mas_num)
    {
      // Сохраняем данные о товарах в избранном неавторизованного пользователя (в куках)
      //global $dir_http;
      
      if (sizeof($mas_num) > 0)
        {
          syst_setcookie(self::$name_cookie, implode(",", $mas_num) . ":".$GLOBALS["timeGlobal"] , ["expires" => $GLOBALS["timeGlobal"] + 60 * 60 * 24 * 60, "path" => "/"]);
        }
      else
        {
          syst_setcookie(self::$name_cookie, "", ["expires" => time(), "path" => "/"]);//удаляем куку
        }
      
      return (true);
    }
  
  protected static function _get_data_product_mas_num($mas_num)
    {
      // Получаем id товаров, которые находятся в избранном, для проверки активны товары или нет
      
      global $obj_ishop;
      $t_db_query_category = $obj_ishop->get_text_db_query_part_category("product.n_category", 0);
      
      $db_query = "select id_product from ".DB_PREF."ishop_product product "
        ." where id_product IN ( ".implode(",", $mas_num)." ) "
        ." and hide = 'show' "
        .($t_db_query_category ? " and ( ".$t_db_query_category." ) " : "");
      
      list($kolvo_check, $data_new_elms) = db_work::query_select_assoc($db_query);
      $mas_num_new = select_mas1lev_2level($data_new_elms, "id_product", false);
      
      return ($mas_num_new);
    }
  
  
}
