<?php

include_once("../../../../config/config.php");
$type_rights_access = array("ishop","server","read");
include_once(DIR_ADMIN."/init_work.php");




class class_ishop_select_product
  {
   
   public $obj_mdishop_cache_category = false;
   public $rez_control_data = array();
   public $mas_inbox = array();
   public $mas_status = array();
   public $obj_ishop = false;
   public $obj_site = false;
   
   function __construct()
     {
      global $obj_ishop;
      global $obj_site;
      $this->obj_ishop = $obj_ishop;
      $this->obj_site = $obj_site;
      $this->obj_mdishop_cache_category = new mdishop_cache_category("mdishop", DIR_CACHE_DATA);
      
     }
   
   function work()
     {
      $error=0;
      $error_text="no";
      $rez="";
      
      $d_mas = $this->list_oper();
      $error = $d_mas[0];
      $error_text = $d_mas[1];
      if ( isset($d_mas[2]) ) $rez = $d_mas[2];
      
      write_ajax_answer_jc($error,$error_text,$rez);
     }
   
   function list_oper()
     {
      
      $this->check_post_data();
      if ( !($this->rez_control_data[0] && !$this->rez_control_data[1]) ) return (array(1,"Ошибка с данными!"));
      
      return ($this->select_data());
     }
   
   function check_post_data()
     {
      $mas_check = array(
        array("page","post","page","numeric",true,true,false,"",false,false,"all",1),
        array("kol_product","post","kol_product","numeric",true,true,false,"",false,false,"all",10),
        array("hide","post","hide","text",true,true,"listv","hide,show,all",false,false,"all","all"),
        //array("moder","post","moder","text",true,true,"listv","new,view,all",false,false,"all","all"),
        array("category","post","id_category","numeric",true,true,false,"",false,false,"all","0"),
        
        array("status","post","status","text",true,true,"listv","special,usual,all",false,false,"all","all"),
        
        array("list_id","post","list_id","text",true,false,"hablonrv","/^[0-9]+(\,[0-9]+)*$/is",false,false,"all",""),
        //array("list_num_user","post","list_num_user","text",true,false,"hablonrv","/^[0-9]+(\,[0-9]+)*$/is",false,false,"all",""),
        array("stext","post","stext","text",true,false,false,"",false,false,"all",""),
        array("logical_and","post","logical_and","text",true,true,"listv","on,off",false,false,"all","on"),
        array("in_stock","post","in_stock","text",true,true,"listv","all,yes,no",false,false,"all","all"),
        array("on_request","post","on_request","text",true,true,"listv","all,on,off",false,false,"all","all"),
        array("on_digital","post","on_digital","text",true,true,"listv","all,on,off",false,false,"all","all"),
        /*array("num_country","post","num_country","numeric",true,false,false,"",false,false,"all",0),
        array("num_region","post","num_region","numeric",true,false,false,"",false,false,"all",0),
        array("num_city","post","num_city","numeric",true,false,false,"",false,false,"all",0)*/
        
       );
      global $obj_control_data;
      
      $this->rez_control_data=$obj_control_data->processing_one_group($mas_check);
      $this->mas_inbox=$this->rez_control_data[3];
      $this->mas_status=$this->rez_control_data[5];
     }
   
   function select_data()
     {
      $error=0;
      $error_text="no";
      $rez="";
      
      global $obj_site,$obj_dynamic;
      
      $mas_inbox = $this->mas_inbox;
      $mas_status = $this->mas_status;
      
      $page=$mas_inbox["page"];
      $kol_to_page=$mas_inbox["kol_product"];
      $hide=$mas_inbox["hide"];
      //$moder=$mas_inbox["moder"];
      $category=$mas_inbox["id_category"];
      
      
      $status=$mas_inbox["status"];
      
      $type="all";//$mas_inbox["type"];
      
      $list_id = $mas_inbox["list_id"];
      //$list_num_user = $mas_inbox["list_num_user"];
      $stext = $mas_inbox["stext"];
      $logical_and = $mas_inbox["logical_and"];
      $in_stock = $mas_inbox["in_stock"];
      $on_request = $mas_inbox["on_request"];
      $on_digital = $mas_inbox["on_digital"];
      
      /*
      $num_country = $mas_inbox["num_country"];
      $num_region = $mas_inbox["num_region"];
      $num_city = $mas_inbox["num_city"];
      */
      $rez_data=$this->select_product_filter($page,$kol_to_page,$hide,$category,$status,
        $list_id,$stext,$logical_and,$in_stock,$on_request,$on_digital);
      
      
      $data_mas = $rez_data[1];
      $kolvo_select_product = sizeof($data_mas);
      
      //$rez = " kolvo_vsego:".$rez_data[0] . " , data: [ ".encode_gen_mas_to_jointext($data_mas,false, true )." ]" ;
      
      $mas_num_product = select_mas1lev_2level($data_mas,"id_product", false);
      
      
      $join_vdyn_data="";
      
      if (sizeof($mas_num_product) > 0)
        {
         
         $mas_dynamic_values=$obj_dynamic->selectValuesListProduct($mas_num_product);
         
         if ( sizeof($mas_dynamic_values) > 0 )
           {
            $join_vdyn_data=encode_mas_to_jointext($mas_dynamic_values);
           }
         
         
         $obj_use_files=new processing_use_files();
         
         $mas_config=array();
         $mas_config["type_element"]="files";
         $obj_use_files->set_processing("ishop",0,"edit",$mas_config);
         list($kol_files,$data_files)=$obj_use_files->select_group_data_files_mas_element("ishop",$mas_num_product);
         
         foreach ($data_mas as $key => $one_product)
           {
             $one_files=array();
             if (!empty($data_files[$one_product["id_product"]]))
               $one_files=$data_files[$one_product["id_product"]];
             $data_mas[$key]["_attached_files"]=$one_files;
           }
         
        }
      
      $rez = " kolvo_vsego:".$rez_data[0] . " , data: [ ".encode_gen_mas_to_jointext($data_mas,false, true )." ]" ;
      
      $rez = $rez . " , vdyndata:[ $join_vdyn_data ]";
      
      /*
      $data_user = array();
      $mas_num_user = ext_data_from_mas2level($data_mas,"type_user","user","num_user");
      if ( sizeof($mas_num_user) )
        {
         //$data_user = intercom_select_data_user($mas_num_user,"id_user,name_user,date_create,access_admin,operation_1");
         $data_user = $obj_site->select_data_user_to_list_id($mas_num_user,"id_user,name_user,date_create,access_admin,operation_1");
        }
      
      $rez .= ",data_user : {".encode_gen_mas_to_jointext($data_user,false, true, "assoc" )."}";
      */
      $rez .= ", timeDayProduct : ".$GLOBALS["timeDayProduct"];
      
      return (array(0,"no",$rez));
     }
   
   function select_product_filter($page,$kol_to_page,$hide,$category,$status,
     $list_id,$stext,$logical_and,$in_stock,$on_request,$on_digital)
     {
	  
      //global $obj_mdishop_cache_category;
      
      $mas_num_product=array();
      
      $where_hide=" ";$where_status=" ";
      $where_vimages=" ";$where_list_id = " ";
      $where_stext = " ";$where_in_stock=" ";$where_on_request=" ";$where_on_digital=" ";
	  
      if ($hide=="hide" || $hide=="show") $where_hide=" and product.hide='$hide' ";
      /*
      if ($moder=="new" || $moder=="view") $where_moder=" and product.moder='$moder' ";
      */
      if ($status=="special" || $status=="usual") $where_status=" and product.status_product='$status' ";
      
      if ($in_stock != "all") $where_in_stock=" and product.quantity_stock ".($in_stock == "yes"?">":"<=")." 0 ";
      if ($on_request != "all") $where_on_request=" and product.on_request='$on_request' ";
      if ($on_digital != "all") $where_on_digital=" and product.on_digital='$on_digital' ";
      /*
      if ($picked != "all") $where_picked=" and product.pick_out_product='$picked' ";
      if ($makegood != "all") $where_makegood=" and product.is_makegood='$makegood' ";
      if ($actual != "all")
        if ( $actual == "actual" )
          {
           $where_actual = " and ( product.end_putdate  >  ".$GLOBALS['timeDayProduct']." "
            ." and on_delete = 'off' ) ";
          }
         else
           {
            $where_actual = " and ( product.end_putdate  <  ".$GLOBALS['timeDayProduct']." "
              ." || on_delete = 'on' ) ";
           }
      */
      //if ($vimages != "all") $where_vimages=" and product.vimages_product='$vimages' ";
      if ( trim($list_id ) ) $where_list_id = " and id_product IN (".$list_id.") ";
      //if ( trim( $list_num_user ) || $list_num_user === "0" ) $where_list_num_user = " and num_user IN (".$list_num_user.") ";
      if ( trim( $stext ) )
        {
         /*
         $s_text = codeText( $stext );
         $where_stext = " and ( product.name_product LIKE '%".$s_text."%' or text LIKE '%".$s_text."%' "
          ." or key_words LIKE '%".$s_text."%' or email LIKE '%".$s_text."%' "
          ." or name_user LIKE '%".$s_text."%' or phone LIKE '%".$s_text."%' or site LIKE '%".$s_text."%'        ) ";
         */
         list($mas_words,$is_min) = process_text_search($stext,2,60,"=+.%$#@!'\",*(){}[]\\|/?<>",false);
         if ( sizeof( $mas_words ) )
           {
            $where_stext .= " and ( ";
            if ( $logical_and == "off" )
              {
               $sep = "";
               foreach ( $mas_words as $one_word )
                 {
                  $s_word = addcslashes(codeText($one_word),"%_");
                  $where_stext .= $sep." product.name_product LIKE '%".$s_word."%' or product.all_text LIKE '%".$s_word."%' "
                  ." or product.key_words LIKE '%".$s_word."%' "
                  ." or product.short_text LIKE '%".$s_word."%' "
                  ." or product.vendor_code LIKE '%".$s_word."%' ";
                  $sep = " or ";
                 }
              }
             else
               {
                $t_like = "";
                //$t_like .= implode("%",$mas_words);
                //$t_like = "%".codeText($t_like)."%";
                $sep = "";
                foreach ( $mas_words as $one_word )
                  {
                   $t_like .= $sep.addcslashes(codeText($one_word),"%_");
                   $sep = "%";
                  }
                $t_like = "%".$t_like."%";
                $where_stext .= " product.name_product LIKE '".$t_like."' or product.all_text LIKE '".$t_like."' "
                  ." or product.key_words LIKE '".$t_like."' "
                  ." or product.short_text LIKE '".$t_like."' "
                  ." or product.vendor_code LIKE '".$t_like."' ";
               }
            $where_stext .= " ) ";
            //var_dump($where_stext);
           }
         
         
        }
      /*
      if ( $num_country > 0 )
        {
         $where_geo = " and product.country_product = ".$num_country." ";
         if ( $num_region > 0 )
           {
            $where_geo .= " and product.region_product = ".$num_region." ";
            if ( $num_city > 0 )
              $where_geo .= " and product.city_product = ".$num_city." ";
           }
        }
      */
      $db_query="select product.*
        from ".DB_PREF."ishop_product product where ";
      $db_query_1="select count(*) 
        from ".DB_PREF."ishop_product product where ";
      $part2=" ";
      
      if ( $category > 0 )
        {
         //$mas_id_category = $obj_ishop_cache_category->get_mas_num_data($category,true);
         //$part2 .= sizeof($mas_id_category) > 0 ? " n_category IN (".implode(",",$mas_id_category).") " : "";
         $t_db_query_category = $this->obj_mdishop_cache_category->get_text_db_query_data_many_lvl("n_category", $category);
         $part2 .= $t_db_query_category ? " ( ". $t_db_query_category. " ) " : " n_category > 0 ";
        }
       else
         {
          $part2 .= " n_category > 0 ";
         }
      
      
      //$db_query.=$where_hide.$where_moder;
      $part3=" order by product.id_product DESC limit ".($page-1)*$kol_to_page.",".$kol_to_page;
      
      $kolvo_vsego = obr_db_query_count($db_query_1.$part2.$where_hide.$where_status.$where_vimages
       .$where_list_id.$where_stext.$where_in_stock.$where_on_request.$where_on_digital);
      $data_mas=array();
      
      /*
      if ( $kolvo_vsego == 0 )
        {
         return (array($kolvo_vsego,array()));
        }
      */
      if ($kolvo_vsego > 0)
        {
          list($kolvo, $data_mas) = obr_db_query_select_assoc($db_query.$part2.$where_hide.$where_status
            .$where_vimages.$where_list_id.$where_stext.$where_in_stock.$where_on_request.$where_on_digital.$part3);
          
        }
      
      return (array($kolvo_vsego,$data_mas));
	 }
   
  }

$obj_ishop_select_product = new class_ishop_select_product();
$obj_ishop_select_product->work();


