<?php


class eng_ishop_page_metka extends eng_gen_ishop_page
{
  /**
   * @var $obj_modul ishop_class
   */
  protected $obj_modul;
  
  protected $open_metka_value = "";
  protected $data_metka = array();
  
  protected $kolvo_vsego_metka = 0;
  protected $open_num_page_metka = 1;
  
  protected $name_sort = "";
  protected $type_sort = "";
  
  protected $base_url_page = "";
  
  function first_init()
    {
      $this->mas_name_copy=["name_sort","type_sort","base_url_page"];
      
      return (true);
    }
  
  function control_data()
    {
      
      global $masConfig;
      
      if ($masConfig["USE_POLE_KEY_WORDS_PRODUCT"] == 0)
        {
          return (false);
        }
      
      $this->open_metka_value = RawUrlDecode($this->mas_inbox["value"]);
      $this->openComponentIdent = $this->open_metka_value;
      
      $this->data_metka = array();
      
      $t_db_query_category = $this->obj_modul->get_text_db_query_part_category("product.n_category", 0);
      
      $db_query = "select count(*) "
        ." from ".DB_PREF."ishop_product product "
        ." where "
        .($t_db_query_category ? " ( ".$t_db_query_category." ) and " : "")
        ." product.hide='show' "
        ." and key_words LIKE '%".codeText($this->open_metka_value)."%' ";
      //." and product.end_putdate > ".$GLOBALS["timeDayProduct"]."   "
      //.$this->add_db_query_country().$this->add_db_query_region().$this->add_db_query_city();
      
      $this->kolvo_vsego_metka = obr_db_query_count($db_query);
      
      
      if ($this->status_inbox["num_page"] == "set")
        {
          $this->open_num_page_metka = $this->mas_inbox["num_page"];
          $this->openOnGetNumPage = true;
        }
      else
        {
          $this->open_num_page_metka = 1;
        }
      
      $this->openNumPage = $this->open_num_page_metka;
      
      if ($this->status_inbox["sort"] == "set")
        {
          $this->name_sort = $this->mas_inbox["sort"];
          $this->type_sort = $this->mas_inbox["tsort"];
          
        }
      
      if ($this->kolvo_vsego_metka == 0)
        {
          if ($this->open_num_page_metka != 1)
            {
              return (false);
            }
        }
      else
        {
          
          global $init_sort_ishop;
          
          $db_query = "select product.id_product,
            
            product.name_product, product.short_text, product.image, product.start_date,
            product.cost,product.status_product , product.n_category, product.currency,
            product.name_url, product.quantity_stock, product.discount_cost, product.first_cost,
            product.on_request 
            from ".DB_PREF."ishop_product product "
            ." where "
            .($t_db_query_category ? " ( ".$t_db_query_category." ) and " : "")
            ." product.hide='show' "
            ." and key_words LIKE '%".codeText($this->open_metka_value)."%' "
            //." and product.end_putdate > ".$GLOBALS["timeDayProduct"]."   "
            //.$this->add_db_query_country().$this->add_db_query_region().$this->add_db_query_city()
            ." order by "
            .($this->name_sort ? " ".$init_sort_ishop[$this->name_sort]." ".$this->type_sort." " : " sort_time DESC ")
            ." limit ".($this->open_num_page_metka - 1) * KOLVO_VIEW_SYNOPSIS_PRODUCT." , ".KOLVO_VIEW_SYNOPSIS_PRODUCT;
          
          list($kolvo, $this->data_metka) = obr_db_query_select_assoc($db_query);
          
          
          if ($kolvo == 0) return (false);
          /*
          if ( $masConfig["ON_USE_GEO_DATA"] == 1 )
            {
             global $obj_geoData;
             $obj_geoData->add_data_mas_for_extract_geo($this->data_metka,array("country_product","region_product","city_product"));
            }
          */
        }
      
      $this->base_url_page = $this->dir_http."/productmetka/".RawUrlEncode($this->open_metka_value)."/";
      
      $korekParam = true;
      
      
      return (true);
    }
  
  function forming_data()
    {
      
      global $mas_value_template, $tpl, $masConfig;
      $mas_perem = $mas_value_template;
      $mas_perem["masConfig"] = $masConfig;
      
      $t_num_page = ($this->open_num_page_metka > 1 ? " - Страница ".$this->open_num_page_metka : "");
      $this->title = 'Товары с ключевым словом '.codeHtmlText(decodeText($this->open_metka_value).$t_num_page);
      $this->title_text = 'Товары с ключевым словом &laquo;'.codeHtmlText(decodeText($this->open_metka_value).$t_num_page).'&raquo;';
      
      
      $mas_perem["kolvo_vsego_metka"] = $this->kolvo_vsego_metka;
      $mas_perem["open_num_page_metka"] = $this->open_num_page_metka;
      $mas_perem["open_metka_value"] = $this->open_metka_value;
      $mas_perem["data_row"] = $this->data_metka;
      
      
      global $init_currency, $name_base_currency;
      $mas_perem["init_currency"] = $init_currency;
      $mas_perem["name_base_currency"] = $name_base_currency;
      
      $mas_perem["dir_http_template_modul"] = $this->obj_modul->dir_http_template_modul;
      
      $mas_perem["obj_ishop"] = &$this->obj_modul;
      
      $tpl->template_dir = $this->obj_modul->dir_template_mfile."/page/";
      
      $tpl->assign($mas_perem);
      $this->text = $tpl->fetch("product_metka.html");
      
      
      return (true);
    }
  
}

