<?php


class eng_ishop_page_product extends eng_gen_ishop_page
{
  /**
   * @var $obj_modul ishop_class
   */
  protected $obj_modul;
  
  protected $kol_next_product = 0;
  protected $data_next_product = array();
  
  protected $data_select_product = array();
  protected $mas_num_lvl_category_product = array();
  
  protected $num_page_comments_product = 1;
  protected $url_product_view = "";
  protected $select_product = 0;
  
  protected $open_num_category = 0;
  protected $open_num_podcategory = 0;
  protected $select_category = 0;
  protected $select_podcategory = 0;
  
  protected $data_open_category = 0;
  protected $data_open_podcategory = 0;
  
  protected $num_open_lvl_category = 0;
  protected $data_block_navigation = [];
  protected $open_num_product = 0;
  
  function first_init()
    {
      $this->mas_name_copy=["open_num_category","open_num_podcategory","num_open_lvl_category",
       "data_open_category","data_open_podcategory" /*,"on_noindex_page"*/];
      
      $this->data_block_navigation = &$this->obj_modul->data_block_navigation;
      
      return (true);
    }
  
  function control_data()
    {
      
      $this->kol_next_product = 0;
      $this->data_next_product = array();
      
      $this->mas_num_lvl_category_product = array();
      
      $this->num_page_comments_product = 1;
      
      $data_previous_product = array();
      
      $mas_list_num = array();
      
      $db_query = "select * from ".DB_PREF."ishop_product where id_product=".$this->mas_inbox["id_product"]." and hide='show' ";//" and end_putdate>".$GLOBALS["timeDayProduct"];
      list($kolvo_product, $this->data_select_product) = obr_db_query_select_one_assoc($db_query);
      
      if ($kolvo_product == 0)
        {
          return (false);
        }
      
      $on_redirect = false;
      $name_url_product = $this->obj_modul->forming_name_url_product($this->data_select_product);
      
      
      global $masConfig;
      
      if ($this->status_inbox["name_product"] == "set")
        {
          $t_url_product = $this->mas_inbox["name_product"];
          
          if ($t_url_product !== $name_url_product) $on_redirect = true;
          
        }
      else
        {
          $on_redirect = true;
        }
      
      
      $this->url_product_view = $this->dir_http."/".$name_url_product."-prod".$this->mas_inbox["id_product"].".html";
      
      if ($on_redirect)
        {
          header("Location: ".$this->url_product_view, true, 301);
          exit ();
        }
      
      
      $this->select_product = $this->mas_inbox["id_product"];
      $id_podcat = $this->data_select_product["n_category"];
      
      
      //if ( empty($this->mas_podcategory[$id_podcat]) ) return;
      
      $mas_serias_lvl_num_category = $this->obj_modul->serias_lvl_num_category($id_podcat);
      if (!$mas_serias_lvl_num_category) return (false);
      
      $mas_list_num = $mas_serias_lvl_num_category;
      
      
      $this->mas_num_lvl_category_product = $mas_serias_lvl_num_category;
      $kolvo_lvl = sizeof($mas_serias_lvl_num_category);
      
      $this->select_podcategory = $kolvo_lvl > 1 ? $mas_serias_lvl_num_category[$kolvo_lvl - 1] : 0;//$this->mas_podcategory[$id_podcat]["id_category"];
      $this->select_category = $mas_serias_lvl_num_category[0];//$this->mas_podcategory[$id_podcat]["n_category"];
      
      $this->open_num_podcategory = $this->select_podcategory;
      $this->open_num_category = $this->select_category;
      
      $this->data_open_category = $this->obj_modul->obj_cache_category->get_one_num_data($this->open_num_category);
      if ($this->open_num_podcategory > 0)
        {
          $this->data_open_podcategory = $this->obj_modul->obj_cache_category->get_one_num_data($this->open_num_podcategory);
        }
      
      $this->num_open_lvl_category = $this->open_num_podcategory > 0 ? $this->open_num_podcategory : $this->open_num_category;
      
      $this->data_block_navigation["num_lvl_category"] = $this->num_open_lvl_category;
      if ($this->open_num_podcategory > 0)
        {
          $this->data_block_navigation["data_open_lvl_category"] = $this->data_open_podcategory;
        }
      else
        {
          $this->data_block_navigation["data_open_lvl_category"] = $this->data_open_category;
        }
      
      //$this->data_block_navigation["data_lvl_podcategory"]=$this->get_mas_nested_category($this->num_open_lvl_category);
      $this->data_block_navigation["series_num_lvl_category"] = $mas_serias_lvl_num_category;
      
      $url_part_category = "";
      if ($this->open_num_category > 0)
        {
          if ($this->open_num_podcategory > 0)
            {
              $url_part_category = "/".$this->obj_modul->forming_name_url_category($this->open_num_podcategory, 'inferior');
            }
          else
            {
              $url_part_category = "/".$this->obj_modul->forming_name_url_category($this->open_num_category, 'high');
            }
        }
      $this->data_block_navigation["url_part_category"] = $url_part_category;
      
      
      if ($this->obj_modul->on_view_quantity_product_category)
        {
          $mas_series_num_category = $this->obj_modul->serias_lvl_num_category($this->num_open_lvl_category);
          //$mas_num_nested_category=$this->obj_cache_category->get_mas_num_nested_data($this->num_open_lvl_category, false);
          $mas_num_get_quantity = $mas_series_num_category;//array_merge($mas_series_num_category,$mas_num_nested_category);
          
          $this->data_block_navigation["quantity_product_category"] = $this->obj_modul->obj_cache_db->get_quantity_product_mas_num_category($mas_num_get_quantity, $this->obj_modul->user_view_country, $this->obj_modul->user_view_region, $this->obj_modul->user_view_city);
        }
      
      $this->obj_modul->addKolOpenProduct($this->select_product);
      
      //дополнительные товары на странице просмотра товара
      
      $kolvo_addit = KOLVO_ADDITIONALLY_PRODUCT;
      $kolvo_next_ext = $kolvo_addit;
      $kolvo_previous_ext = $kolvo_addit;
      
      $db_query = "select * from ".DB_PREF."ishop_product product where id_product>".$this->select_product
        ." and hide='show' and n_category=".$id_podcat
        ." and (product.quantity_stock > 0 || product.on_request = 'on' ) "
        ." order by id_product ASC limit ".(2 * $kolvo_addit);
      
      list($kolvo_next, $data_next) = obr_db_query_select_assoc($db_query);
      $data_next = array_reverse($data_next, false);
      
      $db_query = "select * from ".DB_PREF."ishop_product product where id_product<".$this->select_product
        ." and hide='show' and n_category=".$id_podcat
        ." and (product.quantity_stock > 0 || product.on_request = 'on' ) "
        ." order by id_product DESC limit ".(2 * $kolvo_addit);
      list($kolvo_previous, $data_previous) = obr_db_query_select_assoc($db_query);
      
      if ($kolvo_next < $kolvo_addit)
        {
          $kolvo_next_ext = $kolvo_next;
          $del = $kolvo_addit - $kolvo_next;
          if ($kolvo_previous > $del + $kolvo_addit)
            {
              $kolvo_previous_ext = $del + $kolvo_addit;
            }
          else
            {
              $kolvo_previous_ext = $kolvo_previous;
            }
        }
      elseif ($kolvo_previous < $kolvo_addit)
        {
          $kolvo_previous_ext = $kolvo_previous;
          $del = $kolvo_addit - $kolvo_previous;
          if ($kolvo_next > $del + $kolvo_addit)
            {
              $kolvo_next_ext = $del + $kolvo_addit;
            }
          else
            {
              $kolvo_next_ext = $kolvo_next;
            }
        }
      
      if ($kolvo_next_ext > 0) $this->data_next_product = array_slice($data_next, -$kolvo_next_ext, $kolvo_next_ext);
      if ($kolvo_previous_ext > 0) $this->data_next_product = array_merge($this->data_next_product, array_slice($data_previous, 0, $kolvo_previous_ext));
    
      $this->kol_next_product = sizeof($this->data_next_product);
      
      /*
      if (ON_COMMENTS_PRODUCTS == 1)
        {
         //проверим данные комментариев
         if ( $this->status_inbox["num_page_comment"] == "set" )
           {
            $num_page_comment = $this->mas_inbox["num_page_comment"];
            if ( $num_page_comment > 0 )
              $num_page_comment = (int) round($num_page_comment);
             else
               $num_page_comment = 1;
            $this->num_page_comments_product = $num_page_comment;
           }
         global $obj_site;
         $obj_site->save_data_comments($this->num_page_comments_product,"ishop",$this->select_product,"pcomad", $this->data_select_product["on_comments"] == "on" ? true : false ,  true  );
        }
      */
      $this->open_num_product = $this->select_product;
      $this->openComponentIdent = $this->open_num_product;
      $korekParam = true;
      
      
      $this->openNsrlKeyComponent = "5";
      $this->openNsrlComponentIdent = (sizeof($mas_list_num)) ? $mas_list_num : 0;
      
      $this->openNsrlPageOnRelative = true;
      
      //добавляем товар (id товара) в список просмотренных пользователем
      //$this->historylist_oper($this->select_product,"add");
      eng_historylist_ishop::change_one_num($this->select_product, "add");
      
      
      return (true);
    }
  
  function forming_data()
    {
      
      global $obj_site, $init_currency, $dir_http;
      
      global $mas_value_template, $tpl, $masConfig;
      $mas_perem = $mas_value_template;
      $mas_perem["masConfig"] = $masConfig;
      
      $row = $this->data_select_product;
      $this->title = codeHtmlText(trim($row["teg_title"]) ? $row["teg_title"] : $row["name_product"]);
      
      $name_category = "";
      
      
      $mas_links = $this->obj_modul->forming_mas_links_series_category_from_num($this->open_num_podcategory > 0 ? $this->open_num_podcategory : $this->open_num_category);
      $sep = "";
      foreach ($mas_links as $one_link)
        {
          $name_category .= $sep.$one_link["name"];
          $sep = ", ";
        }
      
      if ($this->num_open_lvl_category > 0)
        {
          
          $this->mas_navigation_pointer[] = array("Все товары",
            $dir_http.$this->data_block_navigation['url_part_geo'].'/allproduct/'
          );
          //$mas_links = $this->forming_mas_links_series_category_from_num($this->num_open_lvl_category);
          $kolvo_links = sizeof($mas_links);
          for ($i = 0; $i < $kolvo_links; $i++)
            {
              $one_link = $mas_links[$i];
              $this->mas_navigation_pointer[] = array($one_link["name"], $one_link["link"]);
            }
          
          $this->mas_navigation_pointer[] = array($row["name_product"], false);
        }
      
      
      $this->keywords = codeHtmlText($row["meta_keywords"]);
      $this->description = codeHtmlText($row["meta_description"]);
      
      $this->title_text = codeHtmlText($row["name_product"]);
      
      
      $mas_images = array();
      
      if ($row["image"])
        {
          $mas_images = explode("|", $row["image"]);
        }
      
      global $domen_site_url, $url_site;
      $domen_url = PROTOCOL_URL_CMS."://".$domen_site_url;
      
      $this->obj_modul->schema_data_ogp[] = array("title", $row["name_product"]);
      $this->obj_modul->schema_data_ogp[] = array("description", $row["short_text"]);
      $this->obj_modul->schema_data_ogp[] = array("url", $domen_url.$this->url_product_view);
      $this->obj_modul->schema_data_ogp[] = array("type", "website");
      $this->obj_modul->schema_data_ogp[] = array("image",
        sizeof($mas_images) ? $url_site."/".NAME_DIR_LOADFILES_MODULS."/ishop/bigfoto/".$mas_images[0] : $domen_url.$this->dir_http."/images/default_ogp.png"
      );
      
      $mas_perem["row"] = $row;
      
      
      //$data_dynamic = "";
      $mas_properties = array();
      
      //выводим динамические данные
      global $obj_dynamic;
      
      //$mas_properties = $obj_dynamic->get_dynamic_data_product($this->select_podcategory,$this->select_product);
      $mas_properties = $obj_dynamic->get_dynamic_data_product_many_lvl_category($this->mas_num_lvl_category_product, $this->select_product);
      
      
      //$mas_perem["data_dynamic"] = $data_dynamic;
      $mas_perem["mas_properties"] = $mas_properties;
      
      
      //$mas_perem["data_cat_podcat_to_product"] = $this->data_cat_podcat_to_product;
      $mas_perem["select_podcategory"] = $this->select_podcategory;
      
      
      $kol_product_user = 0;
      $mas_name_user = array();
      
      
      $mas_perem["mas_name_user"] = $mas_name_user;
      $mas_perem["kol_product_user"] = $kol_product_user;
      
      
      $mas_perem["select_product"] = $this->select_product;
      
      
      $mas_perem["kol_next_product"] = $this->kol_next_product;
      $mas_perem["data_next_product"] = $this->data_next_product;
      
      $mas_data_object = false;
      
      $mas_perem["mas_data_object"] = $mas_data_object;
      
      
      //Данные сопутствующих товаров (аксессуаров и т. п.)
      $kolvo_prods_link = 0;
      $mas_prods_link = [];
      $words_link = trim($row["words_link"]);
      $max_kolvo_prods_link = 6;
      
      if ($words_link)
        {
          
          $mas_words_link = explode(",", $words_link);
          
          $sep = "";
          $sep_relev = "";
          
          $part_relev = "";
          $part_text = " and ( ";
          $on_query = false;
          foreach ($mas_words_link as $one_key_w)
            {
              $one_key_w = trim($one_key_w);
              if (mb_strlen($one_key_w) < 3) continue;
              $part_text .= $sep."(words_descriptor LIKE '%".codeText($one_key_w)."%') ";
              //  ." or name_product LIKE '%".codeText($one_key_w)."%'";
              
              //$part_relev .= $sep_relev . "";
              $sep = " or ";
              $on_query = true;
            }
          $part_text .= ")";
          
          if ($on_query)
            {
              $t_db_query_category = $this->obj_modul->get_text_db_query_part_category("product.n_category", 0);
              
              $db_query = "select * from ".DB_PREF."ishop_product product "
                ." where id_product != ".$row["id_product"]." "
                ." and hide='show' ".($t_db_query_category ? " and (".$t_db_query_category.") " : "")
                .$part_text
                ." order by id_product DESC limit ".$max_kolvo_prods_link;
              
              //write_log_cms($db_query,"дополнительные товары");
              list($kolvo_prods_link, $mas_prods_link) = db_work::query_select_assoc($db_query);
              //write_log_cms($kolvo_prods_link,"количество дополнительных товаров");
            }
        }
      
      
      $mas_perem["kolvo_prods_link"] = $kolvo_prods_link;
      $mas_perem["mas_prods_link"] = $mas_prods_link;
      
      
      $all_kolvo_comments = 0;
      if (ON_COMMENTS_PRODUCTS == 1)
        {
          //выводим форму комментариев
          
          //$t3.=$obj_site->print_page_comments($this->num_page_comments_product,"ishop",$this->select_product,"pcomad", $row["on_comments"] == "on" ? true : false , true, 0 );
          list($all_kolvo_comments, $hcomments) = $obj_site->get_data_comments_modul("ishop", $this->select_product, $row["on_comments"] == "on" ? true : false, true, 0);
          $this->t3 = $hcomments;
        }
      $mas_perem["all_kolvo_comments"] = $all_kolvo_comments;
      
      
      $mas_perem["obj_ishop"] = &$this->obj_modul;
      $mas_perem["init_currency"] = $init_currency;
      $mas_perem["name_base_currency"] = $this->obj_modul->name_base_currency;
      
      $mas_perem["dir_http_template_modul"] = $this->obj_modul->dir_http_template_modul;
      
      $tpl->template_dir = $this->obj_modul->dir_template_mfile."/page/";
      
      $tpl->assign($mas_perem);
      $this->text = $tpl->fetch("product.html");
      
      
      return (true);
    }
  
}

