<?php

//файл php




function set_united_name_url_mas_category_ishop($mas_category)
  {
   // функция вернет массив с новым полем united_name_url, 
   // если будет значение в поле name_url, то это значение будет присвоено полю united_name_url,
   // иначе полю united_name_url будет присвоено транслированное значение поля name
   
   foreach ($mas_category as $key => $one_category)
     {
      $value = "";
      if ( trim( $one_category["name_url"] ) )
        $value = $one_category["name_url"];
       else
         $value = encode_text_to_url_name($one_category["name"]);
      
      $mas_category[$key]["united_name_url"] = $value;
     }
   
   return ($mas_category);
  }



class ishop_cache_category extends model_cache_many_lvl_data
  {
   public function init_obj()
     {
      $this->name_model = "ishop";
      //$this->dir_cache = DIR_CACHE_DATA . "/";
      
     }
   
   public function select_data_first_level()
     {
      //данный метод должен переопределяться для конкретного объекта
      
      //формируем запрос к базе данных для получения категорий 1-го уровня.
      $mas_data_1lvl = array();
      
      $db_query="select * from ".DB_PREF."ishop_category where hide='show' and type='high' order by pos ";
      //list($kol,$mas_data_1lvl) = obr_db_query_select_assoc_index($db_query,"id_category");
      list($kol,$mas_data_1lvl) = db_work::query_select_assoc_index($db_query,"id_category",function($row){ return (self::convert_one_category($row)); } );
      
      //$mas_data_1lvl = set_united_name_url_mas_category_ishop($mas_data_1lvl);
      
      return ($mas_data_1lvl);
     }
   
   public function select_data_many_level()
     {
      //данный метод должен переопределяться для конкретного объекта
      
      //формируем запрос к базе данных для получения категорий всех уровней
      $mas_data_many_lvl = array();
      
      //$db_query="select * from ".DB_PREF."category where hide='show' and type='high' order by pos ";
      //list($kol,$mas_data_1lvl) = obr_db_query_select_assoc_index($db_query,"id_category");
      
      $db_query="select * from ".DB_PREF."ishop_category where hide='show' order by pos ";
      //list($kol,$mas_data_many_lvl) = obr_db_query_select_assoc_index($db_query,"id_category");
      list($kol,$mas_data_many_lvl) = db_work::query_select_assoc_index($db_query,"id_category",function($row){ return (self::convert_one_category($row)); });
      
      //$mas_data_many_lvl = set_united_name_url_mas_category_ishop($mas_data_many_lvl);
      
      return ($mas_data_many_lvl);
     }
   
   public function set_init_data_work()
     {
      $this->mas_init_default_value_pole = array (
        array( "icon_maps", "inheritance", array("","default") ),
        //array( "init_type_product", "inheritance", "" ),
        //array( "auto_name_product", "inheritance", array("","default") ),
        //array( "on_add_product", "inheritance", "default" ),
       );
      
     }
   
   public function convert_one_category($d_category)
     {
       
       $d_category["united_name_url"] = $d_category["name_url"] ? $d_category["name_url"] : encode_text_to_url_name($d_category["name"]);
       $d_category["id_category"]=intval($d_category["id_category"]);
       $d_category["n_category"]=intval($d_category["n_category"]);
       $d_category["pos"]=intval($d_category["pos"]);
       //write_log_cms($d_category);
       
       return ($d_category);
     }
   
   
  }


//$obj_ishop_cache_category = new ishop_cache_category("ishop", DIR_CACHE_DATA);
//$obj_ishop_cache_category->select_data_first_level();


class mdishop_cache_category extends model_cache_many_lvl_data
  {
   public function init_obj()
     {
      $this->name_model = "mdishop";
      //$this->dir_cache = DIR_CACHE_DATA . "/";
      
     }
   
   public function select_data_first_level()
     {
      //данный метод должен переопределяться для конкретного объекта
      
      //формируем запрос к базе данных для получения категорий 1-го уровня.
      $mas_data_1lvl = array();
      
      $db_query="select * from ".DB_PREF."ishop_category where type='high' order by pos ";
      //list($kol,$mas_data_1lvl) = obr_db_query_select_assoc_index($db_query,"id_category");
      list($kol,$mas_data_1lvl) = db_work::query_select_assoc_index($db_query,"id_category",function($row){ return (self::convert_one_category($row)); });
      
      //$mas_data_1lvl = set_united_name_url_mas_category_ishop($mas_data_1lvl);
      
      return ($mas_data_1lvl);
     }
   
   public function select_data_many_level()
     {
      //данный метод должен переопределяться для конкретного объекта
      
      //формируем запрос к базе данных для получения категорий всех уровней
      $mas_data_many_lvl = array();
      
      //$db_query="select * from ".DB_PREF."category where hide='show' and type='high' order by pos ";
      //list($kol,$mas_data_1lvl) = obr_db_query_select_assoc_index($db_query,"id_category");
      
      $db_query="select * from ".DB_PREF."ishop_category order by pos ";
      //list($kol,$mas_data_many_lvl) = obr_db_query_select_assoc_index($db_query,"id_category");
      list($kol,$mas_data_many_lvl) = db_work::query_select_assoc_index($db_query,"id_category",function($row){ return (self::convert_one_category($row)); });
      
      //$mas_data_many_lvl = set_united_name_url_mas_category_ishop($mas_data_many_lvl);
      
      return ($mas_data_many_lvl);
     }
   
   public function convert_one_category($d_category)
     {
       
       $d_category["united_name_url"] = $d_category["name_url"] ? $d_category["name_url"] : encode_text_to_url_name($d_category["name"]);
       $d_category["id_category"]=intval($d_category["id_category"]);
       $d_category["n_category"]=intval($d_category["n_category"]);
       $d_category["pos"]=intval($d_category["pos"]);
       //write_log_cms($d_category);
       
       return ($d_category);
     }
   
  }


/*
function sort_category_name_ishop($a,$b)
  {
   if ( $a["name"] === $b["name"] ) return 0;
   return ( ( $a["name"] > $b["name"] ) ? 1 : -1 );
  }
*/

/*
function forming_geo_part_name_url_product($data_product)
  {
   $t = "";
   
   global $masConfig;
   if ( $masConfig["ON_USE_GEO_DATA"] == 1 )
     {
      global $obj_geoData;
      $t = $obj_geoData->forming_geo_in_url_mas_data( array($data_product["country_product"],$data_product["region_product"],$data_product["city_product"]) );
     }
   
   return ($t);
  }
*/


class ishop_download_files
{
  protected $dir_files="";
  
  protected $error=0;
  protected $error_text="";
  
  function __construct()
    {
      
    }
  
  function start($num_user,$name_user,$t_param)
    {
      $this->dir_files=DIR_LOADFILES_MODULS."/ishop/files/";
      
      $mas_param=array();
      $t_param=base64_url_decode($t_param);
      
      if ( ($mas_param = $this->parse_param($t_param)) === false )
        {
          $this->error=1;
          $this->error_text="Ошибка с параметрами!";
        }
      
      if ($this->error == 0)
        {
          list($this->error, $this->error_text) = $this->work($num_user, $name_user, $mas_param);
        }
      
      return (array($this->error,$this->error_text));
    }
  
  function parse_param($str_param)
    {
      $data=false;
      
      if ($str_param && preg_match("#^([0-9]+)_([0-9]+)_([0-9]+)$#",$str_param,$matches) === 1)
        {
          if ($matches[1] != 0 && $matches[2] != 0 && $matches[3] != 0)
            {
              $data=array("num_order"=>$matches[1],"num_product"=>$matches[2],"num_file"=>$matches[3]);
            }
        }
      
      return ($data);
    }
  
  function work($num_user,$name_user,$param)
    {
      // массив $param: num_order, num_product, num_file 
      $error=0;
      $error_text="";
      
      
      $db_query="select * from ".DB_PREF."ishop_order_item where "
       ." num_order = (select id_order from ".DB_PREF."ishop_order where id_order = ".$param["num_order"]." and status='paid' and num_user = ".$num_user.") "
       ." and num_product = ".$param["num_product"]." ";
      list($kolvo_item,$data_item)=db_work::query_select_assoc($db_query);
      
      
      if ($kolvo_item == 0)
        {
          $error=1;
          $error_text="Нет доступа!";
        }
      
      if ($error == 0)
        {
          $db_query="select * from ".DB_PREF."ishop_product where id_product = ".$param["num_product"] ." and hide='show' ";
          list($kolvo_prod,$data_prod)=db_work::query_select_one_assoc($db_query);
          if ($kolvo_prod == 0)
            {
              $error=1;
              $error_text="Нет доступа к объекту!";
            }
        }
      
      $one_file=false;
      if ($error == 0)
        {
          $one_file=$this->get_info_file($num_user,$param);
          
          if (!$one_file)
            {
              $error=1;
              $error_text="Нет доступа к объекту!";
            }
        }
      
      if ($error == 0 && $one_file)
        {
          list($error,$error_text)=$this->outputs_file_client($num_user,$one_file);
        }
      
      return (array($error,$error_text));
    }
  
  function get_info_file($num_user,$param)
    {
      $one_file=false;
      
      $mas_config=array();
      
      $mas_config["max_size_file"] = -1;
      $mas_config["type_file"] = "gif|jpeg|jpg|png";
      //$mas_config["dir_tmp"] = $dir_tmp;
      //$mas_config["dir_files"]=$dir_small_images;
      //$mas_config["dir_files2"]=$dir_big_images;
      //$mas_config["type_create"]="tosize";
      //$mas_config["type_create2"]="resize";
      //$mas_config["img_width"]=MAX_WIDTH_ICON_INTSHOP;
      //$mas_config["img_height"]=MAX_HEIGHT_ICON_INTSHOP;
      //$mas_config["img_width2"]=MAX_WIDTH_INTSHOP;
      //$mas_config["img_height2"]=MAX_HEIGHT_INTSHOP;
      $mas_config["dir_http"]="";
      $mas_config["dir_http2"]="";
      $mas_config["type_element"]="files";
      
      
      $obj_use_files=new processing_use_files();
      $obj_use_files->set_processing("ishop",0,"edit",$mas_config);
      list($kol_files,$data_files)=$obj_use_files->select_data_files_from_db("ishop",$param["num_product"]);
      
      if ($kol_files > 0)
        {
          list($on_search,$key_search)=search_mas_2level($data_files,"id_files",$param["num_file"],false);
          if ($on_search)
            {
              $one_file=$data_files[$key_search];
            }
        }
      
      return ($one_file);
    }
  
  function outputs_file_client($num_user,$one_file)
    {
      $path_file = $this->dir_files. $one_file["namefile1"];
      
      if (!file_exists($path_file))
        {
          return (array(1,"Ошибка - файл не обнаружен на сервере!"));
        }
      
      $name_file = $one_file["base_namefile1"];//basename($path_file);
      $obj_translit = new translit;
      $name_file=$obj_translit->encode($name_file);
      $name_file = str_replace(" ","_",$name_file);
      header ("Content-Type: application/octet-stream");
      header ("Accept-Ranges: bytes");
      header ("Content-Length: ".filesize($path_file));
      header ("Content-Disposition: attachment; filename=".$name_file);  
      readfile($path_file);
      
      return (array(0,""));
    }
  
}
