<?php



class eng_service_ishop
  {
   
   static public function operationCheckServiceProduct($oper, $num_order, $param, $num_user, $only_check = false, $on_add_log_money = false, $info_payment = false)
     {
      $error = 0;
      $error_text = "";
      
      //проверяем данные в массиве $mas_data
      if ( !is_numeric($num_order) )
        {
         return ( array(1,"ошибка с инициализационными данными") );
        }
      /*
      if ( is_numeric($oper) )
        {
         $oper = self::get_name_type_oper($oper);
        }
      */
      if ($oper !== "buy")
        {
         return ( array(1,"ошибка с инициализационными данными"));
        }
      
      if ( !$only_check && $error == 0 )
        {
         list($error,$error_text) = self::operationServiceProduct( $num_order, $oper, $on_add_log_money, $info_payment );
        }
      
      return (array($error,$error_text));
     }
   
   static public function select_order($num_order)
     {
	  
      $db_query="select * from ".DB_PREF."ishop_order where id_order = $num_order ";
      list($kol,$data)=obr_db_query_select_one_assoc($db_query);
      
      return ($kol ? $data : false);
	 }
   
   static public function operationServiceProduct($num_order, $operation, $on_add_log_money = false, $info_payment = false)
     {
      global $masConfig,$obj_ishop;
      $error = 0;
      $error_text = "";
      $data_order=self::select_order($num_order);
      
      $t_description = "";
      $set_info_payment = array();
      
      if ($data_order)
        {
         $result_query=false;
         
         switch ( $operation )
           {
            case ("buy"):
              
              $db_query="update ".DB_PREF."ishop_order set pay_date=".$GLOBALS["timeGlobal"]." , status='paid'  where id_order = ".$num_order;
              $q_ident = obr_db_query($db_query);
              $t_description = "Оплата заказа №".$num_order;
              
              self::send_message_admin($num_order,$data_order["amount_paid"]);
              
              $obj_ishop->decrement_quantity_stock($data_order,"one_data");
              
              break;
           }
         
         
        }
       else
         {
          $error=1;$error_text="заказ не найден";
         }
      
      if ( $t_description ) $set_info_payment["description"] = $t_description;
      
      if ( $info_payment && is_array( $info_payment ) )
        {
         $set_info_payment = array_merge( $info_payment, $set_info_payment );
        }
      
      if ( $error == 0 && $on_add_log_money )
        {
         
         eng_money_user::add_item_log($set_info_payment);
         
        }
      
      return (array($error,$error_text, $set_info_payment ));
     }
   
   
   static public function infoServiceProduct($mas_data)
     {
      $error = 0;
      $error_text = "";
      
      global $masConfig,$obj_ishop, $dir_http;
      
      //$info = "";
      $t_description = "";
      $cost = 0;
      $kolvo_day = 0;
      
      $db_query="select * from ".DB_PREF."ishop_order where id_order=".$mas_data["number"];//." and hide='show' and end_putdate>".$GLOBALS["timeGlobal"];
      list($kolvo_order,$data_order) = obr_db_query_select_one_assoc($db_query);
      $url_product = "";
      $name_product = "";
      
      if ( $kolvo_order == 0 )
        {
         $error = 1;
         $error_text = "Неверные данные платежа!";
        }
      
      if ( $error == 0 )
        {
         $cost=$data_order["amount_paid"];
         $t_description="Оплата заказа №".$data_order["id_order"];
         
        }
      
      return ( array($error, $error_text, $t_description, $cost, $kolvo_day) );
     }
   
   static function get_name_type_oper($num_type)
     {
      $name = "";
      
      switch ( $num_type )
        {
         case (1): $name = "buy";break;
         
        }
      
      return ($name);
     }
   /*
   static public function get_data_type_proc($type_proc)
     {
      global $masConfig;
      
      $cost=0;
      $name="";
      $num_day=0;
      
      switch ($type_proc)
        {
         
         case("buy"):
          $cost = $masConfig["COST_VIP_ADD_product"];
          $num_day = $masConfig["NUM_DAY_VIP_ADD_product"];
          $name = $masConfig["DESC_PAYMENT_VIP_ADD_product"];
          break;
         
        }
      
      return (array("cost"=>$cost,"name"=>$name,"num_day"=>$num_day));
     }
   */
   
   static public function send_message_admin($num_order,$amount_paid)
     {
      global $url_site,$init_base_currency,$init_currency,$init_use_currency;
      $name_base_currency=(sizeof($init_use_currency) > 0 ? ( isset($init_currency[$init_base_currency]) ? $init_currency[$init_base_currency][1] : "" ) :"");
      
      // отправляем сообщение админисрации
      $subject = "Оповещение об оплаченном заказе!";
      $message = 'Здравствуйте!<br /><br />На вашем сайте '.$url_site.' оплачен заказ №'.$num_order.'.<br />';
      $message .= 'Сумма заказа: '.$amount_paid.' '.$name_base_currency;
      /*
      $message .= "Данные пользователя: <br>";
      if ( $data_user )
        {
         $message .= "ID пользователя: ".$data_user["id_user"]."<br>";
         $message .= "Логин: ".$data_user["name_user"]."<br>";
         $message .= "Пароль: ".$data_user["email_user"]."<br>";
        }
       else
         {
          $message .= "Пользователь не найден в базе данных.";
         }
      */
      
      $message .= forming_signature_email();
      
      send_email($subject,$message,"Администрация сайта",EMAIL_ADMIN);
      
     }
   
  }





