<?php

include_once("../../../config/config.php");
include_once(DIR_CMS."/generalscript/init_work_st.php");

//require_once(DIR_CMS."/generalscript/proc_promocode.php");

$error=0;$error_text="no";
$rez="";



class proc_basket
{
  protected $num_user = 0;
  protected $on_user = false;
  protected $name_user_authoriz=false;
  protected $data_auth_user=false;
  
  protected $quantity_basket = 0;
  protected $data_basket = array();
  protected $data_promocode = array();
  
  protected $type="";
  
  protected $obj_registr_user=false;
  
  function __construct()
    {
      
    }
  
  function start()
    {
      $error=0;
      $error_text="";
      
      $this->check_auth_user();
      
      $this->type = ($_POST["type"] ?? "");
      $data=false;
      
      if ($this->type == "calc")
        {
          list($error,$error_text,$data)=$this->calc();
        }
      elseif ($this->type == "add_promocode")
        {
          list($error,$error_text,$data)=$this->add_promocode();
        }
      elseif ($this->type == "delprod")
        {
          list($error,$error_text,$data)=$this->delete_one_product();
        }
      elseif ($this->type == "new_order")
        {
          list($error,$error_text,$data)=$this->save_new_order();
        }
      else
        {
          $error = 1;
          $error_text = "Ошибка с параметрами!";
        }
      $rez="";
      
      if ($data)
        $rez="data:{".encode_gen_mas_to_jointext($data,false,true)."} ";
      
      return ([$error,$error_text,$rez]);
    }
  
  function check_auth_user()
    {
      if ($GLOBALS["user_to_site"] && $GLOBALS["id_user_to_site"] > 0)
        {
          $this->num_user = $GLOBALS["id_user_to_site"];
          $this->name_user_authoriz = $GLOBALS["name_user_to_site"];
          $this->data_auth_user = $GLOBALS["data_authorize_user"];
          $this->on_user = true;
        }
    }
  
  function get_data_basket()
    {
      //global $obj_ishop;
      //list($this->quantity_basket,$this->data_basket,$this->data_promocode)=$obj_ishop->basket_get_data();
      list($this->quantity_basket,$this->data_basket,$this->data_promocode)=eng_basket_ishop::get_data();
    }
  
  function calc()
    {
      $this->get_data_basket();
      $error = 0;
      $error_text = "";
      
      list($error,$error_text,$data_basket)=$this->get_renew_data();
      
      if ($error != 0) return (array($error,$error_text,false));
      
      
      $data=$this->get_calc_data_basket($data_basket,$this->data_promocode,true);
      
      return (array($error,$error_text,$data));
    }
  
  function get_calc_data_basket($data_basket,$data_promocode,$on_save=false)
    {
      global $obj_ishop;
      /*list($data_basket,
         $data_comb_basket,
         $data_product,
         $all_cost,
         $calc_cost,
         $sum_discount,
         $on_sum_discount,
         $all_digital,
         $quantity_basket_not,
         $quantity_basket_is,
         $quantity_basket_cost_not_v,
         $quantity_basket_on_request,
         
         $t_list_prods,
         $on_save_basket)*/
      $d_calc=$obj_ishop->basket_calc_data($data_basket,$data_promocode,$on_save);
      
      $data=$d_calc;/*array(
       "data_basket"=>$data_basket,
       "data_comb_basket"=>$data_comb_basket,
       //"data_product"=>$data_product,
       "all_cost"=>$all_cost,
       "calc_cost"=>$calc_cost,
       "sum_discount"=>$sum_discount,
       "on_sum_discount"=>$on_sum_discount,
       "all_digital"=>$all_digital,
       "quantity_basket_not"=>$quantity_basket_not,
       "quantity_basket_is"=>$quantity_basket_is,
       "quantity_basket_cost_not_v"=>$quantity_basket_cost_not_v,
       "quantity_basket_on_request"=>$quantity_basket_on_request,
       );*/
      unset($data["data_product"]);
      
      return ($data);
    }
  
  function get_renew_data()
    {
      $error = 0;
      $error_text = "";
      
      $new_data_basket=array();
      
      global $obj_control_data;
      
      $mas_init=array(
        //array("num_product","post","num_product","numeric:int:positive",true,true,false,""),
        array("contr_code","post","contr_code","text",true,true,false,"",false,false,false,false,"Не указан ключ безопасности!",true,false),
       );
      
      $rez_control_data = $obj_control_data->processing_one_group($mas_init);
      
      if ( $rez_control_data[0] && !$rez_control_data[1] )
        {
          $mas_inbox = $rez_control_data[3];
          
          if ( !eng_promote_safety::check_code($GLOBALS["id_user_to_site"],$mas_inbox["contr_code"]) )
            {
              $error=1;
              $error_text="Неверный ключ безопасности!";
            }
        }
       else
         {
           $error=1;
           $error_text="Ошибка с данными";
         }
      
      if ($error == 0 && !empty($_POST["bsk_prd_quantity"]) && is_array($_POST["bsk_prd_quantity"]) && sizeof($_POST["bsk_prd_quantity"]) > 0
        && sizeof($_POST["bsk_prd_quantity"]) == $this->quantity_basket
        )
        {
          $new_quantity = $_POST["bsk_prd_quantity"];
          $new_data_basket = $this->data_basket;
          
          //write_log_cms($new_quantity,"new_quantity");
          $error_calc = false;
          
          foreach ($new_quantity as $set_num_product => $v_quantity)
            {
              
              if (!is_numeric($set_num_product)) $error_calc = true;
              $new_v = trim($v_quantity);
              if (is_numeric($new_v))
                {
                  $new_v = (int)$new_v;
                }
              else
                {
                  $new_v = 1;
                }
              
              if ($new_v < 1) $new_v = 1;
              
              if (!$error_calc)
                {
                  list($on_search, $key_m) = search_mas_2level($new_data_basket, "num_product", $set_num_product, false);
                  if ($on_search)
                    {
                      $new_data_basket[$key_m]["quantity"] = $new_v;
                    }
                  else
                    $error_calc = true;
                }
              
              if ($error_calc)
                {
                  $error=1;
                  $error_text="Ошибка с данными!";
                  break;
                }
              
            }
          
        }
      
      return (array($error,$error_text,$new_data_basket));
    }
  
  function add_promocode()
    {
      global $obj_ishop,$obj_control_data;
      
      $error = 0;
      $error_text = "";
      
      $data=false;
      $all_data_basket=false;
      
      $status=1;// 1 - ошибка, 2 - услуга предоставлена
      $status_text="Услуга не предоставлена.";
      
      $v_promocode="";//(!empty($_POST["vpromocode"]) && is_string($_POST["vpromocode"]) ? trim($_POST["vpromocode"]) : "");
      
      $mas_init=array(
        array("vpromocode","post","vpromocode","text",true,false,false,"",false,"tr","all","","Не указан промокод",false,false),
        array("contr_code","post","contr_code","text",true,true,false,"",false,false,false,false,"Не указан ключ безопасности!",true,false),
       );
      
      $rez_control_data = $obj_control_data->processing_one_group($mas_init);
      
      if ( $rez_control_data[0] && !$rez_control_data[1] )
        {
          $mas_inbox = $rez_control_data[3];
          
          if ( eng_promote_safety::check_code($GLOBALS["id_user_to_site"],$mas_inbox["contr_code"]) )
            {
              $v_promocode=$mas_inbox["vpromocode"];
            }
           else
             {
               $error=1;
               $error_text="Неверный ключ безопасности!";
             }
        }
       else
         {
           $error=1;
           $error_text="Ошибка с данными!";
         }
      
      if ($error == 0)
        {
          if ($v_promocode)
            {
              $obj_proc_promocode = new classProcPromocode();
        
              list($act_error, $act_error_text, $data_promocode) = $obj_proc_promocode->check_promocode($v_promocode, "ishop", "");
        
              if ($act_error == 0)
                {
                  $service = $obj_proc_promocode->get_service_promocode($data_promocode);
            
                  $error2 = 0;
                  $error_text2 = "";
                  /*
                  list($error2, $error_text2) = $obj_proc_service_advert->operationCheckServiceAdv($mas_inbox["type_proc"], $mas_inbox["num_element"], false, false, false);
                  */
                  $one_sdiscount = $obj_ishop->basket_get_promocode_sdiscount($v_promocode, $service);
                  if ($one_sdiscount)
                    {
                      $status = 2;
                      
                      $obj_ishop->basket_add_promocode($v_promocode, $service, $data_promocode, $one_sdiscount);
                      
                    }
                  else
                    {
                      $status = 1;
                      $status_text = "Промокод не верный!";
                    }
            
                }
              else
                {
                  $status = 1;
                  $status_text = "Промокод не принят! ".$act_error_text;
                }
        
              //$rez = "data:{status: ".$status.",status_text:'".rawUrlencode($status_text)."'}";
        
        
            }
          else
            {
              //$error=1;
              //$error_text="Ошибка: не указан промокод!";
              $status = 1;
              $status_text = "Ошибка: не указан промокод!";
            }
    
    
          if ($status == 1)
            {
              $obj_ishop->basket_clear_promocode();
            }
    
          $this->get_data_basket();
          $all_data_basket = $this->get_calc_data_basket($this->data_basket, $this->data_promocode, false);
          
        }
      
      $data=array("status"=>$status,"status_text"=>$status_text,"all_data_basket"=>($all_data_basket ? $all_data_basket:""));
      
      return (array($error,$error_text,$data));
    }
  
  function delete_one_product()
    {
      global $obj_ishop,$obj_control_data;
      
      $error = 0;
      $error_text = "";
      $data=false;
      
      $mas_init=array(
        array("num_product","post","num_product","numeric:int:positive",true,true,false,""),
        array("contr_code","post","contr_code","text",true,true,false,"",false,false,false,false,"Не указан ключ безопасности!",true,false),
       );
      
      $rez_control_data = $obj_control_data->processing_one_group($mas_init);
      
      if ( $rez_control_data[0] && !$rez_control_data[1] )
        {
          $mas_inbox = $rez_control_data[3];
          
          if ( !eng_promote_safety::check_code($GLOBALS["id_user_to_site"],$mas_inbox["contr_code"]) )
            {
              $error=1;
              $error_text="Неверный ключ безопасности!";
            }
          
          if ($error == 0)
            {
              $obj_ishop->basket_delete_one_product($mas_inbox["num_product"]);
    
              $this->get_data_basket();
              $all_data_basket = $this->get_calc_data_basket($this->data_basket, $this->data_promocode, false);
              //write_log_cms($all_data_basket,"basket proc del product");
              $data = array("all_data_basket" => ($all_data_basket ? $all_data_basket : ""));
            }
        }
       else
         {
           $error=1;
           $error_text="Ошибка с данными!";
         }
      
      return (array($error,$error_text,$data));
    }
  
  
  protected function _check_active_email($v_email)
    {
      $on_active=false;
      
      $obj_tool_check_active_email = new tool_check_active_email();
      $on_active = $obj_tool_check_active_email->is_check_active_email($v_email, false);
      
      return ($on_active);
    }
  
  protected function _check_data_user()
    {
      global $obj_ishop,$obj_control_data;
      
      $error = 0;
      $error_text = "";
      $error_mas = [];
      $data_res=[];
      $data_order_user=[];
      $data_registr_user=[];
      $data_registr_user_all=[];
      
      $mas_init=array(
        //array("num_product","post","num_product","numeric:int:positive",true,true,false,""),
        //array("name_user","post","name_user","text",true,true,"hablonrv","/^[a-zA-Zа-яА-ЯёЁ0-9_ ]+$/u",true,"tr",false,false,"Не указано имя!",true,"Неверный формат имени!"),
        array("name_user","post","name_user","text",true,true,false,"",true,"tr",false,false,"Не указано имя!",true,"Неверный формат имени!"),
        array("email_user","post","email_user","text",true,true,"function","check_data_email",true,false,false,false,"Не указан Email!",true,"Неверный формат Email!"),
        array("phone_user", "post", "phone_user", "text", true, true, false, false, true, "tr", false, false, "Укажите свой телефон!", true, true),
        //array("contr_code","post","contr_code","text",true,true,false,"",false,false,false,false,"Не указан ключ безопасности!",true,false),
       );
      
      $rez_control_data = $obj_control_data->processing_one_group($mas_init);
      
      if ( $rez_control_data[0] && !$rez_control_data[1] )
        {
          $mas_inbox=$rez_control_data[3];
          
          $id_user=0;
          //$phone_user="";
          
          //Если пользователь не авторизован, то проверяем подтверждение Email (email будет использован для создания учетной записи на сайте)
          //Если пользователь авторизован, то Email будет только в заказе
          
          if (!$GLOBALS["user_to_site"])
            {
              $on_active_email = $this->_check_active_email($mas_inbox["email_user"]);
              if (!$on_active_email)
                {
                  $error = 1;
                  $error_text = "E-mail не подтвержден!";
                }
              
              //Проверяем, есть ли аккаунт с таким Email
              
              if ($error == 0)
                {
                  
                  $data_user = $this->obj_registr_user->get_user_email($mas_inbox["email_user"]);
                  //write_log_cms($data_user, "data user check");
                  
                  if ($data_user)
                    {
                      //Пользователь с таким Email есть
                      $id_user = $data_user["id_user"];
                      $data_registr_user_all=$data_user;
                    }
                  else
                    {
                      //Пользователя нет с таким Email, создаем учетную запись
                      $_param_user = ["name_user" => $mas_inbox["name_user"], "email_user" => $mas_inbox["email_user"]];
                      $_data_new_user = $this->obj_registr_user->add_new_user_quick($_param_user);//получаем [id нового пользователя, новый пароль]
                      //write_log_cms($_data_new_user, "data new user");
                      $id_user = $_data_new_user[0];
                      $data_registr_user_all=$this->obj_registr_user->get_data_one_user($id_user);
                    }
                  
                  if ($data_registr_user_all && sizeof($data_registr_user_all))
                    {
                      $data_registr_user = [
                        "id_user" => $id_user,
                        "name_user" => $data_registr_user_all["name_user"],
                        "email_user" => $data_registr_user_all["email_user"],
                        "phone_user" => $data_registr_user_all["phone_user"]
                      ];
                    }
                  
                }
              
            }
          else
            {
              $id_user = $GLOBALS["data_authorize_user"]["id_user"];
              $data_registr_user = [
                "id_user" => $id_user,
                "name_user" => $GLOBALS["data_authorize_user"]["name_user"],
                "email_user" => $GLOBALS["data_authorize_user"]["email_user"],
                "phone_user" => $GLOBALS["data_authorize_user"]["phone_user"]
              ];
            }
          
          if ($error == 0)
            {
              $data_order_user=[
                "id_user"=>$id_user,
                "name_user"=>$mas_inbox["name_user"],
                "email_user"=>$mas_inbox["email_user"],
                "phone_user"=>$mas_inbox["phone_user"]
              ];
              
            }
        }
      else
        {
          $error=1;
          $error_text="Ошибка с данными";
        }
      
      
      return (array($error,$error_text,$error_mas,$data_order_user,$data_registr_user,$data_registr_user_all));
    }
  
  function save_new_order()
    {
      global $obj_ishop,$obj_control_data;
      
      $error = 0;
      $error_text = "";
      $error_mas = [];
      $data_res = [];
      
      //$data=false;
      $this->obj_registr_user = new eng_registr_user();
      
      list($error,$error_text,$error_mas,$data_order_user,$data_registr_user,$data_registr_user_all)=$this->_check_data_user();
      //write_log_cms($data_order_user,"data user order");
      
      if ($error == 0)
        {
          
          $this->get_data_basket();
          
          //$d_calc = $obj_ishop->basket_calc_data($this->data_basket, $this->data_promocode, false);
          $d_calc = eng_basket_ishop::calc_data($this->data_basket, $this->data_promocode, false);
          
          //$d_order=$obj_ishop->basket_create_order($d_calc,$this->data_promocode);
          $d_order = eng_basket_ishop::create_order($d_calc, $this->data_promocode, $data_order_user,$data_registr_user);
          //write_log_cms($d_order,"данные create order");
          if ($d_order["check_order_error"])
            {
              $error=1;
              $error_text=$d_order["check_order_text_error"];
              $error_mas=$d_order["check_order_mas_error"];
            }
          else
            {
              if (!$GLOBALS["user_to_site"])
                {
                  //Пользователь неавторизован, авторизуем его
                  $this->obj_registr_user->quick_authorization_user($data_registr_user_all,true);
                }
            }
          
          //$data = array("status" => ($d_order["check_order_error"] ? 1 : 2), "status_text" => $d_order["check_order_mas_error"], "num_order" => $d_order["num_order"]);
          $data_res["num_order"]=$d_order["num_order"];
        }
      
      $data=["error_proc"=>$error, "error_text_proc"=>$error_text, "error_mas_proc"=>$error_mas, "data_res"=>$data_res ];
      
      
      return (array(0,"",$data));
    }
  
}


$obj_proc_basket=new proc_basket();
list($error,$error_text,$rez)=$obj_proc_basket->start();


write_ajax_answer_jc($error,$error_text,$rez);
