<?php


class ishop_class_driver extends base_ishop_class
  {
   
   var $sitemap_kolvo_group = 1000;
   
   
   
   public function sitemap_count_product()
     {
      
      $t_db_query_category = $this->obj_cache_category->get_text_db_query_data_many_lvl( "product.n_category", 0 );
      
      $db_query="select count(*) 
          from ".DB_PREF."ishop_product product 
          where  "
          .( $t_db_query_category ? " ( ".$t_db_query_category." ) and " : "" )
          ." product.hide='show' ";//." and product.end_putdate >=".$GLOBALS["timeDayProduct"]
          //." order by product.sort_time DESC ";
      
      $kolvo_all_product = db_work::query_count($db_query);
      $kolvo_group = ceil($kolvo_all_product/$this->sitemap_kolvo_group);
      
      return ( array($kolvo_all_product,$kolvo_group) );
     }
   
   public function sitemap_get_product($num_group)
     {
      
      $t_db_query_category = $this->obj_cache_category->get_text_db_query_data_many_lvl( "product.n_category", 0 );
      
      $db_query="select product.id_product as id_product, product.name_product as name_product,product.name_url" 
          //"product.country_product as country_product, product.region_product as region_product,product.city_product as city_product," 
          ." from ".DB_PREF."ishop_product product 
          where  "
          .( $t_db_query_category ? " ( ".$t_db_query_category." ) and " : "" )
          ." product.hide='show' "//." and product.end_putdate >=".$GLOBALS["timeDayProduct"]
          ." order by product.id_product DESC "
          ."limit ".($num_group*$this->sitemap_kolvo_group).", ".$this->sitemap_kolvo_group;
      list($kolvo_product,$data_product) = obr_db_query_select_assoc($db_query);
      
      return (array($kolvo_product,$data_product));
     }
   
   public function sitemap_get_info_group()
     {
      global $url_site;
      
      list($kolvo_all_product,$kolvo_group) = $this->sitemap_count_product();
      $mas_sitemap = array();
      $mas_sitemap[] = array( "loc" => $url_site."/sitemap_m_ishop_1.xml" );
      
      for ($i = 0; $i < $kolvo_group; $i++)
        $mas_sitemap[] = array( "loc" => $url_site."/sitemap_m_ishop_".($i+2).".xml" );
      
      return ($mas_sitemap);
     }
   
   public function sitemap_get_data_urls_group($num)
     {
      $error = 0;
      $error_text = "no";
      $urls = array();
      global $url_site,$masConfig;
      
      if ( $num == 1 )
        {
         //$urls[]=array("loc"=>$url_site."/newproduct/","changefreq"=>"weekly","priority"=>0.5);
         $urls[]=array("loc"=>$url_site."/allproduct/","changefreq"=>"daily","priority"=>0.8);
         //$urls[]=array("loc"=>$url_site."/search/","changefreq"=>"weekly","priority"=>0.5);
         //$urls[]=array("loc"=>$url_site."/edit/","changefreq"=>"weekly","priority"=>0.5);
         $mas_top_category = $this->obj_cache_category->get_mas_data(0,false,false);
         
         foreach ($mas_top_category as $one_top_category)
           {
            
            $url_top_category = $url_site."/allproduct/".$one_top_category["united_name_url"]."/";
            $urls[]=array("loc"=>$url_top_category,"changefreq"=>"daily","priority"=>0.8);
            $urls = array_merge($urls,$this->sitemap_forming_url_nested_category($urls,$one_top_category["id_category"],$url_top_category));
           }
         
        }
       else
         {
          list($kolvo_all_product,$kolvo_group) = $this->sitemap_count_product();
          if ( $num >= 2 && ($num - 1) <= $kolvo_group )
            {
             
             list($kolvo_product,$data_product) = $this->sitemap_get_product($num-2);
             /*
             if ( $kolvo_product > 0 && $masConfig["ON_USE_GEO_DATA"] == 1 )
               {
                //global $obj_geoData;
                $obj_geoData->add_data_mas_for_extract_geo($data_product,array("country_product","region_product","city_product"));
               }
             */
             foreach ($data_product as $one_product)
               {
                $a=$url_site."/". $this->forming_name_url_product($one_product)."-prod".$one_product["id_product"].".html";
                $urls[]=array("loc"=>$a,"changefreq"=>"weekly","priority"=>0.7);
                
               }
             
            }
           else
             {
              $error = 1;
              $error_text = "неправильно задан номер группы";
             }
         }
      
      return (array($error,$error_text,$urls));
     }
   
   function sitemap_forming_url_nested_category($urls, $num_category, $url_base_category)
     {
      //global $urls,$obj_ishop_cache_category;
      $urls = array();
      $mas_nested_category = $this->obj_cache_category->get_mas_data($num_category, false, false);
      if ( $mas_nested_category && sizeof($mas_nested_category) > 0 )
        {
         foreach ( $mas_nested_category as $one_category )
           {
            $url_category = $url_base_category.$one_category["united_name_url"]."/";
            $urls[]=array("loc"=>$url_category,"changefreq"=>"daily","priority"=>0.8);
            $this->sitemap_forming_url_nested_category($urls, $one_category["id_category"],$url_category);
           }
        }
      
      return ($urls);
     }
   
   function get_data_page_modul_nsrl($on_struct=false)
     {
      
      global $list_modules;
      $ident_modul_ishop = ( !empty($list_modules["ishop"]) ? $list_modules["ishop"][5] : "0" );
      
      $mas_page=array();
      if (!$on_struct)
        $mas_page = $this->init_data_page_nested_category_nsrl($ident_modul_ishop,0);
      
      $vdata = array( "name" => "Интернет-магазин", "identkey" => $ident_modul_ishop, "nested" => array( 
       "allproduct" => array( "name" => "Все товары", "identkey" => "3", "nested" => 0, "on_list_elm" => 1 ), 
       //"addproduct" => array( "name" => "Страница добавления/редактирования объявления", "identkey" => "2", "nested" => 0, "on_list_elm" => 0 ),
       "general" => array( "name" => "Другие страницы интернет-магазина", "identkey" => "1", "nested" => 0, "on_list_elm" => 0 ),
       "category" => array( "name" => "Все категории интернет-магазина", "identkey" => "4", "nested" => sizeof( $mas_page ) ? $mas_page : 0, "on_list_elm" => 1 ),
       "product" => array( "name" => "Страницы продуктов", "identkey" => "5", "nested" => sizeof( $mas_page ) ? $mas_page : 0, "on_list_elm" => 0 ),
       
       ) );
      
      return ($vdata);
     }
   
   function init_data_page_nested_category_nsrl($ident_modul_ishop,$num_category = 0)
     {
      $mas_page = array();
      
      $mas_main_category_ishop = $this->obj_cache_category->get_mas_data($num_category,false,false);
      
      foreach ( $mas_main_category_ishop as $one_category )
        {
         $mas_nested = $this->init_data_page_nested_category_nsrl($ident_modul_ishop,$one_category["id_category"]);
         $mas_page[$one_category["id_category"]] = array("name" => $one_category["name"], "identkey" => $one_category["id_category"], "nested" => sizeof( $mas_nested ) > 0 ? $mas_nested : 0 );
         
        }
      
      return ( $mas_page );
     }
   
   function forming_email_feedback_author($mas_data)
     {
      global $url_http;
      
      $error=0;
      $error_text="";
      $is_set_send_data=false;
      $name_recipient="";
      $email_recipient="";
      $message="";
      
      $data_product=false;
      $db_query="select product.id_product,product.name_user,product.name_product,product.email "
        ." from ".DB_PREF."product product "
        ." where id_product = ".$mas_data["num_element"]." and hide='show' and is_get_email = 'yes' ";
      list($kolvo,$data_product) = db_work::query_select_one_assoc($db_query);
      
      if ( $kolvo == 1 && $data_product && $data_product["email"] )
        {
         
         $name_recipient=trim($data_product["name_user"]);
         $email_recipient=$data_product["email"];
         $is_set_send_data=true;
         
         $title_page=$data_product["name_product"];
         $url_page="/product".$data_product["id_product"].".html";
         
         $message="Здравствуйте".($name_recipient ? ", ".$name_recipient : "")."!"
           ."<br />Вам написал сообщение посетитель сайта <a href='".$url_http."'>".NAME_SITE."</a> "
           ."с помощью контактной формы по поводу вашего объявления "
           ."<a href='".$url_http.$url_page."'>".$title_page."</a>.<br />"
           ."Имя пользователя:  ".$mas_data["name_user"]."<br>Email: <a href='mailto:".$mas_data["email_user"]."'>".$mas_data["email_user"]."</a>"
           .".<br />Текст сообщения:<br><br>".$mas_data["message_user"]
           ."<br /><br /><br />Если вы больше не хотите получать письма от пользователей нашего сайта, то вам надо отредактировать ваше объявление, и отменить возможность пользователям отправлять вам сообщения с сайта.";
         
        }
       else
         {
          $error=1;
          $error_text="Ошибка с параметрами!";
         }
      
      return (array($error,$error_text,$is_set_send_data,$name_recipient,$email_recipient,$message));
     }
   
   function get_data_page_comment($mas_data)
     {
      $on_data=false;
      $title_page="";
      $url_page="";
      
      $db_query="select product.id_product,product.name_user,product.name_product,product.email "
        ." from ".DB_PREF."product product "
        ." where id_product = ".$mas_data["add_num_element"]." and hide='show' ";
      list($kolvo,$data_product) = db_work::query_select_one_assoc($db_query);
      
      if ( $kolvo )
        {
         $on_data=true;
         $title_page=$data_product["name_product"];
         $url_page="/product".$data_product["id_product"].".html";
        }
      
      return (array($on_data,$title_page,$url_page));
     }
   
  }

$obj_ishop=new ishop_class_driver();
/*
Значение "$obj_имя_объекта" - должно быть прописано в конфигурационном
 файле CMS в соответствии с указанными комментариями 
*/
