<?php

/* класс быстрого редактирования товаров для версии v24.2.1 */

class edit_quick_product
  {
   protected $error = 0;
   protected $error_text = "no";
   
   protected $dir_big_images = "";
   protected $dir_small_images = "";
   protected $dir_images_cms = "";
   
   protected $dir_tmp = "";
   protected $name_tmp_file = "";
   protected $name_tmp_arhiv = "";
   protected $name_dir_files = "";
   protected $on_add_image = false;
   
   protected $csv_import = false;
   
   protected $init_elem = array();
   protected $num_elem_check = 0;
   protected $num_elem_validate = 0;
   protected $num_elem_found = 0;
   protected $kolvo_elem_error = 0;
   protected $max_kolvo_elem_error = 100;
   protected $error_text_list = array();
   protected $last_num_elem_error = -1;
   
   protected $dump_product = array();
   
   protected $mas_category = array();
   protected $mas_podcategory = array();
   protected $mas_num_podcategory = array();
   protected $mas_index_category = array();
   protected $mas_index_num_podcategory = array();
   
   protected $geo_data = array();
   
   protected $index_listv = array();
   protected $index_link_properties_cat = array();
   
   protected $check_only_data_file = false;
   
   protected $num_insert = 0;
   
   protected $obj_cache_category = array();
   protected $mas_index_mas_num_category = array();
   
   protected $delta_time_add = 1;
   
   protected $data_html = array();
   protected $data_answer = "";
   
   protected $type_load_files="";//upload или server
   
   protected $id_elm_create=0;
   protected $db_query_list_product="";
   protected $db_query_properties_product="";
   
   protected $mas_struct_elm=[];
   protected $mas_struct_id_elm=[];
   protected $mas_edit_field=[];
   
   protected $df_csv=false;
   
   function __construct()
     {
      $this->init_main_data();
     }
   
   function init_main_data()
     {
      $this->dir_big_images = DIR_LOADFILES_MODULS . "/ishop/bigfoto/";
      $this->dir_small_images = DIR_LOADFILES_MODULS . "/ishop/smallfoto/";
      $this->dir_images_cms = DIR_CMS."/images/";
      
      $this->dir_tmp = DIR_CMS."/tmp";
      global $obj_ishop_cache_category;
      $this->obj_cache_category = $obj_ishop_cache_category;
      
      //массив mas_edit_field будет содержать поля (name_field=>true/false), которые нужно будет обновить - значение должно быть true
      $this->mas_edit_field=["cost"=>false,"first_cost"=>false,"quantity_stock"=>false,"on_request"=>false];
      
      $this->data_html["title"] = "Быстрое редактирование товаров";
      $this->data_html["text_end"] = "<a href='./'>перейти к форме загрузки файла CSV</a>";
     }
   /*
   function connectBaz()
     {
      $error_code = 0;
      $error_text = "no";
      
      global $dbhost,$dbuser,$dbpasswd,$dbname,$obj_db_connect;
      
      $this->dbcnx = @$obj_db_connect->connectBaz($dbhost,$dbuser,$dbpasswd,$dbname);
      if ( !$this->dbcnx )
        {
         $error_code=1;$error_text="Невозможно подключиться к базе данных!";
        }
      
      return ( array($error_code, $error_text) );
     }
   */
   function ini_data()
     {
      global $init_currency;
      
      
      $this->init_currency = $init_currency;
      $this->index_init_currency = array();
      
      foreach ( $this->init_currency as $key_init => $data_init )
        {
         $this->index_init_currency[$data_init[1]] = $key_init;
        }
      
      $this->infoUserAgent = info_user_agent();
      global $obj_dynamic;
      $this->obj_dynamic = $obj_dynamic;
     }
   
   function upload_file( $type_file, $name_pf_file )
     {
      
      //$name_pf_file = "data_product";
      $name_file = "";
      
      if ( !( isset($_FILES[$name_pf_file]) && isset($_FILES[$name_pf_file]["error"])
          && ( $_FILES[$name_pf_file]["error"] == 0 )
          
         ) )
        {
         return ( array(1,"Файл не загружен!",$name_file) );
        }
      
      
      $name_upload_file = $_FILES[$name_pf_file]["name"];
      $exp_upload_file = get_exp_file($name_upload_file);
      
      if ($type_file !== "all" )
        {
         $exp_error_file=proverka_exp_file($name_upload_file,$type_file);
         if ( !$exp_error_file )
           {
            return ( array(1,"Неверный формат файла!",$name_file) );
           }
        }
      
      if ( is_uploaded_file($_FILES[$name_pf_file]["tmp_name"]) )
        {
         do
          {
           $tmp_name_file=generator_name_img().".".$exp_upload_file;
          }
         while ( file_exists($this->dir_tmp."/".$tmp_name_file) );
         
         if ( move_uploaded_file( $_FILES[$name_pf_file]["tmp_name"],$this->dir_tmp."/".$tmp_name_file ) )
           {
            
            //$this->name_tmp_file = $tmp_name_file;
            $name_file = $tmp_name_file;
            
           }
          else
            {
             return (  array(1,"Файл невозможно скопировать!",$name_file) );
            }
         
        }
       else
         {
          return ( array(1,"Файл невозможно скопировать!",$name_file) );
         }
      
      return ( array(0,"no",$name_file) );
     }
   
   function check_server_file($type_file, $name_pf, $is_necessarily)
     {
      $name_file="";
      
      if (empty($_POST[$name_pf]) || !trim($_POST[$name_pf]))
        {
         if ($is_necessarily)
           return (array(1,"Не указано название файла!",$name_file));
          else
            return (array(0,"no",$name_file));
        }
      $name_file=$_POST[$name_pf];
      
      if ($type_file != "all")
        {
         $on_exp=proverka_exp_file($name_file,$type_file);
         if (!$on_exp) return (array(1,"Файл ".$name_file." имеет недопустимый формат!",$name_file));
         
        }
      
      if (!preg_match("#^([a-zA-Z0-9\_\-\.])+$#i",$name_file)) return (array(1,"Имя файла ".$name_file." имеет недопустимый формат!",$name_file));
      
      if (!file_exists($this->dir_tmp."/".$name_file)) return (array(1,"Файл ".$name_file." не найден на сервере.",$name_file));
      
      return (array(0,"no",$name_file));
     }
   /*
   function load_xml()
     {
      
      $this->csv_import = @simplexml_load_file( $this->dir_tmp."/".$this->name_tmp_file );
      if ( !$this->csv_import )
        {
         return ("Ошибка. Неверная структура xml-документа!");
        }
      
      return ( false );
     }
   */
   function open_file_csv()
     {
      $this->df_csv=fopen($this->dir_tmp."/".$this->name_tmp_file,"r");
      if (!$this->df_csv)
        {
         return ("Невозможно открыть файл csv!");
        }
      
      return (false);
     }
   
   function close_file_csv()
     {
      if ($this->df_csv) fclose($this->df_csv);
      
      return (true);
     }
   
   function end_processing()
     {
      $this->close_file_csv();
      
      if ( $this->type_load_files == "upload" && $this->name_tmp_file )
        {
         delete_file($this->dir_tmp."/",$this->name_tmp_file);
        }
      /*
      if ( $this->type_load_files == "upload" && $this->name_tmp_arhiv )
        {
         delete_file($this->dir_tmp."/",$this->name_tmp_arhiv);
        }
      
      if ( $this->name_dir_files )
        {
         remove_dir( $this->dir_tmp."/".$this->name_dir_files );
        }
      */
     }
   
   function init_elem()
     {
      
      $this->init_elem = array(
        /*
         "name_pole" => array(
           номер ячейки в строчке,
           тип поля (text или numeric),
           обязательно ли должно быть поле - false или true,
           обязательно ли должно быть значение в поле - false или true,
           проверять или нет значение - false или value, listv, hablonrv, function,
           зависит от предыдущего параметра: "" или нужное значение,
           обработать функцией tr или false,
           значение по умолчанию или false
           название поля
           )
        */
        
        //0-id_product
        //1-Артикул
        //2-Наименование
        //3-Цена
        //4-Изначальная цена
        //5-Количество товара
        //6-Под заказ (да,нет)
        
        //-2-Краткое описание
        //-3-Полное описание
        //-4-Категория
        //-6-Валюта
        //-9-Ключевые слова
        //-10-Свойства*
        //-11-Изображения
        //-13-Тип товара (Цифровой/Обычный)
        
        "id_product" => array( 0, "numeric", true, true, false, "", false, 0, "ID товара" ),
        "vendor_code" => array( 1, "text", true, false, false, "", "tr", "", "Артикул" ),
        "name_product" => array( 2, "text", true, true, false, "", "tr", false, "Наименование" ),
        "cost" => array( 3, "numeric", true, true, false, "", false, 0, "Стоимость" ),
        "first_cost" => array( 4, "numeric", true, false, false, "", false, 0, "Изначальная цена" ),
        "quantity_stock" => array( 5, "numeric", true, false, false, "", false, 0, "Количество товара" ),
        "on_request" => array( 6, "text", true, true, "hablonrv", "#^(да|нет)$#ui", "tr", "", "Под заказ" ),
        
        //-"short_text" => array( 2, "text", true, true, false, "", false, false, "Краткое описание" ),
        //-"all_text" => array( 3, "text", true, true, false, "", false, false, "Полное описание" ),
        //-"name_category" => array( 4, "text", true, true, false, "", false, false, "Название категории" ),
        
        //"index_currency" => array( 6, "text", true, false, false, "", false, "руб.", "Валюта" ),//ENUM('rub','usd','uah','eur') NOT NULL default 'rub',
        
        //-"key_words" => array( 9, "text", true, false, false, "", false, false, "Ключевые слова" ),
        
        //-"addparam" => array( 10, "text", false, false, false, "", false, false, "Дополнительные свойства" ),
        //-"index_image" => array( 11, "text", true, false, false, "", "tr", false, "Изображения" ),
        
        //-"on_digital" => array( 13, "text", true, false, "hablonrv", "#^((цифровой)|(обычный))$#ui", "tr", "", "Тип товара"),
       );
      
      
     }
   
   function check_csv_import()
     {
      $this->num_elem_check = 0;
      $this->num_elem_validate=0;
      $this->num_elem_found=0;
      $this->error_text_list = array();
      $this->kolvo_elem_error = 0;
      $this->dump_product = array();
      $this->on_add_image = false;
      
      $this->geo_data = array();
      
      while ( ($elem_csv=fgetcsv($this->df_csv,0,";"))!==false )
        {
         //write_log_cms($elem_csv);
         if ($this->num_elem_check >= 1 && $elem_csv && sizeof($elem_csv) >= 7)
           {
            $on_value=false;
            for ($i=0;$i<=4;$i++)
              {
               if (!empty($elem_csv[$i]))
                 {
                  $on_value=true;
                  break;
                 }
              }
            
            if ($on_value)
              {
               $this->check_one_data_elem_csv = $elem_csv;
               $this->check_one_elem_csv_import( $elem_csv );
               $this->num_elem_found++;
              }
           }
         $this->num_elem_check++;
         
         if ( $this->kolvo_elem_error >= $this->max_kolvo_elem_error )
          break;
         
        }
      
      //var_dump( $this->dump_product );
      
     }
   
   function check_one_elem_csv_import( $one_elem )
     {
      $value = "";// значение элемента
      $is_elem = false;// элемент есть или нет
      $is_value = false;// значение задано или нет
      $elem_error = false;
      $pole_error = false;
      
      $data_elem = array();
      
      foreach ( $this->init_elem as $key_pole => $data_pole )
        {
         if (isset($this->mas_edit_field[$key_pole]))
           {
             //проверяем нужно ли обновлять данное поле
             if (!$this->mas_edit_field[$key_pole]) continue;
           }
         
         $value = "";
         $is_elem = false;
         $is_value = false;
         $pole_error = false;
         
         if ( $data_pole[1] == "numeric" ) $value = 0;
         
         if ( isset( $one_elem[$data_pole[0]] ) )
           {
            //echo( " ok <br>" . $one_elem->$data_pole[0] ." <br>" );
            
            $value = trim($one_elem[$data_pole[0]]);
            $is_elem = true;
            if ( $value || $value === "0" || $value === 0 )
              {
               $is_value = true;
              }
           }
          else
            {
             //echo( " error <br>" );
            }
         
         if ( !$is_elem && $data_pole[2] )
           {
            
            $pole_error = true;
            $this->add_error_text_list("Не указано поле ".$data_pole[8]."");
            
           }
         
         if ( !$pole_error )
           {
            
            if ( !$is_value && $data_pole[3] )
              {
               $pole_error = true;
               $this->add_error_text_list("Не указано значение в поле ".$data_pole[8]."");
              }
            
           }
         
         if ( !$pole_error )
           {
            
            if ( $data_pole[1] == "numeric" )
              {
               if ( $is_value && !is_numeric( $value ) )
                 {
                  $pole_error = true;
                  $this->add_error_text_list("Неверно указано поле ".$data_pole[8]."");
                 }
               
              }
            
           }
         
         if ( !$pole_error && $is_value )
           {
            
            if ( $data_pole[4] )
              {
               switch ( $data_pole[4] )
                 {
                  case ("value"):
                    if ( $value !== $data_pole[5] )
                      {
                       $pole_error = true;
                      }
                    break;
                  case ("listv"):
                    $mas_d_value = explode(",",$data_pole[5]);
                    if ( !in_array($value,$mas_d_value) )
                      {
                       $pole_error = true;
                      }
                    break;
                  case ("hablonrv"):
                    if ( !preg_match($data_pole[5],$value) )
                      {
                       $pole_error = true;
                      }
                    break;
                  case ("function"):
                    $name_function = $data_pole[5];
                    if ( !$name_function($value) )
                      {
                       $pole_error = true;
                      }
                    break;
                  
                 }
               
               if ( $pole_error )
                 {
                  //$pole_error = true;
                  $this->add_error_text_list("Неверно указано поле ".$data_pole[8]."");
                 }
               
              }
            
           }
         
         if ( !$is_value && $data_pole[7] !== false )
           $value = $data_pole[7];
         
         if ( $pole_error ) $elem_error = true;
         
         $data_elem[$key_pole] = $value;
         
        }
      
      
      
      list($check_error,$add_data) = $this->check_one_data_product( $data_elem );
      $data_elem = array_merge($data_elem, $add_data);
      //write_log_cms($data_elem,"data elm");
      $this->dump_product[] = $data_elem;
      
      if ( $check_error ) $elem_error = true;
      
      if ( $elem_error )
        {
         $this->kolvo_elem_error++;//подсчитываем количество элементов (товаров) с ошибками
        }
      
      return ($elem_error);
     }
   
   function add_error_text_list($t_error)
     {
      //$text = "";
      
      if ( $this->last_num_elem_error < 0 || $this->last_num_elem_error != $this->num_elem_check )
        {
         $this->last_num_elem_error = $this->num_elem_check;
         $this->error_text_list[] = "";
         $t = "Элемент номер ".($this->num_elem_check+1);
         $t .= "('".(isset($this->check_one_data_elem_csv[1]) ? $this->check_one_data_elem_csv[1]:"")."')";
         $this->error_text_list[] = $t;
        }
      
      $this->error_text_list[] = $t_error;
      
     }
   
   function select_category()
     {
      
     }
   
   function check_one_data_product( $data_elem )
     {
      $error = false;
      $add_data = array();
      
      $n_category = 0;
      $mas_num_category = array();
      $mas_dyn_data = array();
      
      
      //проверка валюты
      /*
      $currency = "";
      reset( $this->index_init_currency );
      $first_v = _each( $this->index_init_currency );
      $currency = $first_v["value"];
      
      if ( $data_elem["index_currency"] )
        {
         if ( isset( $this->index_init_currency[$data_elem["index_currency"]] ) )
           $currency = $this->index_init_currency[$data_elem["index_currency"]];
          else
            {
             $error = true;
             $this->add_error_text_list("Неверно указана валюта ".$data_elem["index_currency"]."");
            }
        }
      
      $add_data["currency"] = $currency;
      */
      //global $init_base_currency;
      //$add_data["currency"] = $init_base_currency;
      
      /*
      //проверка категории
      if ( $data_elem["name_category"] && ( $data_check_category =  $this->check_category($data_elem["name_category"]) ) )
        {
         $n_category = end($data_check_category);
         $mas_num_category = $data_check_category;
        }
       else
         {
          $error = true;
          $this->add_error_text_list("Неверно указано название категории ".$data_elem["name_category"]."");
         }
      */
      /*
      if ( $data_elem["name_category"] && isset( $this->mas_index_category[mb_strtolower($data_elem["name_category"])] ) )
        {
         $num_category = $this->mas_index_category[mb_strtolower($data_elem["name_category"])]["id_category"];
         if ( $data_elem["name_podcategory"] && isset( $this->mas_index_num_podcategory[$num_category][mb_strtolower($data_elem["name_podcategory"])] ) )
           {
            $d = $this->mas_index_num_podcategory[$num_category][mb_strtolower($data_elem["name_podcategory"])];
            $n_category = $d["id_category"];
           }
          else
            {
             $error = true;
             $this->add_error_text_list("Неверно указано название подкатегории ".$data_elem["name_podcategory"]."");
            }
         
        }
       else
         {
          $error = true;
          $this->add_error_text_list("Неверно указано название категории ".$data_elem["name_category"]."");
         }
      */
      //$add_data["n_category"] = $n_category;
      
      //Проверяем поле "Под заказ" и меняем значение с "да" и "нет", на on и off, соответственно
      if ($this->mas_edit_field["on_request"])
        {
          $v_on_request = "off";
          if (mb_strtolower($data_elem["on_request"]) == "да") $v_on_request = "on";
          $add_data["on_request"] = $v_on_request;
        }
      /*
      //Проверяем поле "Тип товара" и меняем значение с "цифровой" и "обычный", на on и off, соответственно
      $v_on_digital="off";
      if (mb_strtolower($data_elem["on_digital"]) == "цифровой") $v_on_digital="on";
      $add_data["on_digital"]=$v_on_digital;
      */
      
      /*
      //проверяем дополнительные поля (свойства) товаров
      $on_check_add_param = false;
      $mas_param = array();
      $mas_properties_cat = array();
      
      if ( !$error && $n_category > 0 )
        {
         
         if ( !$error )
           {
            $mas_properties_cat = $this->get_mas_link_pc_list_num_category($mas_num_category);
            //if ( !empty( $this->mas_link_pc[$n_category] ) )
            if ( sizeof( $mas_properties_cat ) )
              {
               $on_check_add_param = true;
              }
            
           }
         
         if ( $data_elem["addparam"] && $on_check_add_param )
           {
            
            //$on_check_add_param  = true;
            $add_param = explode(";",$data_elem["addparam"]);
            $mas_param = array();
            
            if ( sizeof($add_param) )
              {
               foreach ( $add_param as $one_param )
                 {
                  $pos_equal=mb_strpos($one_param,"=");
                  if ($pos_equal !== false)
                    {
                     $one_v1=mb_substr($one_param,0,$pos_equal);
                     $one_v2=mb_substr($one_param,$pos_equal+1,mb_strlen($one_param)-$pos_equal-1);
                     $mas_param[trim($one_v1)] = mb_strtolower(trim($one_v2));
                    }
                   else
                     $error=true;
                  /*
                  $one_v = explode("=",$one_param);
                  if ( sizeof($one_v) == 2 )
                    {
                     $mas_param[ trim( $one_v[0] ) ] = mb_strtolower(trim( $one_v[1]) );
                    }
                   else
                     {
                      $error = true;
                      
                     }
                  * /
                 }
              }
            
            //var_dump($mas_param);
            
           }
         
         if ( $error )
           {
            $this->add_error_text_list("Неверно указан один или несколько дополнительных параметров ".$data_elem["addparam"]."");
           }
         
         if ( !$error && $on_check_add_param )
           {
            
            //$mas_link_pc = $this->mas_link_pc[$n_category];
            //$mas_properties_cat = $this->get_mas_link_pc($n_category);
            //echo("<br> mas_prop -> ");var_dump($mas_properties_cat);
            foreach ( $mas_properties_cat as $one_properties )
              {
               //echo("<br> one_prop -> ");var_dump($one_properties);
               $error_properties = false;
               list($error_properties, $add_mas_dyn_data) = $this->check_one_properties( $one_properties["id_properties"], $mas_param );
               if ( $error_properties ) $error = true;
               if ( $add_mas_dyn_data )
                 {
                  $mas_dyn_data = array_merge($mas_dyn_data, $add_mas_dyn_data);
                 }
               
              }
            //var_dump( $mas_dyn_data );
           }
         
         
        }
      
      $add_data["mas_dyn_data"] = $mas_dyn_data;
      */
      
      return ( array( $error, $add_data ) );
     }
   /*
   function _check_category($name_category)
     {
      $error = false;
      $mas_category = array();
      $mas_num_category = array();
      
      $name_clear_category = preg_replace("/[ ]+/"," ",$name_category);
      $name_clear_category = preg_replace("/[ ]*\/[ ]* /","/",$name_clear_category);
      $name_clear_category = mb_strtolower($name_clear_category);
      
      if ( isset($this->mas_index_mas_num_category[$name_clear_category]) )
        return ( $this->mas_index_mas_num_category[$name_clear_category] );
      
      if ( $name_category )
        {
         
         if ( mb_strpos($name_category,"/") !== false )
           {
            $mas_category = explode("/",$name_category);
           }
          else
            $mas_category[] = $name_category;
        }
       else
         {
          $error = true;
         }
      
      if ( sizeof($mas_category) )
        {
         
         $mas_num_category = $this->check_mas_name_category_data($mas_category);
         
         
         if ( $mas_num_category === false )
           {
            $error = true;
            $this->mas_index_mas_num_category[$name_clear_category] = false;
           }
          else
            {
             $this->mas_index_mas_num_category[$name_clear_category] = $mas_num_category;
            }
        }
       else
         {
          $error = true;
         }
      
      return ( $error ? false : $mas_num_category );
     }
   
   public function _check_mas_name_category_data($mas_name_category)
     {
      // проверяем массив с многоуровневыми названиями url категорий - array("Транспорт","Легковое авто")
      $res = false;
      $k = sizeof($mas_name_category);
      if ( $k )
        {
         
         $mas_data_1lvl = $this->obj_cache_category->get_mas_data(0,false,false);
         
         list($on_search,$key_1lvl) = search_mas_2level_string($mas_data_1lvl,"name",trim($mas_name_category[0]),false);
         
         if ( $on_search )
           {
            $res = array();
            $res[] = $mas_data_1lvl[$key_1lvl]["id_category"];
            
            for ( $i = 1; $i < $k; $i++ )
              {
               $check_name_url = trim($mas_name_category[$i]);
               $num_previous_data = $res[$i-1];
               
               $mas_data_lvl = $this->obj_cache_category->get_mas_data($num_previous_data,false,false);
               if ( !sizeof( $mas_data_lvl ) )
                 {
                  $res = false;
                  break;
                 }
               
               list($on_search,$key_lvl) = search_mas_2level_string($mas_data_lvl,"name",$check_name_url,false);
               if ( !$on_search )
                 {
                  $res = false;
                  break;
                 }
               
               $res[] = $mas_data_lvl[$key_lvl]["id_category"];
               
              }
            
           }
         
        }
      
      return ( $res );
     }
   
   function _select_all_properties()
     {
      
      $db_query="select * from ".DB_PREF."ishop_properties ";
      list($kol, $this->mas_all_properties) = obr_db_query_select_assoc_index($db_query,"id_properties");
      
      $db_query="select * from ".DB_PREF."ishop_link_pc ";
      list($kol, $this->mas_link_pc) = obr_db_query_select_assoc_index_group($db_query,"num_category");
      
      $db_query="select * from ".DB_PREF."ishop_listv order by pos_value ASC, name_value ASC ";
      list($kol, $this->mas_all_listv) = obr_db_query_select_assoc($db_query);
      
      
      
     }
   
   function _check_one_properties( $num_properties, $mas_param )
     {
      //$is_fill_add_pole = 1;
      global $masConfig;
      $is_fill_add_pole = $masConfig["IS_FILL_ADD_POLES_PRODUCT"]-0;
      
      $one_properties = $this->mas_all_properties[$num_properties];
      $num_one_properties=$one_properties["id_properties"];
      
      $data_value = $this->select_values_properties( $one_properties );
      
      $is_param = true;
      $is_value = false;
      $name_properties = "";
      $v_param = "";
      
      $error_code = false;
      $text_error = "";
      
      $mas_dynamic_data = array();
      
      if ( isset( $mas_param[$one_properties["name_properties"]] ) )
        {
         $is_param = true;
         $name_properties = $one_properties["name_properties"];
         $v_param = $mas_param[$name_properties];
         if ( $v_param !== "" ) $is_value = true;
        }
      
      if ( ( $is_fill_add_pole == 1 || ( $is_fill_add_pole == 2 && $one_properties["surely_fill"] == "yes" ) ) && $one_properties["type_properties"] != "list_checkbox" )
        {
         if ( !$is_param || !$is_value )
           {
            $error_code = 1;
            $this->add_error_text_list("Не указано дополнительное свойство ".$one_properties["name_properties"]."");
           }
         
         
        }
      
      if ( !$error_code && $is_value )
        {
         
          switch ($one_properties["type_properties"])
            {
             case ("text"):
                $mas_dynamic_data[]=array($num_one_properties,$v_param,"text");
               break;
             
             case ("numeric"):
               if (!is_numeric($v_param))
                 {
                  if ( $is_fill_add_pole == 1 || ( $is_fill_add_pole == 2 && $one_properties["surely_fill"] == "yes" ) )
                    {
                     $error_code=1;
                     $this->add_error_text_list("Неправильно задан дополнительный параметр ".$one_properties["name_properties"]."");
                    }
                 }
                else
                  {
                   if ($one_properties["control_meaning"] == 'y')
                     {
                      if ( $v_param <= $one_properties["max_numeric"] &&
                           $v_param >= $one_properties["min_numeric"] )
                       {
                        $mas_dynamic_data[]=array($num_one_properties,$v_param,"numeric");
                       }
                      else
                        {
                         $error_code=1;
                         $this->add_error_text_list("Неправильно задан дополнительный параметр (число выходит за заданные пределы) ".$one_properties["name_properties"]."");
                        }
                     }
                    else
                      {
                       $mas_dynamic_data[]=array($num_one_properties,$v_param,"numeric");
                      }
                  }
               break;
             
             case ("list"):
                if ( isset($data_value[$v_param]) 
                  && $data_value[$v_param]["n_properties"] == $num_one_properties )
                  {
                   $mas_dynamic_data[]=array($num_one_properties,$data_value[$v_param]["id_value"],"list");
                  }
                 else
                   {
                    if ( $is_fill_add_pole == 1 || ( $is_fill_add_pole == 2 && $one_properties["surely_fill"] == "yes" ) )
                      {
                       $error_code=1;
                       $this->add_error_text_list("Неправильно задан дополнительный параметр (указано несуществующее в базе значение) ".$one_properties["name_properties"]."");
                       //$error_text="Ошибка с данными (динамическими, не найдено значение)!";
                      }
                   }
                
               break;
             
             case ("nested_list"):
                if ( isset($data_value[$v_param]) 
                  && $data_value[$v_param]["n_properties"] == $num_one_properties )
                  {
                   $mas_dynamic_data[]=array($num_one_properties,$data_value[$v_param]["id_value"],"nested_list");
                  }
                 else
                   {
                    if ( $is_fill_add_pole == 1 || ( $is_fill_add_pole == 2 && $one_properties["surely_fill"] == "yes" ) )
                      {
                       $error_code=1;
                       $this->add_error_text_list("Неправильно задан дополнительный параметр (указано несуществующее в базе значение) ".$one_properties["name_properties"]."");
                       //$error_text="Ошибка с данными (динамическими, не найдено значение)!";
                      }
                   }
                
               break;
             
             case ("list_checkbox"):
                if ( $v_param )
                  {
                    $mas_v_param = explode( "|",$v_param );
                    //var_dump($mas_v_param);
                    if (is_array($mas_v_param) && sizeof($mas_v_param) )
                      {
                       foreach ($mas_v_param as $one_value_checkbox)
                         {
                          if (isset($data_value[$one_value_checkbox]) 
                              && $data_value[$one_value_checkbox]["n_properties"] == $num_one_properties)
                              {
                               //$mas_dynamic_data[]=array($num_one_properties,$one_value_checkbox,"list_checkbox");
                               $mas_dynamic_data[]=array($num_one_properties,$data_value[$one_value_checkbox]["id_value"],"list_checkbox");
                              }
                             else
                               {
                                $error_code=1;
                                $this->add_error_text_list("Неправильно задан дополнительный параметр (указано несуществующее в базе значение) ".$one_properties["name_properties"]."");
                                //$error_text="Ошибка с данными (динамическими, не найдено значение)!";
                               }
                          
                          
                         }
                      }
                     else
                       {
                        $error_code=1;
                        $this->add_error_text_list("Неправильно задан дополнительный параметр (указано несуществующее в базе значение) ".$one_properties["name_properties"]."");
                        //$error_text="Ошибка с данными (динамическими, не найдено значение)!";
                       }
                  }
                
               break;
            }
      
        }
      
      return ( array($error_code, $mas_dynamic_data) );
     }
   
   function _select_values_properties( $data_one_properties )
     {
      
      $type_properties = $data_one_properties["type_properties"];
      $mas_value = array();
      $num_properties = $data_one_properties["id_properties"];
      
      if ( isset($this->index_listv[$num_properties]) )
        {
         $mas_value = $this->index_listv[$num_properties];
        }
       else
         {
          if ( $type_properties == "list" || $type_properties == "nested_list" || $type_properties == "list_checkbox" )
            {
             
             foreach ( $this->mas_all_listv as $key => $one_row )
               {
                
                if ( $one_row["n_properties"] == $num_properties )
                  {
                   
                   $mas_value[mb_strtolower(trim($one_row["name_value"]))] = $one_row;
                   
                  }
                
               }
            }
          
          $this->index_listv[$num_properties] = $mas_value;
         }
      //var_dump( $mas_value );
      return ( $mas_value );
     }
   
   function _get_mas_link_pc_list_num_category($mas_num_category)
     {
      $mas_properties_c = array();
      //var_dump($mas_num_category);exit();
      if ( sizeof($mas_num_category) )
        {
         
         $ident_list_category = implode("|",$mas_num_category);
         if ( isset( $this->index_link_properties_cat[$ident_list_category] ) )
           {
            $mas_properties_c = $this->index_link_properties_cat[$ident_list_category];
           }
          else
            {
             foreach ( $mas_num_category as $num_category )
               {
                if ( isset( $this->mas_link_pc[$num_category] ) )
                  {
                   $mas_link_pc = $this->mas_link_pc[$num_category];
                   foreach ( $mas_link_pc as $one_link )
                     {
                      if ( isset( $this->mas_all_properties[ $one_link["num_properties"] ] ) )
                        {
                         $one_properties_c = $this->mas_all_properties[$one_link["num_properties"]];
                         //var_dump($one_properties_c);
                         
                         list($on_search,$v_searh)=search_mas_2level($mas_properties_c,"id_properties",$one_properties_c["id_properties"],"id_properties");
                         if ( !$on_search )
                           {
                            $mas_properties_c[] = $one_properties_c;
                            $add_mas = $this->get_mas_add_properties_cat($one_properties_c["id_properties"]);
                            if ( sizeof( $add_mas ) ) $mas_properties_c = array_merge($mas_properties_c, $add_mas);
                           }
                        }
                     }
                  }
                
               }
             
             $this->index_link_properties_cat[$ident_list_category] = $mas_properties_c;
             
            }
         
        }
      
      return ( $mas_properties_c );
     }
   
   function _get_mas_link_pc($n_category)
     {
      
      if ( isset( $this->index_link_properties_cat[ $n_category ] ) )
        {
         $mas_properties_c = $this->index_link_properties_cat[$n_category];
        }
       else
         {
          
          $mas_link_pc = $this->mas_link_pc[$n_category];
          $mas_properties_c = array();
          
          foreach ( $mas_link_pc as $one_link )
            {
             if ( isset( $this->mas_all_properties[ $one_link["num_properties"] ] ) )
               {
                
                $one_properties_c = $this->mas_all_properties[ $one_link["num_properties"] ];
                $mas_properties_c[] = $one_properties_c;
                $add_mas = $this->get_mas_add_properties_cat( $one_properties_c["id_properties"] );
                if ( sizeof( $add_mas ) ) $mas_properties_c = array_merge($mas_properties_c,$add_mas);
                
               }
             
            }
          
          $this->index_link_properties_cat[$n_category] = $mas_properties_c;
         }
      
      return ( $mas_properties_c );
     }
   
   function _get_mas_add_properties_cat( $num_properties )
     {
      $mas = array();
      foreach ( $this->mas_all_properties as $one_properties )
        {
         if ( $one_properties["num_properties"] == $num_properties )
           {
            $mas[] = $one_properties;
            $add = $this->get_mas_add_properties_cat( $one_properties["id_properties"] );
            if ( sizeof( $add ) ) $mas = array_merge($mas,$add);
           }
        }
      
      //var_dump( $mas );
      
      return ( $mas );
     }
   */
   function processing()
     {
      $error=0;
      $error_text="no";
      $error_text_df="";
      $answer = "";
      $info_work=array();
      
      $d_mas = $this->list_oper();
      $error = $d_mas[0];
      $error_text = $d_mas[1];
      if ( isset($d_mas[2]) ) $error_text_df = $d_mas[2];
      if ( isset($d_mas[3]) ) $info_work = $d_mas[3];
      
      //write_html_answer($error,$error_text,$answer,$this->data_html);
      
      return (array($error,$error_text,array_merge( array("text_error_df"=>$error_text_df), $info_work )));
     }
   
   function list_oper()
     {
      /*
      list($error_code, $error_text) = $this->connectBaz();
      if ( $error_code )
        {
         return(array($error_code,$error_text));
        }
      */
      
      $answer = "";
      $this->check_only_data_file = false;
      
      if ( isset( $_POST["only_check_data"] ) && $_POST["only_check_data"] == "on" )
        {
         $this->check_only_data_file = true;
        }
      
      $type_load=(isset($_POST["type"]) ? $_POST["type"]:"");
      if ( !($type_load == "server" || $type_load == "upload") )
        {
         return(array(0,"no","Не выбран тип загрузки файлов."));
        }
      $this->type_load_files=$type_load;
      
      $v_field=(isset($_POST["v_field"]) ? $_POST["v_field"] : "");
      if ($v_field && (preg_match("/^[a-zA-Z\\_]+(\\,[a-zA-Z\\_]+)*$/",$v_field) === 1))
        {
          $mas_field=explode(",",$v_field);
          //write_log_cms($mas_field,"mas_field");
          
          //$this->mas_edit_field=["cost"=>false,"first_cost"=>false,"quantity_stock"=>false,"on_requst"=>false];
          
          foreach ($mas_field as $one_field)
            {
              if (isset($this->mas_edit_field[$one_field]))
                {
                  $this->mas_edit_field[$one_field]=true;
                }
              else
                {
                  return(array(0,"no","Неправильно выбраны поля для обновления!"));
                }
            }
        }
       else
         {
           return(array(0,"no","Не выбраны поля для обновления!"));
         }
      
      $this->ini_data();
      
      if ($this->type_load_files == "upload")
        {
         list($error_code, $error_text, $name_file) = $this->upload_file("csv","data_product");
         
         if ( $error_code )
           {
            return (array(0,"no",$error_text));
           }
         
         $this->name_tmp_file = $name_file;
         /*
         list($error_code, $error_text, $name_file) = $this->upload_file("zip","data_img");
         
         if ( $error_code == 0 )
           {
            $this->name_tmp_arhiv = $name_file;
           }
         */
        }
       else
         {
          list ($error_code, $error_text, $name_file) = $this->check_server_file("csv","data_product",true);
          if ( $error_code )
            {
             return (array(0,"no",$error_text));
            }
          
          $this->name_tmp_file = $name_file;
          /*
          list ($error_code, $error_text, $name_file) = $this->check_server_file("zip","data_img",false);
          if ( $error_code )
            {
             return (array(0,"no",$error_text));
            }
          
          $this->name_tmp_arhiv = $name_file;
          */
         }
      
      //$error_text = $this->load_xml();
      $error_text = $this->open_file_csv();
      if ( $error_text )
        {
         $this->end_processing();
         return (array(0,"no",$error_text));
        }
      
      //var_dump($this->csv_import);
      /*
      $this->select_category();
      $this->select_all_properties();
      */
      $this->init_elem();
      $this->check_csv_import();
      
      //var_dump( $this->error_text_list );
      //var_dump( $this->dump_product );
      
      $mas_text_errors=array();
      $kolvo_elem_found=0;
      $type="";
      
      if ( $this->kolvo_elem_error )
        {
          /*
          $answer = array_merge(array('<div style="color: #a93;">Найдены ошибки. Выводятся ошибки только для первых 100 элементов</div>'),
            $this->error_text_list);
          */
          $mas_text_errors=$this->error_text_list;
        }
       else
         {
          if ( !$this->check_only_data_file )
            {
             $this->import_db();
             //$answer = "Импорт выполнен! Добавлено товаров - ".$this->num_elem_found." шт.";
             $this->clear_cache();
             $kolvo_elem_found=$this->num_elem_found;
             $type="add";
            }
           else
             {
              // нужно только проверить данные файла
              //$answer = "Проверены только данные файла. Найдено товаров - ".$this->num_elem_found." шт.";
              $kolvo_elem_found=$this->num_elem_found;
              $type="check";
             }
         }
      
      $this->end_processing();
      
      return ( array(0,"no","",array("list_errors"=>$mas_text_errors, "kolvo_elem"=>$kolvo_elem_found, "type"=>$type)) );
     }
   
   function set_answer_data_html()
     {
      //$this->data_html["title"] = "Импорт товаров";
      //$this->data_html["text_end"] = "<a href='./'>перейти к форме загрузки файла CSV</a>";
      
      
      //$this->data_answer = 'Экспорт выполнен. Файл находится в каталоге сайта /tmp<br>'
      // .'Также необходимо сделать копию рисунков находящихся в папке сайта /loadfiles/moduls/ishop/bigfoto';
      
     }
   
   function get_error_text_list()
     {
      return ( $this->error_text_list );
     }
   
   function get_kolvo_elem_error()
     {
      return ( $this->kolvo_elem_error );
     }
   
   function import_db()
     {
      
      //var_dump( $this->dump_product );
      /*
      if ( $this->name_tmp_arhiv )
        {
         $info_file = get_info_file($this->name_tmp_arhiv);
         $this->name_dir_files = $info_file["name"];
         mkdir( $this->dir_tmp. "/" . $this->name_dir_files );
         if ( $this->open_zip_archive() )
           $this->on_add_image = true;
        }
      */
      $this->db_query_list_product="";
      $this->db_query_properties_product="";
      $quantity=0;
      $this->id_elm_create=0;
      //$this->get_max_id_elm_create();
      
      foreach ( $this->dump_product as $one_elem )
        {
         $quantity++;
         //$this->id_elm_create++;
         
         $this->add_struct_one_elem( $one_elem );
         
         if ($quantity >= 30)
           {
            //write_log_cms($this->db_query_list_product,"db_query_list_product");
            //write_log_cms($this->db_query_properties_product,"db_query_properties_product");
            //db_work::query($this->db_query_list_product);
            $this->forming_db_query_edit_list();
            //if ($this->db_query_properties_product) db_work::query($this->db_query_properties_product);
            //$this->db_query_list_product="";
            //$this->db_query_properties_product="";
            $quantity=0;
           }
        }
      
      if (sizeof($this->mas_struct_id_elm) > 0) $this->forming_db_query_edit_list();
      //if ($this->db_query_list_product) db_work::query($this->db_query_list_product);
      //if ($this->db_query_properties_product) db_work::query($this->db_query_properties_product);
      
     }
   /*
   function _open_zip_archive()
     {
      $error = false;
      $zip = new ZipArchive;
      if ( $zip->open( $this->dir_tmp. "/" . $this->name_tmp_arhiv ) === true )
        {
         $zip->extractTo( $this->dir_tmp. "/" . $this->name_dir_files."/" );
         $zip->close();
         
        }
       else
         {
          $error = true;
         }
      
      return ( !$error );
     }
   */
   function add_struct_one_elem( $one_elem )
     {
      global $masConfig,$obj_ishop;
      
      //$time_delta =  $this->delta_time_add * $this->num_insert;
      $this->num_insert++;
      
      //$time_begin = $GLOBALS["timeGlobal"] + $time_delta;
      //$time_end = $time_begin + $one_elem["time_product"];
      /*
      $name_images = "";
      
      if ( $one_elem["index_image"] )
        {
         $mas_name_images = $this->check_images($one_elem["index_image"]);
         if (sizeof($mas_name_images) > 0)
           $name_images = implode("|",$mas_name_images);
        }
      */
      $mas_index = array();
      //"cost","first_cost","quantity_stock","on_request",
      //"id_product","name_product","vendor_code",
      //"currency","on_digital","n_category","key_words","short_text","all_text",
      foreach ($this->mas_edit_field as $name_field => $use_field)
        {
          if ($use_field) $mas_index[]=$name_field;
        }
      
      //$mas_save = array();
      $this->mas_struct_id_elm[]=$one_elem["id_product"];
      
      foreach ($mas_index as $one_index)
        {
          if (!isset($this->mas_struct_elm[$one_index])) $this->mas_struct_elm[$one_index]=[];
          
          $this->mas_struct_elm[$one_index][]=[$one_elem["id_product"],$one_elem[$one_index]];
          
        }
      //$mas_save = copy_mas_to_mas_index($one_elem,$mas_save,$mas_index);
      /*
      $mas_save["name_product"] = max_truncate_text($mas_save["name_product"],$masConfig['MAX_SIM_NAME_PRODUCT'],"",true);
      
      */
      //$mas_save["name_url"] = $obj_ishop->forming_name_url_product($mas_save["name_product"]);
      
      //$mas_save["id_product"] = $this->id_elm_create;
      /*
      $mas_save["teg_title"] = '';
      $mas_save["meta_keywords"] = '';
      $mas_save["meta_description"] = '';
      
      $mas_save["hide"] = 'show';
      
      $mas_save["status_product"] = "usual";
      //$mas_save["quantity_stock"] = 0;
      
      $mas_save["discount_cost"] = 0;
      //$mas_save["vendor_code"] = 0;
      
      $mas_save["kolvo_view"] = 0;
      $mas_save["start_date"] = $time_begin;
      $mas_save["edit_date"] = 0;
      $mas_save["sort_time"] = $time_begin;
      $mas_save["image"] = $name_images;
      $mas_save["num_user"] = 0;
      $mas_save["on_comments"] = "on";
      $mas_save["add_comments"] = "on";
      $mas_save["type_display"] = 0;
      
      $mas_save["robots_index"] = "yes";
      $mas_save["date_last_view"] = 0;
      */
      //$operation = "new";
      //$db_query = forming_db_query_indexmas(DB_PREF."product",$mas_save,$operation,"id_product");
      //$this->forming_db_add_list($mas_save);
      
      //$q_ident = obr_db_query($db_query);
      //$id_product_new = db_work::get_insert_id();
      /*
      $mas_dynamic_data = $one_elem["mas_dyn_data"];
      if (sizeof($mas_dynamic_data) > 0)
        {
         $this->forming_db_properties_product($mas_dynamic_data,$mas_save["n_category"],$this->id_elm_create);
         //$this->obj_dynamic->save_dynamic_values($mas_dynamic_data,$mas_save["n_category"],$id_product_new);
         
        }
      */
      
     }
   
   function forming_db_query_edit_list()
     {
       
       $db_query="update ".DB_PREF."ishop_product set ";
       $delim="";
       foreach ($this->mas_struct_elm as $name_field => $mas_values)
         {
           $db_query.=$delim.$this->forming_one_field_set_query($name_field,$mas_values);
           $delim=",";
         }
       
       $db_query.=" where id_product IN (".implode(",",$this->mas_struct_id_elm).")";
       
       //обновляем в базе данных информацию о товарах
       db_work::query($db_query);
       
       //очищаем данные, чтобы не было дублирования данных
       $this->mas_struct_elm=[];
       $this->mas_struct_id_elm=[];
       
       return (true);
     }
   
   function forming_one_field_set_query($name_field,$mas_values)
     {
       //$name_field - имя поля в таблице,
       //$mas_values - массив содержащий элементы содержащие [id_product,new_value_field]
       $t="";
       
       $t.=" ".$name_field." = CASE \n";
       foreach ($mas_values as $one_value)
         {
           $t .= " WHEN id_product = ".$one_value[0]." THEN ". forming_db_set_value($one_value[1]) ." \n";
         }
       $t.=" ELSE ".$name_field." \n";
       $t.=" END \n";
       
       return ($t);
     }
   /*
   function _forming_db_add_list()
     {
       $mas_save = [];
       $first_part = "";
       $on_first = false;
       $list_values = "";
       if ($this->db_query_list_product == "")
         {
           $on_first = true;
           $first_part = "insert into ".DB_PREF."ishop_product (";
         }
       else
         {
           $list_values .= ",";
         }
       $list_values .= "(";
       $rez = "";
       foreach ($mas_save as $pole => $vpole)
         {
           if ($on_first) $first_part .= $rez.$pole;
           $list_values .= $rez.forming_db_set_value($vpole);
           $rez = ",";
         }
    
       $list_values .= ")";
       if ($on_first) $first_part .= ") values ";
    
       $this->db_query_list_product .= $first_part."\n".$list_values;
    
     }
   */
   function get_max_id_elm_create()
     {
      $db_query="select max(id_product) as max_num from ".DB_PREF."ishop_product ";
      list($kolvo,$data)=db_work::query_select_one_assoc($db_query);
      if ($kolvo == 1 && $data["max_num"] != "NULL") $this->id_elm_create=$data["max_num"];
      
     }
   /*
   function _forming_db_properties_product($mas_dynam,$n_category,$n_product)
     {
      $first_part="";
      //$on_first=false;
      $list_values="";
      $del="";
      
      if ($this->db_query_properties_product == "")
        {
         //$on_first=true;
         $first_part="insert into ".DB_PREF."ishop_data (id_data, n_product, n_category, n_properties, value_properties, type_propData) values ";
        }
       else
         {
          $del=",";
         }
      
      foreach ($mas_dynam as $one_data)
        {
         //if ($on_first) $first_part.=$del.$pole;
         $list_values.=$del."\n"."(0,".$n_product.",".$n_category.",".$one_data[0].",'".codeText($one_data[1])."','".codeText($one_data[2])."')";
         $del=",";
        }
      
      //if ($on_first) $first_part.=") values ";
      
      $this->db_query_properties_product.=$first_part . $list_values;
      
     }
   
   function _check_images($text_list_images)
     {
      global $masConfig;
      $dir_images_cms = $this->dir_images_cms;
      $dir_small_images = $this->dir_small_images;
      $dir_big_images = $this->dir_big_images;
      
      $dir_images_arhive = $this->dir_tmp. "/" . $this->name_dir_files;
      
      $mas_name_images = array();
      
      if ( $text_list_images )
         {
          
          $use_watermark = false;
          $file_img_watermark = "";
          if ( $masConfig["ON_USE_WM_IMG_ISHOP"] == 1 && $masConfig["FILE_WM_IMG_ISHOP"] && proverka_exp_img($masConfig["FILE_WM_IMG_ISHOP"]) )
            {
             $use_watermark = true;
             $file_img_watermark = $dir_images_cms.$masConfig["FILE_WM_IMG_ISHOP"];
             
            }
          
          $raz_images="";
          $mas_images = explode(";",$text_list_images);
          foreach ( $mas_images as $n => $name_one_image )
            {
              
              if ( $masConfig["QUANTITY_IMG_ISHOP"] > 0 && sizeof($mas_name_images) >= $masConfig["QUANTITY_IMG_ISHOP"] )
                {
                 //максимальное количество изображений достигнуто - выходим из цикла
                 break;
                }
              $path_one_image_arhive = $dir_images_arhive . "/".$name_one_image;
              
              if ( file_exists( $dir_images_arhive . "/".$name_one_image ) )
                {
                 $name_upload= $name_one_image;
                 //$exp=strtolower(substr($name_upload,-3,3));
                 //echo ($exp);
                 //$all_exp=array ("jpg","gif","png");
                 $exp=proverka_exp_img($name_upload);//фукнция проверяет расширение, в случае допустимого расширения возвращает его
                 // если расширение не допустимо, возвращает false
                 
                 
                 if (!$exp)
                   {
                    $error_code=1;$error_text="Не верный формат рисунка!";
                   }
                  else
                    {
                     //генерируем новое случайное имя рисунка
                     
                     //$newname = generator_name_img();
                     //$newname.=".".$exp;
                     
                     $newname = generator_name_file_unique_dir($dir_small_images,$exp);
                     
                     //echo ("  ".$newname);
                     
                     //$newname=$name_upload;
                     $on_add_image = false;
                     
                     
                     if ( $use_watermark )
                       {
                        
                        if ( 
                            transform_size_image_watermark($path_one_image_arhive,$dir_big_images.$newname,$file_img_watermark,MAX_WIDTH_ISHOP,MAX_HEIGHT_ISHOP,true,$masConfig["POSITION_X_WM_IMG_ISHOP"],$masConfig["POSITION_Y_WM_IMG_ISHOP"])
                            // && preob_img($path_one_image_arhive,$dir_small_images.$newname,MAX_WIDTH_ICON_ISHOP,MAX_HEIGHT_ICON_ISHOP) )
                            && 
                            //transform_size_image_watermark($path_one_image_arhive,$dir_small_images.$newname,$file_img_watermark,MAX_WIDTH_ICON_ISHOP,MAX_HEIGHT_ICON_ISHOP,false,$masConfig["POSITION_X_WM_IMG_ISHOP"],$masConfig["POSITION_Y_WM_IMG_ISHOP"]) )
                            transform_size_image($path_one_image_arhive,$dir_small_images.$newname,MAX_WIDTH_ICON_ISHOP,MAX_HEIGHT_ICON_ISHOP,false) )
                            $on_add_image = true;
                        
                       }
                      else
                        {
                         if ( 
                            transform_size_image($path_one_image_arhive,$dir_big_images.$newname,MAX_WIDTH_ISHOP,MAX_HEIGHT_ISHOP,true)
                            // && preob_img($path_one_image_arhive,$dir_small_images.$newname,MAX_WIDTH_ICON_ISHOP,MAX_HEIGHT_ICON_ISHOP) )
                            && transform_size_image($path_one_image_arhive,$dir_small_images.$newname,MAX_WIDTH_ICON_ISHOP,MAX_HEIGHT_ICON_ISHOP,false) )
                            $on_add_image = true;
                        }
                     
                     
                     if ( $on_add_image )
                       {
                        
                        //$url_img.=$raz_images.$newname;
                        //$raz_images="|";
                        $mas_name_images[]=$newname;
                        $save_images=true;
                        
                       }
                      else
                        {
                         $error_code=1;$error_text="Произошла ошибка при сохранении рисунка!";
                        }
                     
                    }
                }
            }
          
         }
      
      return ( $mas_name_images );
     }
   */
   function clear_cache()
     {
      global $masConfig;
      if ( $masConfig["ON_VIEW_QUANTITY_PRODUCT_CATEGORY"] == 1 )
        {
         $obj_ishop_cache_db = new class_ishop_cache_db();
         $obj_ishop_cache_db->set_obj_ishop_cache_category($this->obj_cache_category);
         $obj_ishop_cache_db->clear_all_cache_quantity_product();
        }
      
      updateSettings( array("ishop_cache_stats" => 0,"ishop_cache_category_mp" => 0, "ishop_cache_category_lb" => 0) );//меняем параметр кэша статистики
      
     }
   
  }

