<?php

/* Класс экспорта данных товаров для быстрого редактирования. Версия v24.2.1 */

class export_product_quick
  {
   private $error = 0;
   private $error_text = "no";
   
   private $dir_big_images = "";
   private $dir_small_images = "";
   private $dir_images_cms = "";
   
   private $dir_tmp = "";
   private $name_tmp_file = "";
   private $name_tmp_arhiv = "";
   private $name_dir_files = "";
   private $on_add_image = false;
   
   private $name_export_file = "product_edit_quick.csv";//файл будет в папке tmp
   private $dfile_export=false;
   private $kolvo_one_select = 30;
   private $kolvo_all_select = 0;
   private $kolvo_all_product = 0;
   
   private $csv_import = false;
   
   private $init_elem = array();
   private $num_elem_check = 0;
   private $kolvo_elem_error = 0;
   private $max_kolvo_elem_error = 100;
   private $error_text_list = array();
   private $last_num_elem_error = -1;
   
   private $dump_product = array();
   private $mas_data_dump = array();
   
   private $mas_category = array();
   private $mas_podcategory = array();
   private $mas_num_podcategory = array();
   private $mas_index_category = array();
   private $mas_index_num_podcategory = array();
   
   private $geo_data = array();
   
   private $index_listv = array();
   private $index_link_properties_cat = array();
   
   private $check_only_data_file = false;
   
   private $name_default_time_product = "Месяц";
   
   private $url_site = "";
   private $obj_ishop_cache_category=false;
   private $cache_series_mas_num_category = array();
   
   private $data_html = array();
   private $data_answer = "";
   
   private $obj_cache_category=false;
   
   function __construct()
     {
      $this->init_main_data();
     }
   
   function init_main_data()
     {
      $this->dir_big_images = DIR_LOADFILES_MODULS . "/ishop/bigfoto/";
      $this->dir_small_images = DIR_LOADFILES_MODULS . "/ishop/smallfoto/";
      $this->dir_images_cms = DIR_CMS."/images/";
      
      $this->dir_tmp = DIR_CMS."/tmp";
      global $url_site;
      $this->url_site = $url_site;
      //$this->obj_ishop_cache_category = new ishop_cache_category("ishop", DIR_CACHE_DATA);
      
      global $obj_ishop_cache_category;
      $this->obj_cache_category = $obj_ishop_cache_category;
     }
   /*
   function connectBaz()
     {
      $error_code = 0;
      $error_text = "no";
      
      global $dbhost,$dbuser,$dbpasswd,$dbname,$obj_db_connect;
      
      $this->dbcnx = @$obj_db_connect->connectBaz($dbhost,$dbuser,$dbpasswd,$dbname);
      if ( !$this->dbcnx )
        {
         $error_code=1;$error_text="Невозможно подключиться к базе данных!";
        }
      
      return ( array($error_code, $error_text) );
     }
   */
   function ini_data()
     {
      global $mas_time_product,$init_currency;
      
      $this->mas_type_product = array();
      $this->index_mas_type_product = array();
      /*
      foreach ( $this->mas_type_product as $key_type => $name_type )
        {
         $this->index_mas_type_product[$name_type] = $key_type;
        }
      */
      $this->mas_time_product = array();// $mas_time_product;
      $this->index_mas_time_product = array();
      /*
      foreach ( $this->mas_time_product as $key_time => $data_time )
        {
         $this->index_mas_time_product[$data_time["name"]] = $data_time["time"];
        }
      */
      //echo( implode(",",$this->mas_type_product) );
      
      
      $this->init_currency = $init_currency;
      $this->index_init_currency = array();
      /*
      foreach ( $this->init_currency as $key_init => $data_init )
        {
         $this->index_init_currency[$data_init[1]] = $key_init;
        }
      */
      $this->infoUserAgent = info_user_agent();
      global $obj_dynamic;
      $this->obj_dynamic = $obj_dynamic;
     }
   /*
   function ___select_category()
     {
      $this->mas_index_category = array();
      $this->mas_index_num_podcategory = array();
      
      $db_query="select * from ".DB_PREF."category where hide='show' and type='high' order by pos ";
      
      list($kol,$this->mas_category) = obr_db_query_select_assoc_index($db_query,"id_category");
      
      if ( $kol )
        {
         $mas_id = select_mas1lev_2level($this->mas_category,"id_category",false);
         
         $db_query="select * from ".DB_PREF."category where n_category IN (".implode(",",$mas_id).") and hide='show' and type='inferior' order by n_category,pos ";
         list($k,$this->mas_podcategory) = obr_db_query_select_assoc_index($db_query,"id_category");
         
        }
      
     }
   */
   function select_all_properties()
     {
      
      $db_query="select * from ".DB_PREF."ishop_properties ";
      list($kol, $this->mas_all_properties) = obr_db_query_select_assoc_index($db_query,"id_properties");
      
      $db_query="select * from ".DB_PREF."ishop_link_pc ";
      list($kol, $this->mas_link_pc) = obr_db_query_select_assoc_index_group($db_query,"num_category");
      
      $db_query="select * from ".DB_PREF."ishop_listv order by pos_value ASC, name_value ASC ";
      list($kol, $this->mas_all_listv) = obr_db_query_select_assoc_index($db_query,"id_value");
      
      
      
     }
   
   function count_product_db()
     {
      $db_query = "select count(*) from ".DB_PREF."ishop_product";
      $this->kolvo_all_product = obr_db_query_count( $db_query );
      
      $this->kolvo_all_select = ceil( $this->kolvo_all_product/$this->kolvo_one_select );
      
     }
   
   function serias_lvl_num_category($num_category)
     {
      $rez = false;
      if ( isset($this->cache_series_mas_num_category[$num_category]) )
        {
         $rez = $this->cache_series_mas_num_category[$num_category];
        }
       else
         {
          //$rez = search_series_num_lvl_category($this->mas_all_category,$num_category);
          $rez = $this->obj_ishop_cache_category->search_series_num_data($num_category);
          $this->cache_series_mas_num_category[$num_category] = $rez;
         }
      
      return ($rez);
     }
   
   function export_one_select($n)
     {
      
      $db_query = "select * from ".DB_PREF."ishop_product order by id_product ASC limit ".( $n * $this->kolvo_one_select )." , ".$this->kolvo_one_select;
      list($kolvo, $mas_data) = obr_db_query_select_assoc( $db_query );
      
      //var_dump($mas_data);
      /*
      $mas_add_param = array();
      $mas_num_product = select_mas1lev_2level($mas_data,"id_product",false);
      
      //var_dump( $mas_num_product );
      
      if ( sizeof($mas_num_product) )
        {
         
         $db_query = "select * from ".DB_PREF."ishop_data where n_product IN (".implode(",",$mas_num_product).") ";
         list($kolvo_add_param,$mas_add_param) = obr_db_query_select_assoc_index_group($db_query,"n_product");
         //var_dump( $mas_add_param );
        }
      */
      $mas_one_dump = array();
      $add_param = "";
      
      foreach ( $mas_data as $one_elem )
        {
         $mas_one_dump = array();
         $mas_one_dump = $this->export_one_elem( $one_elem );
         /*
         $add_param = "";
         
         if ( isset( $mas_add_param[$one_elem["id_product"]] ) )
           {
            $add_param = $this->export_add_param( $mas_add_param[$one_elem["id_product"]] );
           }
         */
         /*
         if ( $add_param && sizeof($add_param) > 0 )
           {
            $mas_one_dump = array_merge($mas_one_dump, $add_param);
           }
         */
         //$mas_one_dump[10] = $this->forming_one_value($add_param);
         //var_dump($mas_one_dump);
         $this->mas_data_dump[] = $mas_one_dump;
         
        }
      
      
     }
   
   function export_one_elem( $one_elem )
     {
      $mas_one_dump = array("","","", "","","", "");
      
      foreach ( $this->init_elem as $key_elem => $init_elem )
        {
         //$mas_one_dump[$init_elem[0]] = $this->replace_sim( $one_elem[$key_elem] );
         $mas_one_dump[$init_elem[0]] = $this->forming_one_value( $one_elem[$key_elem] );
        }
      
      //$mas_one_dump[11] = $this->forming_one_value(str_replace("|",";",$mas_one_dump[11]));//изображения
      $mas_one_dump[6]=($one_elem["on_request"] == "on"?"да":"нет");//под заказ
      //$mas_one_dump[13]=($one_elem["on_digital"] == "on"?"цифровой":"обычный");
      //$mas_one_dump[6] = $this->init_currency[$one_elem["currency"]][1];
      
      //$name_podcategory = "";
      /*
      $name_category = "";
      
      if ( $one_elem["n_category"] > 0 )//( && isset( $this->mas_podcategory[$one_elem["n_category"]] ) )
        {
         $mas_num_category = $this->obj_cache_category->search_series_num_data($one_elem["n_category"]);
         $mas_data_category = $this->obj_cache_category->get_data_mas_num($mas_num_category);
         $sep = "";
         foreach ($mas_data_category as $one_category)
           {
            $name_category .= $sep.$one_category["name"];
            $sep = "/";
            
           }
         
        }
      
      //$mas_one_dump["podcategory"] = $name_podcategory;
      $mas_one_dump[4] =$this->forming_one_value($name_category);
      */
      return ( $mas_one_dump );
     }
   /*
   function export_add_param( $mas_add_param )
     {
      $t_add_param = "";
      $mas_param = array();
      $sep = "";
      foreach ( $mas_add_param as $one_param )
        {
         if ( isset( $this->mas_all_properties[$one_param["n_properties"]] ) )
           {
            $one_properties = $this->mas_all_properties[$one_param["n_properties"]];
            $name_v = $one_properties["name_properties"];
            $value_v = false;
            //$v = $this->replace_sim_add_param( $one_param["value_properties"] );
            $v = $one_param["value_properties"];
            
            if ( $one_properties["type_properties"] == "list" || $one_properties["type_properties"] == "nested_list" 
                || $one_properties["type_properties"] == "list_checkbox" )
              {
               
               if ( isset($this->mas_all_listv[$v]) )
                 $value_v = $this->mas_all_listv[$v]["name_value"];
              }
             else
               {
                $value_v = $v;
               }
            
            if ($value_v)
              $value_v = $this->replace_sim_add_param( $value_v );
            
            if ( $name_v && $value_v !== false )
              {
               if ( $one_properties["type_properties"] == "list_checkbox" )
                 {
                  if ( isset( $mas_param[$name_v] ) )
                    $mas_param[$name_v] .= "|". $value_v;
                   else
                     $mas_param[$name_v] = $value_v;
                 }
                else
                  {
                   $mas_param[$name_v] = $value_v;
                  }
              }
            
           }
        }
      
      if ( sizeof( $mas_param ) )
        {
         $sep = "";
         foreach ( $mas_param as $key_param => $value_param )
           {
            $t_add_param .= $sep . $key_param ."=".$value_param;
            $sep = ";";
           }
        }
      
      return ( $t_add_param );
     }
   */
   function init_elem()
     {
      
      $this->init_elem = array(
        /*
         "name_pole" => array(
           номер ячейки в строчке,
           тип поля (text или numeric),
           обязательно ли должно быть поле - false или true,
           обязательно ли должно быть значение в поле - false или true,
           проверять или нет значение - false или value, listv, hablonrv, function,
           зависит от предыдущего параметра: "" или нужное значение,
           обработать функцией tr или false,
           значение по умолчанию или false
           название поля
           )
        */
        
        //0-id_product
        //1-Артикул
        //2-Наименование
        //3-Цена
        //4-Изначальная цена
        //5-Количество товара
        //6-Под заказ (да,нет)
        
        //-2-Краткое описание
        //-3-Полное описание
        //-4-Категория
        //-6-Валюта
        //-9-Ключевые слова
        //-10-Свойства*
        //-11-Изображения
        //-13-Тип товара (Цифровой/Обычный)
        
        "id_product" => array( 0, "numeric", true, true, false, "", false, 0, "ID товара" ),//int NOT NULL,
        "vendor_code" => array( 1, "text", true, false, false, "", false, "", "Артикул" ),
        "name_product" => array( 2, "text", true, true, false, "", false, false, "Наименование" ),
        "cost" => array( 3, "numeric", true, false, false, "", false, 0, "Стоимость" ),
        "first_cost" => array( 4, "numeric", true, false, false, "", false, 0, "Изначальная цена" ),
        "quantity_stock" => array( 5, "numeric", true, false, false, "", false, 0, "Количество товара" ),
        
        //-"short_text" => array( 2, "text", true, true, false, "", false, false, "Краткое описание" ),
        //-"all_text" => array( 3, "text", true, true, false, "", false, false, "Полное описание" ),
        
        //-"key_words" => array( 9, "text", true, false, false, "", false, false, "Ключевые слова" ),
        //-"image" => array( 11, "text", true, false, false, "", false, false, "Изображение" ),
        
        
        //*"currency" => array( "currency", "text", true, false, false, "", false, "руб.", "Валюта" ),//ENUM('rub','usd','uah','eur') NOT NULL default 'rub',
        //"num_user" => array( 10, "numeric", false, false, false, "", false, 0, "Номер пользователя" ),//int NOT NULL,
        
       );
      
      
     }
   
   function save_file_csv($type)
     {
      
      $t = "";
      
      if (!$this->dfile_export || $type == "begin")
        {
         $this->dfile_export=fopen($this->dir_tmp."/".$this->name_export_file,"w");
        }
      
      if ($type == "begin")
        {
         $t .= 'id товара;Артикул;Наименование;Цена;Изначальная цена;Количество товара;Под заказ'
          //.';Краткое описание;Полное описание;Категория;'
          //.';Ключевые слова;Свойства;Изображения;Тип товара'
          ."\n";
        }
       elseif ($type == "dump")
         {
          foreach ( $this->mas_data_dump as $one_product )
            {
             
             $sep="";
             foreach ( $one_product as $key => $value )
               {
                $t.=$sep.$value;
                $sep=";";
                
               }
             $t.="\n";
             
            }
          
          $this->mas_data_dump=array();
         }
       elseif ($type == "end")
         {
          
         }
      
      if ($t)
        {
          //file_put_contents($this->dir_tmp."/".$this->name_export_file,$t,$add?FILE_APPEND:0);
          fwrite($this->dfile_export, $t);
        }
      
      if ($type == "end")
        {
         fclose($this->dfile_export);
        }
      
     }
   
   function forming_one_value($v)
     {
      $vv=$v;
      
      if ($v && !is_numeric($v) && preg_match("/\r|\n|\"|\;|\,/",$v))
        {
         if (strpos($v,'"') !== false)
           $vv='"'. str_replace('"','""',$v) .'"';
          else
            $vv='"'.$v.'"';
        }
      
      return ($vv);
     }
   
   function replace_sim($text)
     {
      //&amp; (&), &lt; (<), &gt; (>), &apos; (') и &quot; (")
      $text = str_replace( array('&', '<', '>', "'", '"', '&nbsp;'), array('&amp;', '&lt;', '&gt;', '&apos;', '&quot;', '&#160;'), $text);
      return ( $text );
     }
   
   function replace_sim_add_param($text)
     {
      //&amp; (&), &lt; (<), &gt; (>), &apos; (') и &quot; (")
      $text = str_replace( array(';','|'), array('#smcln#','&#124;'), $text);
      //$text = $this->replace_sim($text);
      return ( $text );
     }
   
   function set_answer_data_html()
     {
      $this->data_html["title"] = "Экспорт товаров";
      $this->data_html["text_end"] = "<a href='./'>Перейти к стартовой странице</a>";
      
      
      $this->data_answer = 'Экспорт выполнен. Файл '.$this->name_export_file.' находится в каталоге сайта /tmp<br>'
       .'Также необходимо сделать копию рисунков находящихся в папке сайта /loadfiles/moduls/ishop/bigfoto';
      
     }
   
   function list_oper()
     {
      
      $answer = "";
      /*
      list($error_code, $error_text) = $this->connectBaz();
      if ( $error_code )
        {
         return(array($error_code,$error_text));
        }
      */
      $this->ini_data();
      
      //$this->select_category();
      $this->select_all_properties();
      
      $this->init_elem();
      
      $this->count_product_db();
      
      $this->save_file_csv("begin");
      
      for ( $n = 0; $n < $this->kolvo_all_select; $n++ )
        {
         
         $this->export_one_select($n);
         $this->save_file_csv("dump");
        }
      
      $this->save_file_csv("end");
      
      //$this->set_answer_data_html();
      
      return ( array(0,"no",$this->data_answer) );
     }
   
   function processing()
     {
      $error=0;
      $error_text="no";
      $answer = "";
      
      $d_mas = $this->list_oper();
      $error = $d_mas[0];
      $error_text = $d_mas[1];
      if ( isset($d_mas[2]) ) $answer = $d_mas[2];
      
      //write_html_answer($error,$error_text,$answer,$this->data_html);
      
      return (array($error,$error_text,array("name_file"=>$this->name_export_file)));
     }
   
  }


