
/* файл js */

var eng_basket = {
  
  dir_sr: dir_http+"/moduls/ishop/include/",
  obj_form: false,
  data_comb_basket: {},
  all_cost: 0,
  calc_cost: 0,
  sum_discount: 0,
  on_sum_discount: false,
  all_digital: false,
  quantity_basket_not: 0,
  quantity_basket_is: 0,
  quantity_basket_cost_not_v: 0,
  quantity_basket_on_request: 0,
  discount_type: "",
  discount_size: 0,
  min_sum: 0,
  on_min_sum: false,
  
  delivery_method: "",
  
  name_base_currency: "",
  
  on_view_bk_make_order: false,
  
  on_user_authorize: false,
  
  init_first: function ()
    {
      var this_obj=this;
      
      this.on_user_authorize=on_user_authorize_site;
      this.name_base_currency=name_base_currency;
      this.obj_form=engine_elm_html.get_obj_form("ishop_basket_products");
      
      if (!this.obj_form) return (false);
      
      this.init_param();
      /*
      var obj_btn_promocode=engine_elm_html.get_obj_pf(this.obj_form,"tbl_bsk_btn_promocode");
      if (obj_btn_promocode)
        {
          elmAddEventListener(obj_btn_promocode, "click", function ()
          {
            this_obj.action_check_promocode();
          })
        }
      */
    },
  
  init_param: function()
    {
      var param={};
      if (typeof(ishop_basket_param) != "undefined") param=ishop_basket_param;
      //wconsole("данные basket param",param);
      
      this.all_digital=param.all_digital || false;
      this.on_view_bk_make_order=param.on_view_bk_make_order || false;
      this.delivery_method=param.delivery_method || "";
      
      return (true);
    },
  
  control_pole_quantity: function (num_product,type)
    {
      if (!this.obj_form) return (false);
      //wconsole("control pole q: "+num_product + " " + type);
      var obj_pf=this.obj_form.elements["bsk_prd_quantity["+num_product+"]"];
      //wconsole(obj_pf);
      var max_quantity = obj_pf.getAttribute("data-max_quantity");
      //wconsole(max_quantity);
      if (!max_quantity) max_quantity=1;
      
      var v=obj_pf.value;
      //wconsole(v);
      v=this.check_value_quantity(v);
      
      if (type == "plus")
        {
          v++;
        }
       else if (type == "minus")
        {
          v--;
        }
      
      if (v == 0) v=1;
      if (v > max_quantity) v = max_quantity;
      
      obj_pf.value=v;
      
      this.send_data_calc();
      
      return (true);
    },
  
  check_value_quantity: function (v)
    {
      v = v.replace(/[^0-9.,]/g, "");
      v = v.replace(/,/g, ".");
      v = parseInt(v);
      if (v == "" || isNaN(v)) v = 0;
      v = Math.abs(v);
      return (roundv(v, 0));
    },
  
  send_data_calc: function ()
    {
      var this_obj=this;
      var mas_elms=this.get_elms_poles("bsk_prd_quantity[");
      //wconsole(mas_elms);
      if (mas_elms.length == 0) return (false);
      
      var name="",value=0,num_product=0;
      var post="type=calc";
      for (var i=0; i<mas_elms.length; i++)
        {
          name=mas_elms[i].getAttribute("name");
          value=mas_elms[i].value;
          //wconsole(name+"="+value);
          
          post+="&"+name+"="+encodeURIComponent(value);
          
        }
      post+="&"+eng_secrt_user_part.get_param_encode();
      //wconsole(post);
      var url=this.dir_sr+"basket_proc.php";
      loadHTTPjc(url,function(a,b){this_obj.obr_srv_send_data_calc(a,b);},post);
      
      return (true);
    },
  
  get_elms_poles: function (v_name)
    {
      //var obj_form = this.obj_form;
      var mas_elms = [];
      var mas_all = this.obj_form.getElementsByTagName("input");
      var elm_name = "";
      for (var i = 0; i < mas_all.length; i++)
        {
          elm_name = mas_all[i].getAttribute("name");
          if (elm_name && elm_name.indexOf(v_name) === 0)
            {
              mas_elms.push(mas_all[i]);
            }
        }
      return (mas_elms);
    },
  
  obr_srv_send_data_calc: function (answer,add_param)
    {
      
      var new_data=answer.data;
      
      this.set_param_basket(new_data);
      
      this.write_data_basket();
      
      return (true);
    },
  
  set_param_basket: function(new_data)
    {
      this.data_comb_basket = new_data.data_comb_basket;
      this.all_cost = new_data.all_cost;
      this.calc_cost = new_data.calc_cost;
      this.sum_discount = new_data.sum_discount;
      this.on_sum_discount = new_data.on_sum_discount;
      this.all_digital = new_data.all_digital;
      this.quantity_basket_not = new_data.quantity_basket_not;
      this.quantity_basket_is = new_data.quantity_basket_is;
      this.quantity_basket_cost_not_v = new_data.quantity_basket_cost_not_v;
      this.quantity_basket_on_request = new_data.quantity_basket_on_request;
      
      this.discount_type = new_data.discount_type;
      this.discount_size = new_data.discount_size;
      
      this.min_sum = new_data.min_sum;
      this.on_min_sum = new_data.on_min_sum;
      
      decode_mas(this.data_comb_basket);
      
      return (true);
    },
  
  write_data_basket: function()
    {
      //wconsole(this.data_comb_basket);
      var row={};
      for (var i=0; i<this.data_comb_basket.length; i++)
        {
          row=this.data_comb_basket[i];
          engine_elm_html.set_html("tbl_bsk_one_cost_"+row["num_product"],row["cost_quantity"] > 0 ? row["cost_quantity"] +" "+ this.name_base_currency : "- - -");
        }
      
      engine_elm_html.set_html("tbl_bsk_all_cost",this.all_cost);
      
      var t="";
      t+=(this.sum_discount > 0 ? (this.discount_type == "percent" ? this.discount_size +"% - ":"") + this.sum_discount : 0);
      engine_elm_html.set_html("tbl_bsk_sum_discount",t);
      engine_elm_html.set_html("tbl_bsk_calc_cost",this.calc_cost);
      
      var obj_info_min_sum=engine_elm_html.get_obj("tbl_bsk_block_info_min_sum");
      if (obj_info_min_sum)
        {
          obj_info_min_sum.style.display=(this.on_min_sum?"block":"none");
        }
      
      var obj_info_discount=engine_elm_html.get_obj("tbl_bsk_block_info_discount");
      if (obj_info_discount)
        obj_processing_block.set_style_obj(obj_info_discount,[["display",this.on_sum_discount ? "block":"none"]]);
      
      var obj_info_not=engine_elm_html.get_obj("tbl_bsk_info_not_product");
      if (obj_info_not && this.quantity_basket_not <= 0 )
        {
          obj_info_not.style.display="none";
        }
      
      var obj_info_cost_not_v=engine_elm_html.get_obj("tbl_bsk_info_cost_not_v");
      if (obj_info_cost_not_v && this.quantity_basket_cost_not_v <= 0 )
        {
          obj_info_cost_not_v.style.display="none";
        }
      
      var obj_info_on_request=engine_elm_html.get_obj("tbl_bsk_info_on_request");
      if (obj_info_on_request && this.quantity_basket_on_request <= 0 )
        {
          obj_info_on_request.style.display="none";
        }
      
      var obj_block_form_make=engine_elm_html.get_obj("bsk_block_form_make");
      var vdisplay=getElementStyle(obj_block_form_make,"display");
      
      if (obj_block_form_make && vdisplay != "block" && (this.quantity_basket_not <= 0 && this.quantity_basket_cost_not_v <= 0) )
        {
          obj_block_form_make.style.display="block";
        }
      
      return (true);
    },
  
  action_check_promocode: function()
    {
      
      var this_obj=this;
      var vpromocode=js_trim(this.obj_form.elements["tbl_bsk_promocde"].value);
      
      if (!vpromocode)
        {
          //alert ("Укажите промокод!");
          this.write_promocode_status(true,"Промокод не указан!");
          return (false);
        }
      
      var data={};
      data["type"]="add_promocode";
      data["vpromocode"]=vpromocode;
      eng_secrt_user_part.add_code_mas(data);
      var post = encode_assoc_mas_query_ajax(data);
      var url=this.dir_sr+"basket_proc.php";
      
      loadHTTPjc(url,function(a,b){ this_obj.obr_srv_query_check_promocode(a,b); },post);
      
      return (true);
    },
  
  obr_srv_query_check_promocode: function(answer,add_param)
    {
      //wconsole(answer);
      
      var status=answer.data.status;
      var status_text=decodeURIComponent(answer.data.status_text);
      
      var new_data=answer.data.all_data_basket;
      decode_mas(new_data);
      
      this.set_param_basket(new_data);
      
      this.write_data_basket();
      
      this.write_promocode_status(status==1 ? true:false,status_text);
      
    },
  
  write_promocode_status: function(on_view,text)
    {
      var obj_status=engine_elm_html.get_obj("tbl_bsk_promocode_status");
      
      engine_elm_html.set_html(obj_status,text);
      obj_status.style.display=(on_view?"block":"none");
      
      return (false);
    },
  
  action_delete_row: function(num_product)
    {
      
      var this_obj=this;
      var data={};
      data["type"]="delprod";
      data["num_product"]=num_product;
      eng_secrt_user_part.add_code_mas(data);
      
      var post = encode_assoc_mas_query_ajax(data);
      var url=this.dir_sr+"basket_proc.php";
      
      loadHTTPjc(url,function(a,b){ this_obj.obr_srv_query_delete_product(a,b); },post,{"num_product":num_product});
      
      return (true);
    },
  
  obr_srv_query_delete_product: function(answer,add_param)
    {
      //wconsole(answer);
      this.delete_one_row_table(add_param.num_product);
      
      var new_data=answer.data.all_data_basket;
      
      if (new_data.data_basket && new_data.data_basket.length > 0)
        {
          this.set_param_basket(new_data);
          this.write_data_basket();
          
          this.constr_bk_make_order();
        }
       else
        {
          this.hide_block_tbl_base();
        }
      
    },
  
  delete_one_row_table: function(num_product)
    {
      var obj_row=engine_elm_html.get_obj("tbl_bsk_one_item_"+num_product);
      obj_row.parentNode.removeChild(obj_row);
      
    },
  
  hide_block_tbl_base: function()
    {
      var obj_base=engine_elm_html.get_obj("block_basket_tbl_base");
      var obj_not_elm=engine_elm_html.get_obj("block_basket_not_elem");
      
      obj_base.style.display="none";
      obj_not_elm.style.display="block";
      
      return (true);
    },
  
  constr_bk_make_order: function()
    {
      //if (!this.on_view_bk_make_order) return (false);//*****
      
      var elm_wrap_delivery_method=engine_elm_html.get_obj("bsk_make_order_wrap_delivery_method");
      var obj_pf=false;
      if (elm_wrap_delivery_method)
        {
          elm_wrap_delivery_method.style.display=(this.all_digital?"none":"block");
          obj_pf=engine_elm_html.get_obj_pf("bsk_form_order","address_user");
          if (this.all_digital && obj_pf)
            obj_pf.value="";
          
        }
      
      var elm_wrap_address=engine_elm_html.get_obj("bsk_make_order_wrap_address");
      if (elm_wrap_address)
        {
          elm_wrap_address.style.display=(this.delivery_method == "pickup"?"none":"block");
          obj_pf=engine_elm_html.get_obj_pf("bsk_form_order","address_user");
          if (this.delivery_method == "pickup" && obj_pf)
            obj_pf.value="";
          
        }
      
      return (true);
    },
  
  /* Выбор способа доставки */
  
  action_delivery_method: function(type)
    {
      //wconsole("delivery -> "+type);
      this.set_delivery_method(type);
      
      return (true);
    },
  
  set_delivery_method: function(type)
    {
      var obj_pf=engine_elm_html.get_obj_pf("bsk_form_order","delivery_method");
      if (!obj_pf) return (false);
      obj_pf.value=type;
      this.delivery_method=type;
      
      var obj_delivery=engine_elm_html.get_obj("bsk_make_order_btn_delivery");
      var obj_pickup=engine_elm_html.get_obj("bsk_make_order_btn_pickup");
      
      var obj_bk_point_issue=engine_elm_html.get_obj("bsk_make_order_bk_point_issue");
      
      var cl_name="ishop_basket_btn_delivery_method_on";
      var v_hide=false;
      
      if (type=="delivery")
        {
          change_class_name.add(obj_delivery,cl_name);
          change_class_name.delete_cl(obj_pickup,cl_name);
          v_hide=true;
        }
       else
        {
          change_class_name.delete_cl(obj_delivery,cl_name);
          change_class_name.add(obj_pickup,cl_name);
          v_hide=false;
        }
      
      if (obj_bk_point_issue) obj_bk_point_issue.style.display=(v_hide ? "none":"block");
      
      this.constr_bk_make_order();
      
      return (true);
    },
  
  /* Оформление заказа */
  
  action_make_order: function()
    {
      //wconsole("action make order");
      var data_user=this.check_value_form_user();
      if (!data_user) return (false);
      this.check_values_form_order(data_user);
      
      return (false);
    },
  
  check_value_form_user: function()
    {
      var obj_form=engine_elm_html.get_obj_form("bsk_form_user");
      //wconsole(obj_form);
      var this_obj=this;
      
      var masInit=[
        ["name_user","name_user","text","text",true,true,"",false,"","","Напишите имя!",false,"имя пользователя"],
        ["email_user","email_user","text","text",true,true,"","function",check_data_email,"","Напишите E-mail!","Напишите правильно E-mail","E-mail"],
        ["phone_user","phone_user","text","text",true,true,"",false,"","","Напишите свой телефон!","Напишите правильно телефон","телефон"],
      /*
        ["address_user","address_user","text","text",true,this.all_digital ? false : (this.delivery_method == "pickup"?false:true),"",false,"","","Укажите адрес доставки товара!",false,"Адрес доставки"],//*** сделать проверку обязательно или нет должно быть указано значение
        ["comment_user","comment_user","text","text",true,false,"",false,"","",false,false,"Комментарий к заказу"],
        
        ["type_pay","type_pay","select","text",true,true,"0",false,"","","Выберите способ оплаты!",false,"способ оплаты"],
        ["on_rules_site","on_rules_site","checkbox","text",true,true,"",false,"","","Нужно согласиться с правилами сайта и с обработкой персональных данных!",false,"соглашение"],
        ["contr_code","contr_code","text","text",false,false,"",false,"","",false,false,"Контрольный код"],
      */
       ];
      
      
      var mas_d = processing_data_form(obj_form,masInit);
      
      if ( mas_d[0] ) return (false);//если обнаружена ошибка, то отменяем отправку данных
      var data_form = mas_d[1];
      
      //data_form["type"]="check_data_user";
      //data_form["delivery_method"]=this.delivery_method;
      //data_form["act_check_order"]="on";
      
      //wconsole("Данные пользователя",data_form);
      //Если пользователь не авторизован, то Email будет использоваться для входа на сайт, поэтому нужно будет его подтверждать
      //Если пользователь авторизован, то Email будет использоваться только в заказе
      if (!this.on_user_authorize && !obj_tool_check_active_email.exists_email_in_list_checked_active(data_form["email_user"]))
        {
          alert ("E-mail не подтвержден!");
          return (false);
        }
      
      /*
      var post=encode_assoc_mas_query_ajax(data_form);
      
      var url=this.dir_sr+"basket_proc.php";
      
      loadHTTPjc(url,function(a,b){ this_obj.obr_send_srv_check_user(a,b); },post);
      */
      return (data_form);
    },
  /*
  obr_send_srv_check_user: function(answer,add_param)
    {
      wconsole(answer);
      var data=answer.data;
      decode_mas(data);
      wconsole(data);
      
      
    },
  */
  check_values_form_order: function(data_user)
    {
      var obj_form=engine_elm_html.get_obj_form("bsk_form_order");
      //wconsole(obj_form);
      var this_obj=this;
      
      var masInit=[
        //["name_user","name_user","text","text",true,true,"",false,"","","Напишите имя и отчество!",false,"имя пользователя"],
        //["phone_user","phone_user","text","text",true,true,"",false,"","","Напишите свой телефон!","Напишите правильно телефон","телефон"],
        //["email_user","email_user","text","text",true,false,"",false,"","","Напишите E-mail!","Напишите правильно E-mail","E-mail"],
        ["address_user","address_user","text","text",true,this.all_digital ? false : (this.delivery_method == "pickup"?false:true),"",false,"","","Укажите адрес доставки товара!",false,"Адрес доставки"],//*** сделать проверку обязательно или нет должно быть указано значение
        ["comment_user","comment_user","text","text",true,false,"",false,"","",false,false,"Комментарий к заказу"],
        
        //["type_pay_2","type_pay","select","text",true,true,"0",false,"","","Выберите способ оплаты!",false,"способ оплаты"],
        ["type_pay","type_pay","radio","text",true,true,"0",false,"","","Выберите способ оплаты!",false,"способ оплаты"],
        //["on_rules_site","on_rules_site","checkbox","text",true,true,"",false,"","","Нужно согласиться с правилами сайта и с обработкой персональных данных!",false,"соглашение"],
        ["contr_code","contr_code","text","text",false,false,"",false,"","",false,false,"Контрольный код"],
       ];
      
      var mas_d = processing_data_form(obj_form,masInit);
      
      if ( mas_d[0] ) return (false);//если обнаружена ошибка, то отменяем отправку данных
      var data_form = mas_d[1];
      data_form["type"]="new_order";
      data_form["delivery_method"]=this.delivery_method;
      data_form["act_check_order"]="on";
      
      data_form=copy_elms_obj(data_form,data_user);
      //wconsole("Отправляемые данные",data_form);
      
      var post=encode_assoc_mas_query_ajax(data_form);
      
      var url=this.dir_sr+"basket_proc.php";
      
      loadHTTPjc(url,function(a,b){ this_obj.obr_send_srv_save_order(a,b); },post);
      
    },
  
  obr_send_srv_save_order: function(answer,add_param)
    {
      //wconsole(answer);
      var data=answer.data;
      decode_mas(data);
      //wconsole(data);
      
      var error_proc=data.error_proc;
      var status_text=data.status_text;
      decode_mas(status_text);
      
      if (data.error_proc == 1)
        {
          if (data.error_text_proc)
            alert (data.error_text_proc);
          
          if (data.error_mas_proc.length > 0)
            alert (data.error_mas_proc[0]);
          
          return (false);
        }
      
      var num_order=data.data_res.num_order;
      
      this.start_open_url(num_order);//*****
    },
  
  start_open_url: function(num_order)
    {
      
      var url=dir_http + "/myorders/addnum"+num_order+".html";
      document.location.href=url;
    },
  
  action_activation_email: function()
    {
      //wconsole("action_activation_email");
      
      var obj_form=engine_elm_html.get_obj_form("bsk_form_user");
      var obj_field=engine_elm_html.get_obj_pf("bsk_form_user","email_user");
      //wconsole(obj_field);
      var v_email=obj_field.value;
      //wconsole(v_email);
      
      if (!v_email)
        {
          alert ("Введите E-mail!");
          return (false);
        }
      
      if (!check_data_email(v_email))
        {
          alert ("Введите правильно E-mail!");
          return (false);
        }
      
      if (obj_tool_check_active_email.exists_email_in_list_checked_active(v_email))
        {
          alert ("E-mail уже подтвержден!");
          return (false);
        }
      
      obj_tool_check_active_email.action_check_data(v_email);
      
      return (true);
    }
  
};

add_function_start_on_domcontent(function(){ eng_basket.init_first(); })
